2002-03-09  Jason Rumney  <jasonr@gnu.org>

	* fileio.c (Fcopy_file) [WINDOWS_NT]: Ensure file is not
	read-only when setting modified time.

2002-03-08  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (move_it_vertically_backward): At the end of the
	function, when moving forward by lines, treat terminal frames
	specially.

	* keyboard.c (echo_char): Make sure to add a separator between
	keys even if echo_dash hasn't been called.

	* xdisp.c: Use new string macros.
	(update_echo_area): Pass number of bytes to message3 instead of
	number of chars.
	(set_message_1): Don't access a string's size_byte directly.
	(decode_mode_spec_coding): Use number of bytes of eoltype string
	instead number of chars.

	* lisp.h (SREF, SDATA, SCHARS, SBYTES, SMBP): New macros.

2002-03-08  Juanma Barranquero  <lektu@terra.es>

	* w32fns.c (Fx_display_color_cells): Force 24+ bit color depths to
	24-bit.

2002-03-06  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_draw_hollow_cursor): Draw same size as block cursor.

2002-03-06  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (echo_prompt, echo_char, echo_dash, echo_now)
	(cancel_echoing, echo_length, echo_truncate): Changed to
	work with new kboard definition.
	(echo_now): Use message3_nolog instead of message2_nolog.

	* alloc.c (mark_kboards): Mark echo_string.

	* keyboard.h (ECHOBUFSIZE): Removed.
	(struct kboard): Member echoptr removed, member echobuf renamed
	to echo_string.

	* xdisp.c (message_with_string): Use Fformat instead of doprnt and
	message3 instead of message2 to display the message using STRING's
	text properties.

2002-03-05  Andreas Schwab  <schwab@suse.de>

	* xdisp.c (hscroll_margin): Change to EMACS_INT.

2002-03-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* frame.c (default-frame-alist): Explain that setting it doesn't
	affect existing frames.

2002-03-05  Stefan Monnier  <monnier@cs.yale.edu>

	* indent.c (skip_invisible): Fix my brain fart.

	* dispnew.c (sit_for): Don't wait if executing a kbd macro.

2002-03-04  Stefan Monnier  <monnier@cs.yale.edu>

	* dosfns.c, dosfns.h, dispnew.c, dispextern.h, commands.h, charset.c,
	* alloc.c, abbrev.c, emacs.c, eval.c, keyboard.c, keyboard.h,
	* lisp.h, lread.c, sysdep.c, termcap.c, termchar.h, w32term.c,
	* window.c, xdisp.c, xselect.c, xterm.c: Change defvar_int definition
	and variables to use EMACS_INT instead of just int.

	* buffer.c (syms_of_buffer): Allow non-string `mode-name'.

2002-03-04  Eli Zaretskii  <eliz@is.elta.co.il>

	* sysdep.c (sys_subshell) [MSDOS]: If PWD is set in the
	environment, pass it down with corrected value.

2002-03-04  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* lread.c (read_filtered_event): Do not call start_hourglass
	before returning.

2002-03-04  Juanma Barranquero  <lektu@terra.es>

	* w32term.c (x_display_and_set_cursor): Fix typo.

2002-03-03  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Fmake_temp_name): Doc fix.

2002-03-03  Gary Wong  <gtw@gnu.org>

	* termcap.c [!emacs]: Replace ospeed for building standalone
	libtermcap, for binary compatibility.

	* tparam.c [!emacs]: Move #define of bcopy to after string.h.

2002-03-03  Richard M. Stallman  <rms@gnu.org>

	* xrdb.c (file_p): Rename arg `path' to `filename'.

	* abbrev.c (Fexpand_abbrev): Increment plist as use count
	only if it is an integer.

	* xfns.c (png_load): Set screen_gamma based on f->gamma.
	If png_get_sRGB gives an answer, call png_set_gamma
	using the default image gamma value.

	* lread.c (read1): When reading from a file, default string to
	multibyte only if it has some multibyte characters.

	* print.c (print_object): Output multibyte chars 128...255
	using \x even if ! print_escape_multibyte.

	* xdisp.c (display_mode_element): Move the places where
	bytepos, charpos, this, and lisp_string are set.
	Use lisp_string to set bytepos.

	* xdisp.c (redisplay_internal):
	Call clear_image_cache only if HAVE_WINDOW_SYSTEM.

	* xdisp.c (display_mode_element): Merge properties specified with
	:propertize onto those that come with the string.

2002-03-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* xdisp.c (syms_of_xdisp) <auto-hscroll-mode>: Renamed from
	automatic-hscrolling.  Users changed.
	<hscroll-margin>: Renamed from automatic-hscroll-margin.
	Users changed.
	<hscroll-step>: Renamed from automatic-hscroll-step.  Users changed.

2002-03-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* buffer.c (syms_of_buffer) <buffer-file-coding-system>: Doc fix.

2002-03-02  Kim F. Storm  <storm@cua.dk>

	* window.c (Fminibuffer_selected_window): New function.
	(syms_of_window): Defsubr it.

2002-03-01  Kim F. Storm  <storm@cua.dk>

	* window.h (struct window): New member phys_cursor_width.

	* window.c (make_window, replace_window): Init phys_cursor_width.

	* xterm.c (x_display_and_set_cursor): Blink box cursor using
	hollow box cursor.  Blink bar cursor using 1 pixel wide bar.

	* w32term.c (x_display_and_set_cursor): Blink box cursor using
	hollow box cursor.  Blink bar cursor using 1 pixel wide bar.

	* lisp.h (GCPRO6): New macro.

	* process.c (Fopen_network_stream): Use GCPRO6.

2002-03-01  Kim F. Storm  <storm@cua.dk>

	* process.c (Qconnect, Qfailed): New variables.
	(syms_of_process): Intern and staticpro them.
	(Fprocess_status): Document connect and failed return values.
	[NON_BLOCKING_CONNECT]: New conditional.
	(connect_wait_mask, num_pending_connects): New variables.
	(status_message): Convert Qfailed status.
	(Fopen_network_stream): Added support for non-blocking connect.
	New optional args: filter, sentinel, non_blocking.  Doc updated.
	[HAVE_GETADDRINFO, !HAVE_GETADDRINFO]:  Merged common code.
	(deactivate_process): Handle pending non-blocking connect.
	(wait_reading_process_input): Poll for status of non-blocking
	connects.  Exec sentinel directly when connect succeeds.
	(status_notify): Don't read process output if not yet connected.

2002-02-28  Kim F. Storm  <storm@cua.dk>

	* window.c: (minibuf_selected_window): Renamed from
	Vminibuf_selected_window.  Users changed.
	(syms_of_window): Staticpro it.

2002-02-26  Kim F. Storm  <storm@cua.dk>

	The following changes add a new Vminibuf_selected_window variable
	which is similar to Vminibuf_scroll_window, but which is only set
	on entry to the minibuffer (from a non-minibuffer window):

	* window.c: (Vminibuf_selected_window): New variable.
	(struct save_window_data): New member minibuf_selected_window.
	(Fset_window_configuration): Restore Vminibuf_selected_window.
	(Fcurrent_window_configuration): Save Vminibuf_selected_window.
	Set minibuf_scroll_window member to nil if minibuf_level is 0.
	(compare_window_configurations): Compare minibuf_selected_window.

	* window.h: (Vminibuf_selected_window): Declare extern.

	* minibuf.c (read_minibuf): Set Vminibuf_selected_window on first
	entry to minibuffer or on entry from a non-minibuffer window.

	* dispextern.h (CURRENT_MODE_LINE_FACE_ID_3): Compare with
	Vminibuf_selected_window instead of Vminibuf_scroll_window.

	* xdisp.c (init_iterator): Compare with Vminibuf_selected_window
	instead of Vminibuf_scroll_window when deciding in which window
	the region should be highlighted.  Consequently, the region remains
	highlighteded even when a completion buffer is also displayed.

2002-02-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* fileio.c (Fsubstitute_in_file_name): Fix the change from
	2002-02-08.

	* xselect.c (Qcompound_text_with_extensions): Renamed from
	Qcompound_text_no_extensions.
	(lisp_data_to_selection_data, syms_of_xselect): Use the new name.

2002-02-26  Juanma Barranquero  <lektu@terra.es>

	* w32proc.c (syms_of_ntproc): Doc fix.

2002-02-24  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* intervals.h: Include "dispextern.h" unconditionally.

2002-02-24  Jason Rumney  <jasonr@gnu.org>

	* Makefile.in (WINNT_SUPPORT) [WINDOWSNT]: Add w32-vars.elc
	and disp-table.elc.
	(lisp): Add emacs-lisp/backquote.elc.

2002-02-24  Kim F. Storm  <storm@cua.dk>

	* keymap.c (Flookup_key): Fixed problem in 2001-12-28 patch:
	The validation of the event type was too strict as it didn't
	allow string events; buffer names are used in bindings for
	menu-bar-select-buffer (see `menu-bar-update-buffers').

2002-02-23  Kim F. Storm  <storm@cua.dk>

	The following changes rework my patch of 2002-02-06 which
	added command remapping by entering the commands directly into
	the keymaps.  Now, command remapping uses an explicit `remap'
	prefix in the keymaps, i.e. [remap COMMAND].

	* keymap.c (Qremap, remap_command_vector): New variables.
	(is_command_symbol): Removed function.
	(Fdefine_key): No longer accept a symbol for KEY.
	Added validation of [remap COMMAND] argument for KEY.
	The DEF is no longer required to be a symbol when remapping a command.
	(Fremap_command): New function to remap command through keymaps.
	(Flookup_key): Perform command remapping initiated by
	Fremap_command directly for speed.
	(Fkey_binding): Use Fremap_command for command remapping.
	(where_is_internal): Handle new command remapping representation.
	(syms_of_keymap): Intern Qremap, initialize remap_command_vector,
	staticpro them.  Defsubr Fremap_command.

	* keymap.h (Fremap_command): Declare extern.
	(is_command_symbol): Remove extern.

	* keyboard.c (command_loop_1): Use Fremap_command for command
	remapping; now try command remapping for all symbols.

2002-02-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* coding.h (run_pre_post_conversion_on_str): Add prototype.

2002-02-23  Jason Rumney  <jasonr@gnu.org>

	* w32select.c (Fw32_set_clipboard_data): Run pre-write-conversion
	on the string before encoding it.
	(Fw32_get_clipboard_data): Run post-read-conversion on the string
	after decoding it.

	* w32fns.c (w32_wnd_proc) <WM_TIMER>: Fix last change.

2002-02-23  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* w32term.c (enter_timestamp): Remove unused static variable to
	prevent warning.

	* xterm.c (enter_timestamp): Put in #if 0 to prevent warning.

2002-02-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* w16select.c (Fw16_get_clipboard_data): Fix last change.

	* xselect.c (selection_data_to_lisp_data): Fix last change.

2002-02-22  Jason Rumney  <jasonr@gnu.org>

	* w32term.h (struct w32_output): New member menu_command_in_progress.

	* w32menu.c (menubar_selection_callback): Free the menu and
	clear the menu_command_in_progress flag.

	* w32fns.c (mouse_move_timer, mouse_button_timer): Initialize.
	(menu_free_timer): New variable.
	(MENU_FREE_ID, MENU_FREE_DELAY): New constants.
	(w32_wnd_proc) <WM_TIMER>: Handle menu_free_timer.
	<WM_EXITMENULOOP>: Delay before freeing menu.  Do nothing if a
	menu command is in progress.
	<WM_COMMAND>: Set the menu_command_in_progress flag.
	Kill any menu_free_timer that is running.

	* w32term.c (w32_text_out): Renamed from W32_TEXTOUT.
	Call ExtTextOutA rather than ExtTextOut.

2002-02-22  Eli Zaretskii  <eliz@gnu.org>

	* puresize.h (BASE_PURESIZE): Increase to 755000.

2002-02-22  Eli Zaretskii  <eliz@is.elta.co.il>

	* w16select.c (Fw16_set_clipboard_data): Run pre-write-conversion
	on the string before encoding it.
	(Fw16_get_clipboard_data): Run post-read-conversion on the string
	after decoding it.

2002-02-22  Eli Zaretskii  <eliz@is.elta.co.il>

	Support for ICCCM  Extended Segments in X selections:

	* xselect.c <Qcompound_text_no_extensions>: New variable.
	(syms_of_xselect): Intern and staticpro it.
	(selection_data_to_lisp_data): Run post-read-conversion on decoded
	selection text.
	(lisp_data_to_selection_data): If next-selection-coding-system is
	compound-text-no-extensions, set the type of selection to be
	compound-text.

	* xterm.h (x_encode_text): Update prototype.

	* xfns.c (x_encode_text): Accept additional arg SELECTIONP; all
	callers changed.  If SELECTIONP is non-zero, run the
	pre-write-conversion function before encoding the selection text.

2002-02-21  Kim F. Storm  <storm@cua.dk>

	* frame.c (syms_of_frame): Change mouse-highlight default to t.

	* keyboard.c (kbd_buffer_get_event) [WINDOWSNT]:
	Correct composing of language-change event.

2002-02-20  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (menu_bar_items): Don't include keymap or local-map
	bindings at PT when building menu (the menu is not updated often
	enough for this to work reliable).
	(tool_bar_items): Likewise.
	(current_active_maps): Removed unused (and buggy) function.

2002-02-20  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xfns.c (gif_load): Use correct width and height for GIF images.

2002-02-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* floatfns.c (Fatan): Accept an optional second arg and call
	atan2 if passed 2 args.

2002-02-18  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (glyph_rect): Determine the row and glyph more precisely.

2002-02-17  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_autoselect_window_p): New variable.
	(syms_of_w32term): DEFVAR_BOOL and initialize it.
	(note_mouse_movement): Use it.

	* w32fns.c (w32_load_system_font): Never set fonts_changed_p to zero.

	* w32bdf.c (w32_load_bdf_font): Maybe set fonts_changed_p.

	* w32fns.c (Qfullscreen, Qfullwidth, Qfullheight, Qfullboth):
	New variables.
	(syms_of_w32fns): Intern and staticpro them.
	(x_frame_parms) <"fullscreen">: New parameter.
	(x_fullscreen_move, x_set_fullscreen): New functions.
	(x_set_frame_parameters): Support Qfullscreen.
	(x_real_positions): Save x/y_pixels_diff frame params.
	(x_figure_window_size): Support full-screen frames.
	(Fx_create_frame): Default the fullscreen parameter.

	* w32term.c (x_check_fullscreen, x_check_fullscreen_move)
	(x_fullscreen_adjust): New functions.
	(w32_read_socket) <WM_WINDOWPOSCHANGED>:  Don't	resize to
	fullscreen.  Call x_check_fullscreen_move, and set the
	want_fullscreen member of output_data.w32
	<WM_ACTIVATE, WM_ACTIVATEAPP>: Call x_check_fullscreen.

	* w32term.h: New enum for FULLSCREEN_* constants.
	(struct w32_output): New members want_fullscreen, x_pixels_diff,
	y_pixels_diff, x_pixels_outer_diff, and y_pixels_outer_diff.
	(x-fullscreen-adjust): New prototype.

2002-02-17  Kim F. Storm  <storm@cua.dk>

	* frame.c: (Vmouse_highlight): New variable.
	(syms_of_frame): DEFVAR_LISP it.

	* frame.h: (Vmouse_highlight): Declare extern.

	* xterm.h (struct x_display_info): Add mouse_face_hidden.

	* xterm.c (disable_mouse_highlight): Removed variable.
	(note_mouse_highlight): Don't highlight if Vmouse_highlight is nil.
	(show_mouse_face): Don't show highlight if mouse_face_hidden is	set.
	(XTread_socket): Turn mouse_face_hidden off after mouse movement,
	and on after keyboard input.
	(x_term_init): Initialize mouse_face_hidden.

	* msdos.h (struct display_info): Add mouse_face_hidden.

	* msdos.c (disable_mouse_highlight): Removed variable.
	(show_mouse_face): Don't show highlight if mouse_face_hidden is	set.
	(IT_note_mouse_highlight): Don't highlight if Vmouse_highlight is nil.
	(internal_terminal_init): Initialize mouse_face_hidden.
	(dos_rawgetc): Turn mouse_face_hidden off after mouse movement,
	and on after keyboard input.

	* w32term.h (struct w32_display_info): Add mouse_face_hidden.

	* w32term.c (disable_mouse_highlight): Removed variable.
	(note_mouse_highlight): Disable highlight if Vmouse_highlight is nil.
	(show_mouse_face): Don't show highlight if mouse_face_hidden is	set.
	(w32_read_socket): Turn mouse_face_hidden off after mouse movement,
	and on after keyboard input.
	(w32_initialize_display_info): Initialize mouse_face_hidden.

2002-02-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (last_mouse_window): New variable.
	(dos_rawgetc): Fix last change--if the mouse is in the same window
	as recorded in last_mouse_window, don't select this window.

	* Makefile.in (lisp, shortlisp): Use cus-start.elc, not cus-start.el.

	* msdos.c (x_autoselect_window_p): New variable.
	(syms_of_msdos): Defvar it.
	(dos_rawgetc): If x_autoselect_window_p is set, select the window
	in which the last mouse movement occured, unless it is already
	selected.

	* xdisp.c (automatic_hscroll_margin, Vautomatic_hscroll_step):
	New variables.
	(syms_of_xdisp): DEVFAR them.
	(hscroll_window_tree): Use automatic_hscroll_margin and
	Vautomatic_hscroll_step to compute the amount of window scrolling.

2002-02-16  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xterm.c (x-autoselect-window): New variable.
	(note_mouse_movement): Use it.

	* keyboard.c: Do not include "systime.h" twice.

2002-02-15  Andreas Schwab  <schwab@suse.de>

	* puresize.h (BASE_PURESIZE): Increase to 9/5.

	* alloc.c (NSTATICS): Increase to 1280.

2002-02-15  Kai Gro,A_(Bjohann  <Kai.Grossjohann@CS.Uni-Dortmund.DE>

	* alloc.c (NSTATICS): Bump to 1026.

	* xterm.c (Vx_alt_keysym, Vx_hyper_keysym, Vx_meta_keysym)
	(Vx_super_keysym): New variables.
	(syms_of_xterm): DEFVAR_LISP them.
	(x_x_to_emacs_modifiers, x_emacs_to_x_modifiers): Use the
	variables to determine which keys to use for the various modifiers.

2002-02-13  Kim F. Storm  <storm@cua.dk>

	* window.c: (Vmode_line_in_non_selected_windows): Removed.
	(mode_line_in_non_selected_windows): New variable.
	(syms_of_window): DEFVAR_BOOL it.

	* dispextern.h (CURRENT_MODE_LINE_FACE_ID_3):
	Use mode_line_in_non_selected_windows.
	(mode_line_in_non_selected_windows): Declare extern.
	(Vmode_line_in_non_selected_windows): Removed extern.

2002-02-13  Richard M. Stallman  <rms@gnu.org>

	* keyboard.c (Fthis_command_keys, Fthis_command_keys_vector)
	(Fthis_single_command_keys, Fthis_single_command_raw_keys)
	(Fclear_this_command_keys): Doc fixes.

	* xfaces.c (Finternal_make_lisp_face, Finternal_copy_lisp_face)
	(update_face_from_frame_parameter): Increment face_change_count
	and windows_or_buffers_changed to force redisplay using changed faces.

	* xdisp.c (QCpropertize): New variable.
	(mode_line_proptrans_alist): New variable.
	(display_mode_element): New arg PROPS; all calls changed.
	Implement this, for strings.
	Handle literal output of strings by sharing the
	main-line code for strings, using local var `literal'.
	Handle :propertize feature.
	(syms_of_xdisp): Initialze and staticpro QCpropertize and
	mode_line_proptrans_alist.

2002-02-11  Kim F. Storm  <storm@cua.dk>

	* window.c: (Vmode_line_in_non_selected_windows): New variable.
	(syms_of_window): DEFVAR_LISP it.

	* dispextern.h (CURRENT_MODE_LINE_FACE_ID_3): New macro.
	(CURRENT_MODE_LINE_FACE_ID): Use it.
	(Vmode_line_in_non_selected_windows): Declare extern.

	* xdisp.c (display_mode_lines): Use CURRENT_MODE_LINE_FACE_ID_3
	to get mode line face.

2002-02-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (Vx_bitmap_file_path, x_stretch_cursor_p): Remove these
	variables; cus-start.el doesn't need them anymore.

2002-02-09  Kim F. Storm  <storm@cua.dk>

	* insdel.c (make_gap_smaller): Preserve BEG_UNCHANGED during gap
	reduction.  This fixes a display problem where stray newlines were
	inserted in the window (corrected by C-l).  Clarified code (IMHO).

2002-02-09  Eli Zaretskii  <eliz@is.elta.co.il>

	* dispextern.h (CURRENT_MODE_LINE_FACE_ID): Fix last change.

	* xdisp.c (display_mode_lines): Fix last change.

2002-02-09  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (enum_font_cb2): Don't let charsets unknown to Windows
	match each other.
	(w32_load_system_font): Prevent Cleartype fonts from loading.
	(Fx_show_tip): Ensure tip frames are above other topmost windows.

2002-02-09  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (CURRENT_MODE_LINE_FACE_ID): New macro.
	(CURRENT_MODE_LINE_HEIGHT): Use it.
	(enum face_id): Add MODE_LINE_INACTIVE_FACE_ID.

	* xdisp.c (window_box_height): Use CURRENT_MODE_LINE_FACE_ID.
	(pos_visible_p, handle_face_prop): Likewise.
	(display_mode_lines): Likewise, but for the real selected window.
	(init_iterator) [row == NULL]: Handle MODE_LINE_INACTIVE_FACE_ID.

	* xfaces.c (Qmode_line_inactive): New face variable for mode-line
	in non-selected windows.
	(realize_basic_faces): Realize it.
	(syms_of_term): Intern and staticpro it.

2002-02-08  Kim F. Storm  <storm@cua.dk>

	* alloc.c (SETJMP_WILL_LIKELY_WORK, SETJMP_WILL_NOT_WORK):
	Changed mail addresses to emacs-devel@gnu.org.

2002-02-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* fileio.c (Fsubstitute_in_file_name): If the file name includes
	~user, and there's no such user, don't discard everything before ~user.

	* floatfns.c (Fround): Doc fix.

2002-02-08  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* sysdep.c (init_system_name): Put unused variable `p' in #if 0.

2002-02-07  Stefan Monnier  <monnier@cs.yale.edu>

	* lisp.h (Fx_file_dialog): Add extern decl (used in fileio.c).

2002-02-07  Kim F. Storm  <storm@cua.dk>

	* keymap.c (where_is_internal): Only check whether definition is
	remapped if it fulfills is_command_symbol.

2002-02-07  Andreas Schwab  <schwab@suse.de>

	* s/gnu-linux.h (GC_LISP_OBJECT_ALIGNMENT): Define to 2 for m68k.

	* alloc.c (mark_stack): Don't assume sizeof (Lisp_Object) is 4.

2002-02-06  Kim F. Storm  <storm@cua.dk>

	* keymap.c (Fdefine_key): Allow symbol as KEY argument for
	defining command remapping.  Doc updated.
	(Flookup_key): Remap command through keymap if KEY is a symbol.
	(is_command_symbol): New function.
	(Fkey_binding): Use it.  New optional argument NO-REMAP.
	Doc updated.  Callers changed.  Perform command remapping via
	recursive call unless that arg is non-nil.
	(where_is_internal): New argument no_remap.  Callers changed.
	Call recursively to find original key bindings for a remapped
	comand unless that arg is non-nil.
	(Fwhere_is_internal): New optional argument NO-REMAP.
	Doc updated.  Callers changed.  Pass arg to where_is_internal.

	* keymap.h (Fkey_binding, Fwhere_is_internal): Update prototype.
	(is_command_symbol): Added prototype.

	* keyboard.c (Vthis_original_command): New variable.
	(syms_of_keyboard): DEFVAR_LISP it.
	(command_loop_1): Set it, and perform command remapping.

2002-02-06  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* keyboard.c (recursive_edit_1): Call cancel_hourglass unconditionally.

2002-02-06  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_native_per_char_metric): Disable 2002-01-20 change.

2002-02-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* charset.c (get_charset_id): Use if-else instead of ?:.

2002-02-06  Richard M. Stallman  <rms@gnu.org>

	* filelock.c (S_ISLNK): Define if not defined.

2002-02-03  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Fdo_auto_save): Improve "auto save disabled" msg.

	* lread.c (read1): Redesign strategy for force_multibyte and
	force_singlebyte.  Now is_multibyte records whether read_buffer
	is multibyte.  Encountering any multibyte character makes it so.

2002-02-02  Stefan Monnier  <monnier@cs.yale.edu>

	* term.c (term_get_fkeys_1): If `k0' and `k;' are both specified and
	with the same sequence, map that sequence to f10 rather than f0.

2002-02-03  Andreas Schwab  <schwab@suse.de>

	* s/gnu-linux.h: Check for __mc68000__ instead of __m68k__, the
	latter never being defined on GNU/Linux.

2002-02-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* xfaces.c (realize_default_face): Don't set the weight and slant
	of the default face to Qnormal, unless these attributes are
	unspecified.

2002-02-02  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* keyboard.c (command_loop_1) [HAVE_X_WINDOWS]:
	Call cancel_hourglass unconditionally.

	* eval.c (Fsignal): Remove duplicated declaration of
	the variable `display_hourglass_p'.

2002-01-31  Richard M. Stallman  <rms@gnu.org>

	* editfns.c (region_limit): Nicer error message.

	* coding.c (decode_composition_emacs_mule):
	Give up if NCOMPONENT gets too large to index `component'.

	* callint.c (check_mark): New arg to specify clearer error message.
	Callers changed.

2002-01-27  Richard M. Stallman  <rms@gnu.org>

	* minibuf.c (Fcompleting_read): Doc fix.

2002-01-27  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* minibuf.c (Fread_from_minibuffer, Fread_command, Fread_function)
	(Fread_variable, Fread_buffer, minibuffer-completion-confirm):
	Fix doc-strings.

2002-01-26  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (syms_of_buffer): Doc fixes for scroll-...-aggressively.

	* xdisp.c (try_scrolling): Exchange uses of scroll_down_aggressively
	and scroll_up_aggressively.

2002-01-26  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* keyboard.c (parse_tool_bar_item): Remove duplicated prototypes.

2002-01-25  Stefan Monnier  <monnier@cs.yale.edu>

	* textprop.c (Fnext_property_change, Fnext_single_property_change)
	(Fprevious_property_change, Fprevious_single_property_change):
	Stay within the narrowed-buffer boundaries.

2002-01-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* term.c (Ftty_display_color_cells): New function.
	(syms_of_term): Defsubr it.
	(Ftty_display_color_cells, Ftty_display_color_p): Change the
	argument name to DISPLAY.  Doc fix.

	* dispextern.h: Add prototype for set_tty_color_mode and
	tty_setup_colors.

2002-01-24  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_scroll_run): Use ScrollWindowEx in place of BitBlt.
	If region left to draw is not what was expected, mark the frame as
	garbaged.

	* w32fns.c (w32_wnd_proc) <WM_PAINT>: Initialize update_rect.
	Combine the regions returned by BeginPaint and GetUpdateRect.

2002-01-23  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_update_window_begin): Only hide caret if
	w32_use_visible_system_caret is set.
	(x_update_window_end): Only show caret if
	w32_use_visible_system_caret is set.
	(syms_of_w32term): Handle SystemParametersInfo call failing.

	* w32fns.c (syms_of_w32fns): Initialize w32_visible_system_caret_hwnd.

2002-01-22  Richard M. Stallman  <rms@gnu.org>

	* unexelf.c (unexec): Define n so as to cause compilation error
	for the code where people have often written n instead of nn.

	* .gdbinit (hookpost-run): Defined.

2002-01-22  Jan D.  <Jan.Djarv@mbox200.swipnet.se>

	* xfns.c (x_set_frame_parameters): Typo in previous fix corrected.

2002-01-21  Jan D.  <Jan.Djarv@mbox200.swipnet.se>

	* xfns.c (x_set_frame_parameters): Just call x_fullscreen_adjust
	if fullscreen is being set.

2002-01-21  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* minibuf.c (Fminibuffer_contents)
	(Fminibuffer_contents_no_properties, Fread_from_minibuffer)
	(Fread_string, Fread_no_blanks_input, Fcompleting_read): Doc fixes.

2002-01-21  Richard M. Stallman  <rms@gnu.org>

	* window.c (check_frame_size): Fix minimum height calculation.

2002-01-20  Ken Raeburn  <raeburn@gnu.org>

	* dispextern.h (WINDOW_WANTS_MODELINE_P): Use XFASTINT on window
	height before comparison.
	(WINDOW_WANTS_HEADER_LINE_P): Likewise.

2002-01-20  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_system_caret_width): Remove.
	(w32_use_visible_system_caret): New user flag.
	(syms_of_w32term): DEFVAR_BOOL it.  Initialize based on whether
	Windows reports a screen reader running.
	(x_update_window_begin): Hide the system caret.
	(x_update_window_end): Show the system caret.
	(x_display_and_set_cursor): Don't draw a cursor when
	w32_use_visible_system_caret is set.  Do not adjust width.

	* w32fns.c (w32_visible_system_caret_hwnd): New static variable.
	(w32_wnd_proc) <WM_KILL_FOCUS, WM_EMACS_DESTROY_CARET>: Set it.
	<WM_EMACS_TRACK_CARET>: Arrange for system caret to be visible if
	the user requests it.  Use system default width when creating.
	<WM_EMACS_HIDE_CARET, WM_EMACS_SHOW_CARET>: Handle new messages.

	* w32term.h (WM_EMACS_SHOW_CARET, WM_EMACS_HIDE_CARET):
	New window messages.

2002-01-20  Richard M. Stallman  <rms@gnu.org>

	* window.c (MIN_SAFE_WINDOW_HEIGHT): Value now 1.

2002-01-20  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* doprnt.c (doprnt1): Fix typos in error call.

2002-01-20  Eli Zaretskii  <eliz@is.elta.co.il>

	* unexelf.c (unexec) [__sgi]: Support the .got sections.

2002-01-20  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_native_per_char_metric): Don't trust the metrics
	that Windows returns.  If a double check fails, try to guess how
	ExtTextOut is going to act.

	* w32fns.c (w32_load_system_font, w32_to_x_charset): Use strnicmp
	in place of stricmp.
	(w32_list_synthesized_fonts): Removed.
	(w32_to_all_x_charsets, enum_font_maybe_add_to_list): New functions.
	(struct enumfont_t): New element; list.
	(enum_font_cb2): List all style and charset variations of a font.
	(Fw32_select_font): New optional argument; include_proportional.
	Exclude vertical fonts.  Exclude proportional fonts unless
	include_proportional is non-nil.
	(w32_enable_synthesized_fonts): Change to a boolean.
	(Fw32_send_sys_command): Doc fix.

2002-01-19  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* dispnew.c (update_frame): Move the variable `tem' to the block
	where it is used.

2002-01-19  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fx_create_frame): Bind redisplay-dont-pause around
	call to face-set-after-frame-default.

2002-01-18  Richard M. Stallman  <rms@gnu.org>

	* dispextern.h (WINDOW_WANTS_MODELINE_P): Check window height > 1.
	(WINDOW_WANTS_HEADER_LINE_P): Check window height provides room.

2002-01-17  Richard M. Stallman  <rms@gnu.org>

	* window.c (enlarge_window): When exceeding size of parent,
	directly delete all the siblings instead of trying to resize it.

2002-01-17  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* term.c (set_tty_color_mode): Remove unused variable `tem'.

2002-01-16  Henrik Enberg  <henrik@enberg.org>

	* lread.c (init_lread): Move the installed-lisp dirs later in the path.

2002-01-16  Kim F. Storm  <storm@cua.dk>

	* xterm.c (x_erase_phys_cursor): Don't erase cursor if cursor row
	is invisible.  This can happen if cursor is on top line of a
	window, and we switch to a buffer with a header line.

	* w32term.c (x_erase_phys_cursor): Ditto.

2002-01-16  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xterm.c (XTread_socket) [!USE_X_TOOLKIT]: Compute the value of
	`dont_resize' only when used.

	* xdisp.c: Remove forgotten extern declaration of `Qimage'.

2002-01-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* xdisp.c (display_mode_element): When computing charpos, depend
	on multibyteness of elt, not the text in field.

2002-01-15  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* buffer.c (Fkill_all_local_variables):
	Increment `update_mode_lines' only once.

2002-01-14  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* lisp.h (adjust_after_replace_noundo)
	(Fupdate_coding_systems_internal): Add prototypes.

	* sound.c (Fplay_sound): Initialize header_size also for :data case.

2002-01-14  Eli Zaretskii  <eliz@is.elta.co.il>

	Support for the --color command-line argument and tty-color-mode
	frame parameter:

	* term.c (tty_default_color_capabilities, tty_setup_colors)
	(set_tty_color_mode): New functions.
	(term_init): Call tty_default_color_capabilities.
	(Qtty_color_mode_alist): New variable.
	(syms_of_term): Intern and staticpro it.

	* frame.c (store_frame_param): Call set_tty_color_mode for termcap
	frames.
	(do_switch_frame): For termcap frames, switch the tty
	color mode as specified by the frame's parameters.
	(Qtty_color_mode): New variable.
	(syms_of_frame): Intern and staticpro it.

	* emacs.c (USAGE2): Add the --color option.
	(standard_args): Ditto.

2002-01-13  Jan Djarv  <Jan.Djarv@mbox200.swipnet.se>

	* xterm.h (struct x_output): New members want_fullscreen,
	x_pixels_diff, y_pixels_diff, x_pixels_outer_diff, and
	y_pixels_outer_diff.
	New enum for FULLSCREEN_* constants.
	(FRAME_OUTER_WINDOW): Handle the case where output_data.x->widget
	is NULL.
	(x_fullscreen_adjust): Add prototype.

	* emacs.c (USAGE2): Add the new full-screen arguments.
	(standard_args): Ditto.

	* xfns.c (Qfullscreen, Qfullwidth, Qfullheight, Qfullboth):
	New variables.
	(syms_of_xfns): Intern and staticpro them.
	(x_frame_parms) <"fullscreen">: New parameter.
	(x_fullscreen_move, x_set_fullscreen): New functions.
	(x_set_frame_parameters): Support for Qfullscreen.
	(x_real_positions): More accurate computation of the frame position.
	(x_figure_window_size): Support full-screen frames.
	(Fx_create_frame): Default the fullscreen parameter.

	* xterm.c (x_check_fullscreen, x_fullscreen_adjust): New functions.
	(XTread_socket) <Expose>: Call x_check_fullscreen.
	<ConfigureNotify>: Don't resize to fullscreen.
	Call x_check_fullscreen_move, and set the want_fullscreen member of
	output_data.x.

2002-01-13  Jason Rumney  <jasonr@gnu.org>

	* w32term.h (WM_XBUTTONDOWN, WM_XBUTTONUP): New window messages
	for mice with more than 3 buttons.

	* w32term.c (parse_button): New parameter xbutton.  Callers changed.
	(w32_read_socket): Handle new "XBUTTON" messages.

	* w32fns.c (w32_pass_extra_mouse_buttons_to_system): New user option.
	(syms_of_w32fns): DEFVAR_BOOL it.
	(w32_wnd_proc): Handle new "XBUTTON" messages.

2002-01-13  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* keyboard.c (read_key_sequence): Remove unused variable `extra_maps'.

2002-01-13  Andreas Schwab  <schwab@suse.de>

	* xterm.c (x_load_font): Never set fonts_changed_p to zero.

2002-01-12  Andreas Schwab  <schwab@suse.de>

	* .gdbinit (xbuffer): Remove address operator since data is now a
	pointer.

2002-01-11  Richard M. Stallman  <rms@gnu.org>

	* insdel.c (adjust_after_replace_noundo): New function.

	* coding.c (code_convert_region): Don't copy old text if undo disabled.

2002-01-09  Jason Rumney  <jasonr@gnu.org>

	* xdisp.c (x_consider_frame_title): Don't count the tooltip frame
	when checking for multiple frames.

2002-01-08  Richard M. Stallman  <rms@gnu.org>

	* window.c (delete_window): Rewrite the code for changing the
	selected window to handle the case where WINDOW is not a leaf.

2002-01-07  Eli Zaretskii  <eliz@is.elta.co.il>

	* process.c (send_process): Set src_multibyte to 1 after the call
	top setup_coding_system, not before the call.

2002-01-07  Jason Rumney  <jasonr@gnu.org>

	* xmenu.c (set_frame_menubar, xmenu_show):
	(xdialog_show):	Initialize wv->help to Qnil.

	* w32menu.c (single_submenu, set_frame_menubar, w32_menu_show):
	(w32_dialog_show): Initialize wv->help to Qnil.

2002-01-06  Jason Rumney  <jasonr@gnu.org>

	* xmenu.c (single_submenu): Initialize wv->help to Qnil.

	* w32menu.c (w32_menu_display_help): Revert last change.

	* xmenu.c (menu_highlight_callback): Revert last change.

2002-01-06  Andreas Schwab  <schwab@suse.de>

	* insdel.c (make_gap_larger): Make sure buffer size does not
	overflow range of int.

2002-01-05  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_draw_glyphs): Don't call notice_overwritten_cursor if
	OVERLAPS_P.

	* w32menu.c (w32_menu_display_help): Hide any tooltip window.

	* w32fns.c (compute_tip_xy): If tooltip won't fit on the screen
	to the left or to the right of the pointer, put it against
	the left screen edge.
	(x_frame_parms): Add missing braces around initializer.

	* w32term.c (x_setup_relief_colors): Don't compute an image's
	background color if it doesn't have a Pixmap.
	(notice_overwritten_cursor): Don't depend on
	output_cursor and updated_area.  Compare pixel coordinates with
	window's cursor pixel coordinates.
	(x_draw_glyphs, x_clear_end_of_line, show_mouse_face):
	Call notice_overwritten_cursor with new arg list.
	(show_mouse_face): Fix bug setting a row's mouse_face_p flag
	unconditionally.
	(x_draw_image_relief): Use predefined macro instead of
	constant when the value of `tool_bar_button_relief' is negative.

	* w32term.c (x_display_and_set_cursor): Fix PostMessage arg types.

2002-01-04  Richard M. Stallman  <rms@gnu.org>

	* xmenu.c (menu_highlight_callback): Hide any tooltip window.

2002-01-03  Richard M. Stallman  <rms@gnu.org>

	* keymap.c (Fcurrent_active_maps): Put the `keymap' property map first.
	(Fkey_binding): Try the `keymap' property map first.
	(Fdescribe_buffer_bindings): Show `keymap' property bindings before
	minor mode bindings.

2002-01-03  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (read_key_sequence): Fixed cast of submaps arg to bcopy.

2002-01-02  Richard M. Stallman  <rms@gnu.org>

	* keyboard.c (read_key_sequence): Handle the keymap property
	before minor mode maps.

	* editfns.c (Fformat): Update thissize from field_width
	based on the actual width, in the string case.

2002-01-01  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* charset.h (UNIBYTE_STR_AS_MULTIBYTE_P): Parenthesize assignment
	when used as truth value to prevent gcc warnings.

	* sysdep.c, unexapollo.c, w32.c, w32bdf.c, w32heap.c, w32inevt.c,
	* w32proc.c: Include <config.h>.

2002-01-01  Andreas Schwab  <schwab@suse.de>

	* eval.c (max_specpdl_size, max_lisp_eval_depth): Define as int,
	not EMACS_INT, to make them compatible with DEFVAR_INT.
	* lisp.h (max_specpdl_size): Adjust declaration.

2002-01-01  Richard M. Stallman  <rms@gnu.org>

	* print.c (print_object): Test print_escape_nonascii only for
	unibyte strings.
	(PRINTPREPARE): Once again bind Qprint_escape_nonascii
	when outputting to a multibyte buffer.

2001-12-29  Richard M. Stallman  <rms@gnu.org>

	* print.c (print_object): In multibyte string, use hex escapes.
	Use octal only for unibyte strings.
	(PRINTPREPARE): Don't ever set Qprint_escape_nonascii.

	* lread.c (read_escape): New arg BYTEREP for reporting whether
	escape forces unibyte or multibyte.
	(read1): When reading a string, take note of that info.

2001-12-29  Ken Raeburn  <raeburn@gnu.org>

	* abbrev.c (Fexpand_abbrev): Use NILP instead of implicit zero
	comparison to test lisp value returned by Fget.

2001-12-29  Richard M. Stallman  <rms@gnu.org>

	* lisp.h (max_specpdl_size): Add declaration.

	* fileio.c (Fdo_auto_save): If NO_MESSAGE, don't call push_message.

	* keymap.c (silly_event_symbol_error): New subrtn, from Fdefine_key.
	Handle modifier bits.  Correct typo in error message.

2001-12-28  Richard M. Stallman  <rms@gnu.org>

	* abbrev.c: Use the plist of an abbrev for multiple params if nec.
	(Fdefine_abbrev): New arg SYSTEM-FLAG for a system abbrev.
	(Fdefine_global_abbrev, Fdefine_mode_abbrev):
	Update calls to Fdefine_abbrev.
	(write_abbrev): Update for changed data format.
	Don't list "system" abbrevs.
	(Fexpand_abbrev): Update use count with new data format.
	(describe_abbrev): Update for changed data format.
	(Fdefine_abbrev_table): Handle the new SYSTEM-FLAG.

	* config.in (HAVE_MBSINIT): Add #undef.

	* strftime.c (mbsinit): Define as no-op if not available.

	* s/sco5.h (LIBX11_SYSTEM) [MOTIF]: Add -lgen.
	(sigprocmask_set): Conditionalize decl on ! NOT_C_CODE.

	* keymap.c (Flookup_key): Error message if key has wrong data type.
	(Fdefine_key): Add error message for trying to bind [DEL], [RET], etc.
	(exclude_key): New variable.

2001-12-28  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_setup_relief_colors): Don't compute an image's
	background color if it doesn't have a Pixmap.

	* xterm.c (notice_overwritten_cursor): Don't depend on
	output_cursor and updated_area.  Compare pixel coordinates with
	window's cursor pixel coordinates.
	(x_draw_glyphs, x_clear_end_of_line, show_mouse_face):
	Call notice_overwritten_cursor with new arg list.
	(show_mouse_face): Fix bug setting a row's mouse_face_p flag
	unconditionally.

	* xdisp.c (try_scrolling) <PT below scroll margin>: Add the
	height of the cursor line to the amount to scroll.

2001-12-27  Richard M. Stallman  <rms@gnu.org>

	* intervals.c (set_point_both): The position after an invisible,
	intangible character is not an acceptable stopping point.

2001-12-27  Ken Raeburn  <raeburn@gnu.org>

	* window.c (enlarge_window): In new preserve_before code, convert
	CURBEG from lisp object to integer before doing arithmetic.

2001-12-27  Richard M. Stallman  <rms@gnu.org>

	* bytecode.c (Fbyte_code): Undo previous change.

2001-12-26  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (record_char): Ignore duplicate help-echo events only
	separated by mouse-movement.  When tracking mouse, only record
	first and last mouse-movement event in same window.
	Don't record mouse-movement events in keyboard macros.

2001-12-25  Richard M. Stallman  <rms@gnu.org>

	* window.c (enlarge_window): New arg PRESERVE_BEFORE.  Callers changed.
	(Fenlarge_window): New arg PRESERVE_BEFORE.

	* bytecode.c (Fbyte_code): Use Fstring_make_unibyte
	instead of Fstring_as_unibyte.

2001-12-22  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	The following changes remove mocklisp support:

	* mocklisp.h, mocklisp.c: Files removed.

	* lisp.h: Remove declarations of variables `Vmocklisp_arguments',
	`Qmocklisp' and `Qmocklisp_arguments'.
	Remove prototype of syms_of_mocklisp.

	* makefile.nt, makefile.w32-in, Makefile.in: Remove mocklisp files.

	* callint.c: Do not include mocklisp.h.
	(Fcall_interactively): Do not test for mocklisp case.

	* eval.c: Remove variables `Qmocklisp_arguments',
	`Vmocklisp_arguments' and `Qmocklisp'.  Remove prototype of ml_apply.
	(Fprogn, Fwhile, Fcommandp, Feval, Ffuncall, funcall_lambda):
	Do not test for mocklisp case.
	(Fwhile): Remove unused variable `tem'.
	(syms_of_eval): Remove variable `moclisp-arguments'.

	* data.c (wrong_type_argument): Remove mocklisp case.

	* doc.c (Fdocumentation): Remove mocklisp case.

	* emacs.c (main): Do not call syms_of_mocklisp.

2001-12-21  Richard M. Stallman  <rms@gnu.org>

	* xfns.c (compute_tip_xy): If tooltip won't fit on the screen
	to the left or to the right of the pointer, put it against
	the left screen edge.

2001-12-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* Makefile.in (distclean): Remove .gdbinit if we are building
	outside the source tree.

2001-12-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* w32.c (emacs_root_dir): New function.

	* msdos.c (emacs_root_dir): New function.

	* fileio.c (Fexpand_file_name) [DOS_NT]: Use the root directory
	of the current drive as the fallback for default_directory.

	* dired.c (file_name_completion): Run the elements of
	completion-ignored-extensions through ENCODE_FILE.

	* lisp.h (scmp): Remove prototype, since it's now a static
	function private to dired.c.

2001-12-18  Richard M. Stallman  <rms@gnu.org>

	* dired.c (scmp): Function moved from minibuf.c.
	Delete multibyte handling--used only on encoded strings.

	* minibuf.c (scmp): Function moved to dired.c.

	* fns.c (merge): Add QUIT call.

2001-12-18  Dave Love  <fx@gnu.org>

	* Makefile.in (lisp, shortlisp): Add language/utf-8-lang.el,
	language/georgian.el.

2001-12-18  Eli Zaretskii  <eliz@is.elta.co.il>

	* Makefile.in (lisp, shortlisp): Synchronize with changes to
	lisp/Makefile.in:DONTCOMPILE.

2001-12-18  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xdisp.c (window_box_height): Do not return negative values.
	From Gerd Moellmann <gerd@gnu.org>.

	* keyboard.c (head_table): Add missing braces around initializer.

	* term.c (keys): Likewise.

	* xfns.c (x_frame_parms, visual_classes): Likewise.

2001-12-17  Sam Steingold  <sds@gnu.org>

	* coding.c (DECODE_COMPOSITION_END): Fixed a typo in the last
	patch (COMPOSING_P, not COMPOSING).

2001-12-17  Richard M. Stallman  <rms@gnu.org>

	* editfns.c (Fcompare_buffer_substrings): Add QUIT to main loop.

	* coding.c (code_convert_region): Update coding->cmp_data->char_offset
	before calling decode_coding.

	* charset.c (Fdefine_charset): Call Fupdate_coding_systems_internal.

	* coding.c (DECODE_COMPOSITION_END): Check for ! COMPOSING_P (coding)
	instead of only for COMPOSITION_DISABLED.

2001-12-16  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (pure_alloc): After overflow, allocate just a small block.

	* Makefile.in (xmenu.o, xterm.o, fontset.o): Depend on buffer.h.

	* buffer.h (struct buffer): New field `display_error_modiff'.
	* buffer.c (reset_buffer): Initialize `display_error_modiff'.

	* window.c (Frecenter): Clear display_error_modiff field.

	* xdisp.c (redisplay_window_0, redisplay_window_1): New functions.
	Call redisplay_window, but not if display_error_modiff field says no.
	(redisplay_window_error): New function.
	(displayed_buffer): New variable.
	(redisplay_internal, redisplay_windows): Call the new functions
	instead of redisplay_window directly.

2001-12-15  Richard M. Stallman  <rms@gnu.org>

	* keyboard.c (syms_of_keyboard) <double-click-fuzz>: Doc fix.

2001-12-14  Andrew Innes  <andrewi@gnu.org>

	* makefile.w32-in (EMACSLOADPATH): Define.
	($(EMACS)): Run `list-load-path-shadows' after dumping emacs.
	(bootstrap-temacs): Remove dependency on bootstrap-clean.

2001-12-13  Eli Zaretskii  <eliz@is.elta.co.il>

	* xfns.c (x_report_frame_params): Make the scroll-bar-width frame
	parameter have a numeric value all the time.

	* w32fns.c (x_report_frame_params): Likewise.

2001-12-12  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Fwrite_region): Doc fix.

	* xdisp.c (CLEAR_FACE_CACHE_COUNT): Redefine as 500.
	(redisplay_internal): Call clear_image_cache only for window terminals.

2001-12-12  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (move_it_vertically_backward): Change heuristic
	for the case that we didn't move far enough initially.

	* window.c (Frecenter): Simplify computation in the case of window
	system frames and ARG < 0; use window_box_height.

2001-12-11  Richard M. Stallman  <rms@gnu.org>

	* Makefile.in, mem-limits.h, dispnew.c, emacs.c, fileio.c:
	* process.c, sysdep.c, unexec.c: Test GNU_LINUX, not LINUX.

2001-12-11  Andrew Innes  <andrewi@gnu.org>

	* insdel.c (make_gap) [DOUG_LEA_MALLOC]: Call make_gap_smaller if
	arg is negative.

2001-12-11  Richard M. Stallman  <rms@gnu.org>

	* m/hp800.h: Split the __hpux conditional into the parts
	that are right for GNU/Linux too and the parts that are not.
	Use the former if GNU_LINUX.
	(HAVE_ALLOCA, LOAD_AVE_TYPE, LOAD_AVE_CVT): New defs for GNU/Linux.

	* s/gnu-linux.h (GNU_LINUX): Defined.

2001-12-11  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* macros.c, msdos.c, w16select.c: Change doc-string comments to
	`new style' [w/`doc:' keyword].

2001-12-10  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (w32_free_submenu_strings): Clear menu item struct
	before using.

2001-12-09  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* dosfns.c: Change doc-string comments to `new style' [w/`doc:'
	keyword].

2001-12-09  Eli Zaretskii  <eliz@is.elta.co.il>

	* dosfns.c (dos-display-scancodes, dos-decimal): Doc fix.

	* s/hpux10.h (srand48): Don't undefine.

2001-12-09  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (_widget_value): Make `help' field a Lisp_Object.
	Add	comment to explain where the struct came from.
	(single_submenu, w32_menu_show): Set `help' field as Lisp_Object.
	(add_menu_item): Process pop-up menus first to avoid memory leak.
	(add_menu_item, w32_menu_display_help): Use `help' field as
	Lisp_Object.
	(w32_free_submenu_strings): Only free owner-drawn strings.

2001-12-09  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* COPYING: Moved back.

	* charset.c (char_to_string_1, translate_char, Fdefine_charset):
	Add parentheses around && within ||.

	* indent.c (compute_motion): Likewise.

	* intervals.c (merge_properties_sticky): Likewise.

	* coding.c (setup_coding_system, shrink_encoding_region)
	(Fdecode_sjis_char): Likewise.

2001-12-07  Andreas Schwab  <schwab@suse.de>

	* xdisp.c (display_mode_element): Don't read past end of string if
	it ends with '%'.

	* alloc.c (inhibit_garbage_collection): Don't exceed value an int
	can hold.

	* data.c (Vmost_positive_fixnum, Vmost_negative_fixnum): Rename
	from most_positive_fixnum and most_negative_fixnum, resp., and
	type changed to Lisp_Object.
	(syms_of_data): DEFVAR_LISP them.

2001-12-07  Richard M. Stallman  <rms@gnu.org>

	* callproc.c (init_callproc): Set Vdata_directory based on the source
	location whenever Emacs was run uninstalled.

2001-12-06  Paul Eggert  <eggert@twinsun.com>

	* config.in (HAVE_WORKING_VFORK): New #undefs.
	* process.c (create_process):
	Use HAVE_WORKING_VFORK, not HAVE_VFORK.
	* m/cnvrgnt.h (HAVE_VFORK): Remove #define.
	* m/ibm370aix.h (HAVE_VFORK): Remove #undef.
	* m/ibmps2-aix.h (HAVE_VFORK): Remove #define.
	* m/intel386.h (HAVE_VFORK): Likewise.
	* m/mips-siemens.h (HAVE_VFORK): Likewise.
	* m/mips.h (HAVE_VFORK): Likewise.
	* s/freebsd.h (vfork): Remove #define.
	* s/lynxos.h (HAVE_VFORK): Remove #undef.
	* s/usg5-4-2.h: Fix comment about vfork.

2001-12-06  Richard M. Stallman  <rms@gnu.org>

	* s/hpux10.h (random): Add undef.
	(HAVE_RANDOM): Define it just once.

2001-12-06  Stefan Monnier  <monnier@cs.yale.edu>

	* eval.c: Undo last change: the standard syntax is not wanted.

2001-12-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* xterm.c (x_free_frame_resources) [USE_X_TOOLKIT]: Remove all the
	scroll bars of the frame before deleting the frame itself.  If the
	frame has a widget, delete the frame with XtDestroyWidget, and do
	not call XDestroyWindow before that.

2001-12-06  Kim F. Storm  <storm@cua.dk>

	* xfns.c (x_report_frame_params): Return actual fringe widths.

	* w32fns.c (x_report_frame_params): Return actual fringe widths.

2001-12-05  Andrew Innes  <andrewi@gnu.org>

	* alloc.c (Fgarbage_collect): Shrink buffer gaps that are
	excessively large.

	* insdel.c (make_gap_larger): New function.
	(make_gap_smaller): New function.
	(make_gap) [USE_MMAP_FOR_BUFFERS || REL_ALLOC]: Call
	make_gap_smaller if arg is negative.

2001-12-04  Stefan Monnier  <monnier@cs.yale.edu>

	* keyboard.c (kbd_buffer_store_event): Fix interrupt_signal prototype.
	Pass a dummy argument when calling interrupt_signal.
	(parse_menu_item): Mark disabled items before checking for empty def.
	(read_char_minibuf_menu_prompt): Make safety more visible.
	(read_key_sequence): Add a `first_unbound' variable.
	Use it to detect C-c ESC ESC ESC ESC ... cases and drop the
	unbound prefix as soon as we can detect it.

	* doc.c (Fsnarf_documentation): Add prototype.
	(get_doc_string): Handle negative arguments.
	(Fdocumentation): Use AREF and ASIZE.
	Move the calls to get_doc_string to a single place.
	Don't confuse an interactive-spec for a docstring reference.
	(Fdocumentation_property): Take advantage of the fact that
	get_doc_string now ignores the sign of the docstring position.

	* eval.c: Use standard syntax for usage in docstrings.

2001-12-03  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xdisp.c (syms_of_xdisp): Make `tool-bar-button-relief` an option.

2001-12-02  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xterm.c (x_draw_image_relief): Use predefined macro instead of
	constant when the value of `tool_bar_button_relief' is negative.

2001-12-02  Richard M. Stallman  <rms@gnu.org>

	* xmenu.c (menu_highlight_callback): Use `help' field as Lisp_Object.
	(single_submenu, xmenu_show): Set `help' field as Lisp_Object.

	* fileio.c (read_non_regular): Delete Fsignal call.

2001-12-01  Stefan Monnier  <monnier@cs.yale.edu>

	* lisp.h (run_hook_list_with_args): Undo last change.

2001-12-01  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_draw_fringe_bitmap): Always undo clipping.

2001-12-01  Jason Rumney  <jasonr@gnu.org>

	* window.c (Qleft_fringe, Qright_fringe): Remove. Now in frame.c.

	* w32term.h (WM_MOUSELEAVE, TME_LEAVE, TRACKMOUSEEVENT)
	[!WM_MOUSELEAVE]: Define.

	* w32menu.c (current_popup_menu, get_menu_item_info):
	(set_menu_item_info): New vars.
	(set_frame_menubar): Doc fix clarifying GC interaction with menus.
	(w32_menu_show): Set current_popup_menu.
	(add_menu_item): Allocate new strings for owner-drawn menu items
	and help strings.
	Use owner-draw for disabled menu items again.
	(w32_menu_display_help): Ignore owner-drawn items and popup menus.
	(w32_free_submenu_strings, w32_free_menu_strings): New functions.

	* w32fns.c (trackmouse_window, track_mouse_event_fn): New vars.
	(w32_wnd_proc) <WM_MOUSEMOVE>: Notice when mouse enters frame.
	<WM_EXITMENULOOP>: Free menu strings.
	<WM_MOUSELEAVE>: Stop tracking mouse.
	(x_create_tip_frame): Specify no minibuffer, modeline or fringes.

	* w32term.c (w32_read_socket) <WM_MOUSELEAVE>: Cancel help echo
	and mouse face.

2001-12-01  Kim F. Storm  <storm@cua.dk>

	The following changes add left-fringe and right-fringe
	frame parameters to adjust fringe widths, or remove one or
	both fringes.

	* frame.h (struct frame): Remove trunc_area_pixel_width and
	trunc_area_cols fields.
	(Qleft_fringe, Qright_fringe): Declare.
	(FRAME_RIGHT_FRINGE_WIDTH): New macro.

	* frame.c (Qleft_fringe, Qright_fringe): New vars.
	(syms_of_frame): Initialize them.

	* window.c (coordinates_in_window): Handle separate left and right
	fringe widths.

	* xterm.h (struct x_output): Add left_fringe_width, right_fringe_width,
	and fringe_cols fields.
	(FRAME_FRINGE_BITMAP_WIDTH, FRAME_FRINGE_BITMAP_HEIGHT): Remove macros.
	(FRAME_X_FRINGE_COLS): Use fringe_cols field.
	(FRAME_X_FRINGE_WIDTH): Use fringes_extra field.
	(FRAME_X_LEFT_FRINGE_WIDTH): Use left_fringe_width field.
	(FRAME_X_RIGHT_FRINGE_WIDTH): Use right_fringe_width field.
	(x_compute_fringe_widths): Add prototype.

	* xterm.c (zv_height, zv_bits, zv_period): Changed zv bitmap to
	fill fringe evenly with small dashes.
	(x_draw_fringe_bitmap): Clear background if necessary. Align and
	clip the new ZV bitmap to avoid jitter between rows.
	(x_draw_row_fringe_bitmaps): Rely on x_draw_fringe_bitmap to clear
	background.  Don't draw fringe bitmaps if fringe width is zero.
	(x_compute_fringe_widths): New function.
	(x_new_font, x_set_window_size_1): Use it.

	* xfns.c (x_frame_parms): Add `left-fringe' and `right-fringe' parms.
	(x_set_frame_parameters): Process `font' parameter before other
	parameters as fringe widths depend on it.
	(x_set_fringe_width): New function.
	(x_figure_window_size): Use x_compute_fringe_widths.
	(Fx_create_frame): Process `left-fringe' and `right-fringe' frame
	parameters.

	* widget.c (set_frame_size): Use x_compute_fringe_widths.
	(EmacsFrameSetCharSize): Ditto.

	* w32term.h: Merged changes from xterm.h.
	* w32term.c: Merged changes from xterm.c.
	* w32fns.c: Merged changes from xfns.c.

2001-11-29  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* COPYING: Removed.

2001-11-29  Dave Love  <fx@gnu.org>

	* coding.c (syms_of_coding) <Qchar_coding_system>: Give it an
	extra extra slot.
	(detect_coding_mask): Fix call of detect_coding_iso2022.

2001-11-29  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* fileio.c (file-name-coding-system)
	(default-file-name-coding-system): Doc fix (links to referenced
	variables added).

2001-11-28  Stefan Monnier  <monnier@cs.yale.edu>

	* lisp.h (GCPRO1, GCPRO2, GCPRO3, GCPRO4, GCPRO5):
	Add dummy uses of gcproN variables.

	* category.c (describe_category, describe_category_1)
	(Fdescribe_categories): Remove.  (Moved to lisp/help-fns.el.)
	(syms_of_category): Don't defsubr Sdescribe_categories.

2001-11-28  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Ffind_file_name_handler): Avoid initializer for `result'.

	* Makefile.in (lispdir): New variable, referring to build dir.
	(TAGS-LISP): Find Makefile in $(lispdir), not $(lispsource).

2001-11-28  Andrew Innes  <andrewi@gnu.org>

	* w32menu.c (w32_menu_display_help): Actually add the new argument
	OWNER.

2001-11-28  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (add_menu_item): Do not use owner-draw for disabled
	menu items.  From David Ponce <dponce@wanadoo.fr>.
	(w32_dialog_show) [HAVE_DIALOGS]: Compile whole function
	conditionally.
	(w32_menu_display_help): New argument OWNER. Rewritten to store a
	help event in the owner frame's keyboard buffer.

	* w32fns.c (w32_wnd_proc) <WM_MENUSELECT>: Display help directly.
	(Fx_show_tip): Don't subtract last width from row width.

	* w32term.c (w32_read_socket) <WM_MENUSELECT>: Remove.
	(w32_read_socket): Use EQ to compare frames.

2001-11-28  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_draw_glyphs): Don't call notice_overwritten_cursor if
	OVERLAPS_P.

2001-11-28  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xdisp.c (message_dolog): Remove unused variables `gcpro2',
	`gcpro3' and `gcpro4'.

	* coding.c (decode_coding_string): Remove unused variable `gcpro1'.

2001-11-28  Stefan Monnier  <monnier@cs.yale.edu>

	* ccl.c: Use AREF and ASIZE.

2001-11-27  Stefan Monnier  <monnier@cs.yale.edu>

	* lisp.h (run_hook_list_with_args): Remove.
	(LIST_END_P): Fix call to wrong_type_argument.
	(make_fixnum_or_float): Use EMACS_INT rather than int.

2001-11-26  Stefan Monnier  <monnier@cs.yale.edu>

	* syntax.c (syms_of_syntax): Remove defsubr of Sdescribe_syntax.
	(describe_syntax, describe_syntax_1, Fdescribe_syntax): Remove.

	* eval.c: Use AREF and ASIZE.
	(Ffetch_bytecode): Add the file name to the error message.

	* fileio.c (Ffind_file_name_handler): Give precedence to handlers
	which match the end of the file-name.
	(Fsubstitute_in_file_name): Don't signal an error if $ENVVAR
	is not a valid env var, but leave it as is instead.

	* keymap.c (access_keymap): Handle t bindings like nil bindings.
	Make nil bindings in char-tables transparent.
	(store_in_keymap): Turn a nil binding into a t binding for char-tables.

2001-11-26  Richard M. Stallman  <rms@gnu.org>

	* textprop.c (set_text_properties_1): Allow START, END in either order.
	Do nothing if range is empty.

	* Makefile.in (mallocobj): Simplify logic using auxiliary vars.

	* Makefile.in (mostlyclean): Delete bootstrap-emacs here.
	(clean): Not here.

2001-11-25  Stefan Monnier  <monnier@cs.yale.edu>

	* textprop.c (set_text_properties_1): Clearly mark that the
	interval should not be empty.

	* intervals.c (graft_intervals_into_buffer):
	Don't call set_text_properties_1 on an empty interval.

2001-11-25  Richard M. Stallman  <rms@gnu.org>

	* unexelf.c (unexec): Index by n, not nn, when checking for ".sbss".

	* callproc.c (Fcall_process): When we make a bigger buffer for bufptr,
	don't lose the data in it.

2001-11-25  Juanma Barranquero  <lektu@terra.es>

	* abbrev.c (Fexpand_abbrev): Use Frun_hooks instead of Vrun_hooks.

	* buffer.c (Fkill_buffer): Use Frun_hooks, not Vrun_hooks.

	* print.c (temp_output_buffer_setup): Use Frun_hooks, not Vrun_hooks.

2001-11-25  Stefan Monnier  <monnier@cs.yale.edu>

	* xfaces.c (merge_face_heights): Coerce back to int explicitly.

2001-11-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* window.c (Fset_window_vscroll): Doc fix.  From Kalle Olavi
	Niemitalo <kon@iki.fi>.

2001-11-25  Jason Rumney  <jasonr@gnu.org>

	* w32term.h (FRAME_X_FRINGE_COLS): No fringe on tip frames.

	* w32fns.c (x_create_tip_frame): Set frame's fringes_extra to 0.
	(Fx_show_tip): Block input during frame creation.
	(Fx_show_tip, Fx_hide_tip): Enable.

2001-11-24  Richard M. Stallman  <rms@gnu.org>

	* lread.c (Fload): Detect recursive load error for more than 3
	nestings of the same file.
	(Vrecursive_load_depth_limit): Variable deleted.
	(syms_of_lread) <recursive-load-depth-limit>: Variable deleted.

2001-11-24  Jason Rumney  <jasonr@gnu.org>

	* xfns.c (compute_tip_xy): Initialize root_x and root_y from
	mouse position if either left or top is not specified.

	* w32fns.c (w32_wnd_proc) <WM_MENUSELECT>: Revert last change.
	<WM_WINDOWPOSCHANGING>: Let tip frames resize without restriction.
	(my_create_tip_window, Fx_show_tip): Adjust size for external border.
	(my_create_tip_window): Assign tip_window.
	(x_create_tip_frame): Use same defaults as X.
	(compute_tip_xy): Remove unused variable.  Use full screen width.
	(Fx_show_tip): Do not double height. Call ShowWindow directly.

	* w32term.c (x_after_update_window_line): Doc fix.
	(w32_read_socket): Doc fix.  Avoid SET_FRAME_GARBAGED for tip
	frames.
	<WM_SHOWWINDOW>: Redo mouse highlight when hiding tip frame.

	* xdisp.c (prepare_menu_bars) [HAVE_WINDOW_SYSTEM]: Use tip_frame
	for all Windowed systems.

2001-11-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (IT_clear_screen): If the frame's faces are not yet
	realized, use the initial screen colors to clear the screen.

2001-11-23  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* textprop.c (Fset_text_properties): Remove unused variables
	`unchanged', `prev_changed', `s' and `len'.

	* search.c (Freplace_match): Remove unused variable `inslen'.

	* keymap.c (access_keymap): Remove unused variables `c1' and `c2'.

2001-11-22  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (x_window_to_frame): Remove irrelevant TODO comment.
	(w32_wnd_proc) <WM_MENUSELECT>: Show help echo directly.
	(my_create_tip_window): New function.
	(x_create_tip_frame, compute_tip_xy): Adapt for Windows.
	(Fx_show_tip, Fx_hide_tip) [TEST_TOOLTIPS]: Adapt for Windows.

2001-11-20  Jason Rumney  <jasonr@gnu.org>

	* coding.h (Vw32_system_coding_system) [WINDOWSNT]: Remove.
	(ENCODE_SYSTEM, DECODE_SYSTEM) [WINDOWSNT]: Use Vlocale_coding_system.

	* w32fns.c (Vw32_system_coding_system): Remove.
	(w32_to_x_font, x_to_w32_font): Use Vlocale_coding_system.

2001-11-19  Stefan Monnier  <monnier@cs.yale.edu>

	* fileio.c (Fwrite_region): Move choose_write_coding_system to
	after build_annotations.

	* syntax.c (describe_syntax): Add dummy arg.
	(describe_syntax_1): Update call to describe_vector.

	* category.c (describe_category): Add dummy arg.
	(describe_category_1): Update call to describe_vector.

	* keymap.c (Fdescribe_vector): Add `describer' parameter.
	(describe_command, describe_translation): Add dummy second param.
	(describe_map): Call elt_describer with two arguments.
	(describe_vector_princ): Add `fun' parameter.
	Call it instead of the hardcoded `princ'.
	(describe_vector): Add arg `args'.
	Pass it as a new second argument to elt_describer.

	* keymap.h (describe_vector): Update prototype.

	* frame.c: Don't include keymap.h any more.
	(keys_of_frame): Remove.

	* lisp.h (keys_of_frame): Remove declaration.

	* emacs.c (main): Don't call `keys_of_frame' any more.

2001-11-14  Andreas Schwab  <schwab@suse.de>

	* unexelf.c [!defined MAP_ANON]: Define MAP_ANON to MAP_ANONYMOUS
	if defined, 0 otherwise.
	(MAP_FAILED): Define if not defined and use it to test mmap failure.
	(unexec) [!MAP_ANON]: Use /dev/zero as file to map.

2001-11-19  Richard M. Stallman  <rms@gnu.org>

	* indent.c (current_column_1): Fix handling of scan_bytes for mb chars.

2001-11-18  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (note_mouse_highlight): Fix type of variable `ignore'.
	(x_draw_bar_cursor): If the background color of the glyph under
	the cursor equals the frame's cursor color, use the glyph's
	foreground color for drawing the bar cursor.
	(x_after_update_window_line): Clear internal border in different
	circumstances.
	(w32_set_vertical_scroll_bar): Check for width and height > 0.
	(w32_draw_relief_rect): Correct relief by 1 pixel.
	(x_set_glyph_string_background_width):
	Set extends_to_end_of_line_p if the row's fill_line_p is set and
	drawing the last glyph with DRAW_IMAGE_{RAISED,SUNKEN}.
	(x_display_and_set_cursor): If cursor_in_echo_area, use NO_CURSOR
	if cursor_in_non_selected_windows is false.
	(show_mouse_face): Clean up.  Recognize overwritten cursor differently.
	(x_draw_glyphs): Remove parameters REAL_START and REAL_END.
	Notice if cursor gets overwritten.
	(notice_overwritten_cursor): Renamed from
	note_overwritten_text_cursor.  Rewritten to take glyph widths
	into account, and to take X positions as parameters.
	(x_draw_phys_cursor_glyph): Save state of w->phys_cursor_on_p
	around call to x_draw_glyphs.
	(x_setup_relief_colors): Use `IMAGE_BACKGROUND' and
	`IMAGE_BACKGROUND_TRANSPARENT' to calculate the correct background
	color to use for image glyph reliefs.
	(x_draw_image_relief): Accept zero tool_bar_button_relief.
	(glyph_rect): Remove unused variable `area'.

	* w32fns.c (x_set_frame_parameters): Avoid infinite recursion for
	some items.
	(x_set_internal_border_width): Set frame garbaged when window
	doesn't exist yet.
	(Fx_create_frame): Accept zero tool_bar_button_relief.
	(x_clear_image_1, four_corners_best, image_background)
	(image_background_transparent): New functions.
	(xpm_format, png_format, jpeg_format, tiff_format, gif_format)
	(gs_format): Add `:background' entry.
	(lookup_image): Set IMG's background color if specified.
	(pbm_load, xbm_load_image, png_load): Set IMG's background field
	when appropriate.
	(x_clear_image_1): Reset `background_valid' and
	`background_transparent_valid' fields.
	(x_build_heuristic_mask): Use IMAGE_BACKGROUND instead of
	calculating it here.  Set IMG's background_transparent field.
	(enum xpm_keyword_index): Add XPM_BACKGROUND.
	(enum png_keyword_index): Add PNG_BACKGROUND.
	(enum jpeg_keyword_index): Add JPEG_BACKGROUND.
	(enum tiff_keyword_index): Add TIFF_BACKGROUND.
	(enum gif_keyword_index): Add GIF_BACKGROUND.
	(enum gs_keyword_index): Add GS_BACKGROUND.
	(pbm_load, png_load, jpeg_load, tiff_load, gif_load):
	Pre-calculate image background color where necessary.
	(x_create_x_image_and_pixmap, xbm_load, gs_load):
	Use display info's n_cbits entry for screen depth.
	(Fx_show_tip): Remove unused variables `buffer', `top',
	`left', `max_width' and `max_height'.

	* w32menu.c (w32_menu_show, push_menu_pane): Doc fixes.

2001-11-18  Gerd Moellmann  <gerd@gnu.org>

	* puresize.h (BASE_PURESIZE): Increase to 750000.

2001-11-18  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* frame.c (Fframe_live_p): Doc fix.

2001-11-18  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (message_dolog_marker1, message_dolog_marker2)
	(message_dolog_marker3): New static variables hold three markers.
	(syms_of_xdisp): Initialize and staticpro them.
	(message_dolog): Use message_dolog_marker1..3 instead of
	allocating markers each time.  Unchain them when done.

2001-11-17  Richard M. Stallman  <rms@gnu.org>

	* doc.c (Fsnarf_documentation): Doc fix.

2001-11-17  Andreas Schwab  <schwab@suse.de>

	* xterm.c (note_mouse_highlight): Fix type of variable `ignore'.

2001-11-17  Richard M. Stallman  <rms@gnu.org>

	* fileio.c (Fwrite_region): Avoid initializer for Lisp_Object.

2001-11-17  Jason Rumney  <jasonr@gnu.org>

	* xterm.c (notice_overwritten_cursor): Take care of end < 0 case.

2001-11-17  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (tool_bar_item_info): Avoid calling Fget_text_property
	with invalid position.

2001-11-16  Richard M. Stallman  <rms@gnu.org>

	* syswait.h: Delete conditionals for HPUX7, ISC 4.1, and convex.

	* s/isc4-1.h (HAVE_SYS_WAIT_H): Add #undef.
	* s/hpux.h (HAVE_SYS_WAIT_H): Add #undef.
	* s/hpux8.h (HAVE_SYS_WAIT_H): Define it.

	* m/convex.h (HAVE_SYS_WAIT_H): Add #undef.

2001-11-16  Stefan Monnier  <monnier@cs.yale.edu>

	* fileio.c (build_annotations): Split off the tail.
	(build_annotations_2): New fun.  Extracted from build_annotations.
	(Fwrite_region): Split the call to build_annotations into two
	calls to build_annotations and build_annotations_2.

2001-11-16  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* sysdep.c (wait_for_kbd_input) [VMS]: Do not call
	clear_waiting_for_input with argument.

	* xterm.h (x_update_cursor): Remove duplicated prototype.

	* keyboard.h (clear_waiting_for_input): Remove duplicated prototype.

	* xterm.c (waiting_for_input): Remove unnecessary declaration.

	* data.c (Ftimes, Fquo, Frem, Fmod): Doc fix.

2001-11-16  Stefan Monnier  <monnier@cs.yale.edu>

	* fileio.c (choose_write_coding_system): New fun, extracted
	from Fwrite_region.
	(Fwrite_region): Use it.

	* eval.c (max_specpdl_size, max_lisp_eval_depth): Use EMACS_INT.
	(funcall_lambda, run_hook_with_args): Make static and add prototype.
	(ml_apply, find_handler_clause): Add prototype.

2001-11-16  Eli Zaretskii  <eliz@gnu.org>

	* config.in: Add #undef HAVE_COFF_H.

	* unexec.c (coff.h): Don't include unless HAVE_COFF_H is defined.
	Required for ISC 4.1.

2001-11-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* syswait.h: (HAVE_SYS_WAIT_H): Undef for ISC 4.1.  Reported by
	Andrew Wiseman <a.wiseman@btclick.com>.

2001-11-16  Kim F. Storm  <storm@cua.dk>

	The following changes are made to clean up the various internal
	references to the fringes to actually use the term `fringe' for
	them.  Previously, they were called `flags areas', `bitmap areas',
	`left/right side of windows', or implicitly as `flags' or
	`bitmaps':

	* dispextern.h (FRINGE_FACE_ID): Renamed from BITMAP_AREA_FACE_ID.
	Comments fixed. Use renamed symbols.

	* dispnew.c: Comment fix. Use renamed symbols.

	* frame.h (FRAME_FRINGE_COLS): Renamed from FRAME_FLAGS_AREA_COLS.
	(FRAME_FRINGE_WIDTH): Renamed from FRAME_FLAGS_AREA_WIDTH.
	(FRAME_LEFT_FRINGE_WIDTH): Renamed from FRAME_LEFT_FLAGS_AREA_WIDTH.

	* msdos.c: Comment fix.

	* w32fns.c: Use renamed symbols.

	* w32term.c: Comment fixes. Use renamed symbols.
	(fringe_bitmap_type): Renamed from bitmap_type.
	(NO_FRINGE_BITMAP): Renamed from NO_BITMAP.
	(w32_draw_fringe_bitmap): Renamed from w32_draw_bitmap.
	(x_draw_row_fringe_bitmaps): Renamed from x_draw_row_bitmaps.

	* w32term.h: Comment fixes. Use renamed symbols.
	(fringes_extra): Renamed from flags_areas_extra.
	(FRAME_FRINGE_BITMAP_WIDTH): Renamed from FRAME_FLAGS_BITMAP_WIDTH.
	(FRAME_FRINGE_BITMAP_HEIGHT): Renamed from FRAME_FLAGS_BITMAP_HEIGHT.
	(FRAME_X_FRINGE_COLS): Renamed from FRAME_X_FLAGS_AREA_COLS.
	(FRAME_X_FRINGE_WIDTH): Renamed from FRAME_X_FLAGS_AREA_WIDTH.
	(FRAME_X_LEFT_FRINGE_WIDTH):
	Renamed from FRAME_X_LEFT_FLAGS_AREA_WIDTH.
	(FRAME_X_RIGHT_FRINGE_WIDTH):
	Renamed from FRAME_X_RIGHT_FLAGS_AREA_WIDTH.

	* widget.c: Use renamed symbols.

	* window.c: Comment fixes. Use renamed symbols.
	(coordinates-in-window-p): Doc fix.

	* xdisp.c: Comment fixes. Use renamed symbols.

	* xfaces.c (realize_basic_faces): Use FRINGE_FACE_ID.

	* xfns.c: Use renamed symbols.

	* xterm.c: Comment fixes. Use renamed symbols.
	(fringe_bitmap_type): Renamed from bitmap_type.
	(NO_FRINGE_BITMAP): Renamed from NO_BITMAP.
	(x_draw_fringe_bitmap): Renamed from x_draw_bitmap.
	(x_draw_row_fringe_bitmaps): Renamed from x_draw_row_bitmaps.

	* xterm.h: Comment fixes. Use renamed symbols.
	(fringes_extra): Renamed from flags_areas_extra.
	(FRAME_FRINGE_BITMAP_WIDTH): Renamed from FRAME_FLAGS_BITMAP_WIDTH.
	(FRAME_FRINGE_BITMAP_HEIGHT): Renamed from FRAME_FLAGS_BITMAP_HEIGHT.
	(FRAME_X_FRINGE_COLS): Renamed from FRAME_X_FLAGS_AREA_COLS.
	(FRAME_X_FRINGE_WIDTH): Renamed from FRAME_X_FLAGS_AREA_WIDTH.
	(FRAME_X_LEFT_FRINGE_WIDTH):
	Renamed from FRAME_X_LEFT_FLAGS_AREA_WIDTH.
	(FRAME_X_RIGHT_FRINGE_WIDTH):
	Renamed from FRAME_X_RIGHT_FLAGS_AREA_WIDTH.

2001-11-15  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (add-menu-item): Make help_echo and radio buttons
	work for most menu items.  From David Ponce
	<david.ponce@wanadoo.fr>.

2001-11-15  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x_set_frame_parameters): Revert change of 2001-11-07.
	Some x_set_* function expect to be called even if old and new
	value are equal.

	* xdisp.c (build_desired_tool_bar_string): Accept zero
	tool_bar_button_relief.

	* xfns.c (Fx_create_frame): Accept zero tool_bar_button_relief.

	* xterm.c (x_draw_image_relief): Accept zero tool_bar_button_relief.

	* xterm.c (x_draw_bar_cursor): If the background color of the
	glyph under the cursor equals the frame's cursor color, use
	the glyph's foreground color for drawing the bar cursor.

	* dispnew.c (direct_output_forward_char): Fix character/byte
	position comparison.

2001-11-15  Miles Bader  <miles@gnu.org>

	* editfns.c (find_field): Add BEG_LIMIT and END_LIMIT parameters.
	(Fdelete_field, Ffield_string, Ffield_string_no_properties):
	Update arguments to find_field.
	(Ffield_beginning, Ffield_end): Add LIMIT param, pass to find_field.
	(Fconstrain_to_field): Use LIMIT arg to shorten search time.
	* lisp.h (Ffield_beginning, Ffield_end): Update EXFUN decl.
	* minibuf.c (Fminibuffer_prompt_end): Update args to Ffield_end.

2001-11-14  Richard M. Stallman  <rms@gnu.org>

	* editfns.c (Fpropertize): Allow call with 1 arg.

	* dispextern.h (image_background, image_background_transparent):
	Conditionalize on HAVE_X_WINDOWS.

2001-11-13  Richard M. Stallman  <rms@gnu.org>

	* print.c (Fprin1_to_string): Doc fix.

	* sunfns.c (Fsun_change_cursor_icon): Doc fix.

	* floatfns.c (Fceiling, Ffloor): Doc fixes.

	* filelock.c (Funlock_buffer, Ffile_locked_p): Doc fixes.

	* fileio.c (Ffile_accessible_directory_p): Doc fix.

	* eval.c (syms_of_eval): Doc fix.

	* coding.c (syms_of_coding): Doc fix.

	* doc.c (Fsnarf_documentation): Doc fix.

	* dispnew.c (syms_of_display): Doc fix.

	* category.c (Fget_unused_category): Doc fix.

	* buffer.c (syms_of_buffer): Doc fixes.

2001-11-14  Eli Zaretskii  <eliz@is.elta.co.il>

	* print.c (prin1, print): Doc fix.

2001-11-14  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* fontset.h: Remove declarations of variables
	`Vhighlight_wrong_size_font' and `Vclip_large_size_font'.

	* fontset.c: Remove variables `Vhighlight_wrong_size_font' and
	`Vclip_large_size_font'.

2001-11-13  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c: Doc fix.

2001-11-13  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xfaces.c (Fface_attributes_as_vector): Doc fix.

	* w32fns.c (Fx_synchronize): Reindent.

	* fns.c: Doc fix.

	* emacs.c: Doc fix.

	* coding.c: Doc fix.

	* cmds.c, composite.c, dired.c, doc.c, filelock.c, floatfns.c,
	* fontset.c, insdel.c, keymap.c: Change doc-string comments to
	`new style' [w/`doc:' keyword].

	* xmenu.c (x-popup-menu): Reindent.
	(x-popup-dialog): Likewise.

	* xfaces.c (Finternal_set_alternative_font_family_alist): Reindent.

	* xdisp.c (Fdump_tool_bar_row): Reindent.

	* minibuf.c (Fminibuffer_complete_word): Reindent.
	(Fminibuffer_complete_and_exit): Likewise.
	(Fminibuffer_completion_help): Likewise.
	(Fminibuffer_message): Likewise.

	* fns.c (Freverse): Reindent.

	* eval.c (Fif): Reindent.
	(Fand): Likewise.

	* editfns.c (Fuser_real_login_name): Reindent.
	(Finsert_buffer_substring): Likewise.
	(Fcompare_buffer_substrings): Likewise.
	(Fsubst_char_in_region): Likewise.

	* dispnew.c (Fsit_for): Reindent.
	(Fframe_or_buffer_changed_p): Likewise.
	(Finternal_show_cursor_p): Likewise.
	(syms_of_display): Likewise.

	* alloc.c (Flist): Reindent.
	(Fvector): Likewise.

2001-11-12  Richard M. Stallman  <rms@gnu.org>

	* xterm.c (XTread_socket): Don't update focus for EnterNotify or
	LeaveNotify events.  Only FocusIn and FocusOut do that now.
	(x_display_and_set_cursor): Do display hollow cursors in active
	minibuffer windows when they are not selected.

2001-11-12  Jason Rumney  <jasonr@gnu.org>

	* w32console.c, w32fns.c, w32menu.c, w32proc.c, w32select.c,
	* w32term.c: Change doc-string comments to `new style'.
	[w/`doc:' keyword]. Doc fixes.

	* w32fns.c: Don't define max.
	(Fx_open_connection): Only execute once.

2001-11-12  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* ccl.c: Change macros to use do-while block instead of if-else.
	Use braces to follow GNU Coding Standards.

2001-11-11  Richard M. Stallman  <rms@gnu.org>

	* sysdep.c (child_setup_tty): Don't clear ICRNL or INLCR.

	* lread.c (read_escape): Use end_of_file_error for reporting eof.

	* insdel.c (replace_range): Use adjust_markers_for_replace
	instead of adjust_markers_for_delete and adjust_markers_for_insert.

	* intervals.h: Declare set_text_properties and set_text_properties_1.

	* textprop.c (set_text_properties_1): New subroutine
	broken out of set_text_properties.
	(set_text_properties): Use set_text_properties_1.

	* intervals.c (graft_intervals_into_buffer):
	Use set_text_properties_1 to clear out properties.

	* search.c (Freplace_match): Use replace_range to insert
	and delete.  Don't request property inheritance from
	surrounding text.

2001-11-10  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (enum_font_cb2): Use leading @ on face name to detect
	vertical fonts. Allow them if face name is explicitly specified.
	Do not give up if we find a font that cannot be converted to an xlfd.

2001-11-10  Gerd Moellmann  <gerd@gnu.org>

	* unexelf.c (unexec): Use mmap/munmap to allocate buffers
	instead of malloc/free.

2001-11-09  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xfaces.c (merge_face_vectors): Use braces to follow GNU
	Coding Standards.
	(Finternal_set_lisp_face_attribute): Likewise.

	* buffer.c (Fbury_buffer): Likewise.

	* indent.c (current_column_1): Remove unused variable `prev_col'.

	* coding.c (encode_coding): Use precomputed value of `src'.
	(encode_coding): Remove unused variable `src_end'.
	(code_convert_region): Remove unused variables `count'.

2001-11-07  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_display_and_set_cursor): Do not move system caret
	if cursor_glyph is NULL.

2001-11-07  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* keymap.c (access_keymap): Fix compilation error.

2001-11-07  Miles Bader  <miles@gnu.org>

	* xfns.c (x_set_frame_parameters): Avoid infinite recursion.

2001-11-07  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* intervals.c (graft_intervals_into_buffer):
	Remove #ifdef'd-out code.
	(graft_intervals_into_buffer): Remove unused variable `middle'.

	* lread.c (Feval_region): Remove obsolete #ifdef'd-out
	code (eval-current-buffer).
	Change doc-string comments to `new style' [w/`doc:' keyword].

2001-11-06  Richard M. Stallman  <rms@gnu.org>

	* keymap.c (access_keymap): Don't use initializers on Lisp_Object.

2001-11-06  Stefan Monnier  <monnier@cs.yale.edu>

	* lread.c (read1): Fix behavior with nested backquoting.

	* keyboard.c (make_lispy_event): Check integerness and fix
	Lisp_Object/int mixup.

2001-11-06  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* fns.c (copy_hash_table): Remove unused variable `v'.

	* fontset.c (fontset_font_pattern): Remove unused variable
	`family_registry'.

	* indent.c (current_column_1): Remove unused variable `prev_col'.

2001-11-05  Richard M. Stallman  <rms@gnu.org>

	* m/news-risc.h (BROKEN_PROTOTYPES): Defined.

	* buffer.c (Fkill_buffer): Don't delete auto save file
	if buffer is modified.

2001-11-05  Andrew Innes  <andrewi@gnu.org>

	* w32proc.c (Fw32_set_keyboard_layout): Use CHECK_NUMBER_CAR and
	CHECK_NUMBER_CDR.

2001-11-05  Richard M. Stallman  <rms@gnu.org>

	* unexelf.c (unexec): Minor changes; clean up comments.

2001-11-05  Sam Steingold  <sds@gnu.org>

	* w32term.c (x_display_and_set_cursor): Fix w32 compilation error.

2001-11-05  Andreas Schwab  <schwab@suse.de>

	* sound.c (sound_perror): Save errno from being clobbered.

2001-11-05  Dale Hagglund  <rdh@yottayotta.com>

	* unexelf.c (unexec): Don't use `mmap'.  Instead, read and write
	the program image directly.

2001-11-05  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* buffer.h (Fbuffer_local_value): Add prototype.

2001-11-04  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (Fbuffer_local_value): Remove extra args from CHECK_SYMBOL
	and CHECK_BUFFER.

	* keyboard.c (read_char): Use Fcar and Fcdr, not Fnth.
	(record_char): Likewise.

	* keyboard.c (make_lispy_event): Don't insist a drag event must
	move to a different buffer position.  Instead, check for moving at
	least double_click_fuzz.

	* fns.c (Fmake_hash_table): Use XCAR and XCDR, not Fnth and Flength.

	* keyboard.c (echo-area-clear-hook): Undo Oct 29 change.

	* indent.c (current_column_1, Fmove_to_column): Separate the code
	for display-table glyphs from the code buffer text, to fix
	bugs in the former.

2001-11-04  Michael Welsh Duggan  <md5i@cs.cmu.edu>

	* buffer.c (Fbuffer_local_value): New function.
	(syms_of_buffer): Defsubr it.

	* xterm.c, w32term.c (x_display_and_set_cursor): Use buffer-local
	value of `cursor-in-non-selected-windows'.

	* lisp.h (Qcursor_in_non_selected_windows): New declaration.
	* xdisp.c (Qcursor_in_non_selected_windows): New variable.
	(syms_of_xdisp): Initialize it.

2001-11-04  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xfns.c (Fx_create_frame): Doc fix.

	* coding.c: Change doc-string comments to `new style' [w/`doc:'
	keyword].

	* eval.c (top_level_value, top_level_set): Remove commented and
	#ifdef'd-out code.
	(Fdefvar): Fix usage in doc-string.

2001-11-03  Richard M. Stallman  <rms@gnu.org>

	* xfns.c: Include unistd.h, if it exists.

	* editfns.c: Move the include of ctype.h after unistd.h.

	* gmalloc.c: Test BROKEN_PROTOTYPES.

2001-11-03  Ken Raeburn  <raeburn@gnu.org>

	* lisp.h (CHECK_STRING_CAR): New macro.
	* lread.c (Fload): Use XSETCARFASTINT, XSETCDRFASTINT instead of
	treating XCAR and XCDR as lvalues.
	(openp): Use CHECK_STRING_CAR.
	(read_list): Use XSETCDR instead of treating XCDR as lvalue.

2001-11-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* s/sco5.h (sigprocmask_set): Declare as extern SIGMASKTYPE.
	(SIGMASKTYPE): Define.

	* syssignal.h (sigunblock): Don't define if already defined.

2001-11-02  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* eval.c (debugger_may_continue, Vdebug_ignored_errors)
	(call_debugger, Fcondition_case, skip_debugger, unbind_to):
	Fix typos in comments.

	* mocklisp.c (Fml_defun, Fml_while, Fml_substr): Remove commented
	and #ifdef'd-out code.
	Fix and reindent comments.

	* mocklisp.h: Remove comment which is a copy of comment in mocklisp.c.

	* category.h (CHECK_CATEGORY, CHECK_CATEGORY_SET): Remove unused
	argument `i' in macros.

	* frame.h (CHECK_FRAME, CHECK_LIVE_FRAME): Remove unused argument
	`i' in macros.

	* lisp.h (CHECK_STRING_OR_BUFFER, CHECK_HASH_TABLE, CHECK_LIST)
	(CHECK_STRING, CHECK_CONS, CHECK_SYMBOL, CHECK_CHAR_TABLE)
	(CHECK_VECTOR, CHECK_VECTOR_OR_CHAR_TABLE, CHECK_BUFFER)
	(CHECK_WINDOW, CHECK_LIVE_WINDOW, CHECK_PROCESS, CHECK_NUMBER)
	(CHECK_NATNUM, CHECK_MARKER, CHECK_NUMBER_COERCE_MARKER)
	(CHECK_FLOAT, CHECK_NUMBER_OR_FLOAT)
	(CHECK_NUMBER_OR_FLOAT_COERCE_MARKER, CHECK_OVERLAY)
	(CHECK_NUMBER_CAR, CHECK_NUMBER_CDR): Remove unused argument `i'
	in macros.

	* abbrev.c, alloc.c, buffer.c, bytecode.c, callint.c, callproc.c,
	* casefiddle.c, category.c, ccl.c, charset.c, cmds.c, coding.c,
	* composite.c, data.c, dired.c, dispnew.c, doc.c, dosfns.c, emacs.c,
	* eval.c, fileio.c, filelock.c, fns.c, fontset.c, frame.c, frame.h,
	* indent.c, keyboard.c, keymap.c, lread.c, macros.c, marker.c,
	* minibuf.c, mocklisp.c, msdos.c, print.c, process.c, search.c,
	* sunfns.c, syntax.c, textprop.c, undo.c, w16select.c, w32console.c,
	* w32fns.c, w32menu.c, w32proc.c, w32select.c, window.c, xdisp.c,
	* xfaces.c, xmenu.c, xselect.c: Update usage of CHECK_ macros
	(remove unused second argument).

2001-11-02  Stefan Monnier  <monnier@cs.yale.edu>

	* syntax.c (describe_syntax): New wrapper.
	(Finternal_describe_syntax_value): Rename from describe_syntax.
	Don't insert space at front and \n at the end.
	(syms_of_syntax): Defsubr Sinternal_describe_syntax_value.

	* regex.c (re_wctype): Try to fix some warnings.
	(regcomp, regexec): Don't forget the __restrict.

2001-11-02  Richard M. Stallman  <rms@gnu.org>

	* textprop.c (Fget_char_property): Doc fix.

2001-11-02  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* process.c (Fstart_process): Add usage to doc-string.

	* data.c (Fsetq_default): Ditto.

	* callint.c (Finteractive): Ditto.

2001-11-01  Stefan Monnier  <monnier@cs.yale.edu>

	* macros.c: Don't include keymap.h any more.

2001-11-01  Richard M. Stallman  <rms@gnu.org>

	* data.c (Fmake_local_variable): Doc fix.

	* eval.c (Frun_hooks, Frun_hook_with_args_until_failure): Doc fix.
	(Frun_hook_with_args_until_success, Frun_hook_with_args): Doc fix.

	* keymap.c (Fdescribe_buffer_bindings): Print character property
	bindings along with or instead of the buffer local map.
	Make the overriding maps override what they should.

2001-11-01  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* window.c (grow_mini_window): Fix typo in comment.

2001-11-01  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_scroll_bar_create): Check for width and height > 0.
	(XTset_vertical_scroll_bar): Likewise.

	* xfns.c (x_build_heuristic_mask): Use four_corners_best
	instead of IMAGE_BACKGROUND.

	* xfns.c (four_corners_best): Reindent.

	* xfaces.c (Finternal_set_lisp_face_attribute_from_resource):
	Handle :box so that it is possible to specify sexprs.

2001-11-01  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xfaces.c (Finternal_merge_in_global_face): Reindent.
	(Fface_font): Ditto.
	(Finternal_set_alternative_font_registry_alist): Ditto.
	(Ftty_suppress_bold_inverse_default_colors): Ditto.

	* xfns.c (x-get-resource): Reindent.

2001-10-31  Eli Zaretskii  <eliz@is.elta.co.il>

	* s/hpux11.h: New file.

2001-10-31  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* emacs.c (USAGE1): Show command line option --no-window-system
	instead of --no-windows in usage.
	(standard_args): Rename --no-windows to --no-window-system.
	(bug_reporting_address): Follow Emacs coding conventions.

	* eval.c (Fcommandp): Doc fix.
	Change doc-string comments to `new style' [w/`doc:' keyword].

	* frame.c (Fframe_live_p): Doc fix.

	* buffer.c (selective-display-ellipses): Doc fix.

2001-10-31  Gerd Moellmann  <gerd@gnu.org>

	* lread.c (to_multibyte): Fix computation of new read_buffer_size.

	* xfaces.c (realize_x_face): If C is not a single-byte character,
	set the face's colors_copied_bitwise_p instead of the defaulted_p
	members which have a different meaning.
	(free_face_colors): Do nothing for a face whose colors have been
	copied bitwise.

	* dispextern.h (struct face) <colors_copied_bitwise_p>: New member.

2001-10-31  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* marker.c, mocklisp.c: Change doc-string comments to `new style'
	[w/`doc:' keyword].

2001-10-31  Gerd Moellmann  <gerd@gnu.org>

	* fns.c (require_unwind): Return Lisp_Object.

2001-10-31  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* keyboard.c (lucid-menu-bar-dirty-flag): Doc fix.
	(last-input-char): Revert doc-string to be the same as the
	doc-string of `last-input-event'.

	* xdisp.c:  Fix typos in comments.

2001-10-31  Gerd Moellmann  <gerd@gnu.org>

	* window.c (grow_mini_window): Handle case that the root
	window is already smaller than the nominal mininum height.

2001-10-30  Stefan Monnier  <monnier@cs.yale.edu>

	* emacs.c (main): Don't call keys_of_macros any more.

	* lisp.h (keys_of_macros): Remove.

	* macros.c (keys_of_macros): Remove.

	* xfaces.c (Fface_attribute_relative_p): Declare args.

2001-10-30  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (w32_to_x_charset): Increase size of XLFD charset buffer.
	(enum_font_cb2): Ignore fonts with vertical orientation.

2001-10-30  Richard M. Stallman  <rms@gnu.org>

	* keyboard.c (Finput_pending_p): Doc fix.

2001-10-30  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_after_update_window_line): Don't run the code
	clearing in borders for rows whose visible height is 0.

	* xdisp.c (clear_garbaged_frames): Redraw the frame only if its
	resized_p flag is set.  If not set, use the much less flickering
	method previously used.

	* dispnew.c (change_frame_size_1): Set frame's resized_p.

	* frame.h (struct frame) <resized_p>: New member.

	* lread.c (to_multibyte): Ensure read_buffer is at least twice
	as large as the number of bytes to convert.

	* lread.c (to_multibyte): New function.
	(read1): Use it.

2001-10-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.h (FRAME_LINE_HEIGHT): Define (it's used by xmenu.c).

2001-10-30  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_draw_relief_rect): Correct bottom relief by 1 pixel.
	(x_set_glyph_string_background_width): Set extends_to_end_of_line_p
	if the row's fill_line_p is set and drawing the last glyph with
	DRAW_IMAGE_{RAISED,SUNKEN}.

	* xdisp.c (clear_garbaged_frames): Call Fredraw_frame.

2001-10-29  Stefan Monnier  <monnier@cs.yale.edu>

	* xmenu.c: Include coding.h and charset.h.
	(Fx_popup_menu): Use FRAME_PTR and FRAME_FONT and FRAME_LINE_HEIGHT.
	(Fx_popup_dialog): Use FRAME_PTR and enum scroll_bar_part.
	(single_submenu, xmenu_show): Use ENCODE_SYSTEM.
	Explicitly set wv->help.  Use `TRUE' rather than `True'.
	(menu_help_callback): Use empty_string.

	* w32menu.c (Fx_popup_menu): Explicitly init f, xpos, and ypos.
	(Fx_popup_dialog): Explicitly init f.
	(w32_menu_display_help): Use empty_string.

2001-10-29  Richard M. Stallman  <rms@gnu.org>

	* fns.c (Frequire): Detect recursive try to require the same
	feature 3 or more levels deep, and get error.
	(require_unwind): New subroutine.
	(require_nesting_list): New variable.
	(syms_of_fns): Init and staticpro it.

	* print.c (print_object): Clarify indication of insertion type.

2001-10-29  Eli Zaretskii  <eliz@is.elta.co.il>

	* coding.c (syms_of_coding): Document that locale-coding-system is
	used for decoding input on X.

	* window.c (Fscroll_left, Fscroll_right): Doc fix.

2001-10-29  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* keyboard.c (Finput_pending_p): Fix typo in doc-string.
	(echo-area-clear-hook): Properly DEFVAR_LISP and staticpro it.

2001-10-29  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_display_and_set_cursor): If cursor_in_echo_area,
	use NO_CURSOR if cursor_in_non_selected_windows is false.

	* xfaces.c (Fface_font): Use UNSPECIFIEDP instead of NILP for
	the slant attribute if FRAME is t.

	* xfns.c (x_set_internal_border_width): Set frame garbaged
	when X window doesn't exist yet.

	* xterm.c (x_after_update_window_line): Clear internal border
	in different circumstances.

	* xterm.c (XTread_socket) <KeyPress>: Don't use
	STRING_CHAR_AND_LENGTH if nchars == nbytes.  From Kenichi Handa
	<handa@etl.go.jp>.

2001-10-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* m/ibms390.h: New file.  From Adam Thornton
	<athornton@sinenomine.net>.

2001-10-28  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x_build_heuristic_mask): Use x_alloc_image_color.

	* xfns.c (x_build_heuristic_mask): Fix a bug not incrementing
	a loop counter.

2001-10-28  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* emacs.c: Use argv[0] instead of emacs when -t was specified.

	* keyboard.c: Change doc-string comments to `new style' [w/`doc:'
	keyword].
	Fix typos in comments.

	* emacs.c (bug_reporting_address): New function.
	Use it when displaying usage message.

	* minibuf.c (read_minibuf): Remove unused external declaration of
	variable `Qread_only'.

	* keymap.c (access_keymap): Remove unused variable `charset'.

2001-10-28  Miles Bader  <miles@gnu.org>

	* xfaces.c (merge_face_heights): Handle TO being relative as well.
	Remove #ifdef'd-out code.
	(Fface_attribute_relative_p, Fmerge_face_attribute): New functions.
	(syms_of_xfaces): Initialize them.

2001-10-27  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (w32_wnd_proc) <WM_KILLFOCUS>: Destroy the system caret.
	<WM_EMACS_DESTROY_CARET, WM_EMACS_TRACK_CARET>: Track cursor
	position using the system caret.

	* w32term.c (w32_system_caret_hwnd, w32_system_caret_width)
	(w32_system_caret_height, w32_system_caret_x)
	(w32_system_caret_y): New variables for tracking system caret.
	(w32_initialize): Initialize them.
	(x_display_and_set_cursor): Make system caret follow the active cursor.

	* w32term.h (WM_EMACS_TRACK_CARET, WM_EMACS_DESTROY_CARET):
	New messages types.

	* w32term.c (note_mouse_highlight): Clear old help_echo.

2001-10-27  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xterm.c: Fix typo in a comment.

	* emacs.c: Fix typos in comments.
	Remove unnecessary spaces.
	Change doc-string comments to `new style' [w/`doc:' keyword].
	(USAGE2): Fix typos in usage string.

	* xterm.c: Fix typo in a comment.

	* lisp.h: (gdb_lisp_params): Remove code in #if 0 which is now in
	emacs.c.

2001-10-27  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (move_it_vertically_backward): Use 2/3 line_height
	instead of 1/2 line_height in the heuristic for skipping
	farther backward when target_y was not reached.

	* sound.c (sound_perror): Unblock SIGIO, turn on atimers.
	Display errno only if non-zero.
	(sound_warning): New function.
	(vox_configure): Don't treat failing to set sample rate as error.
	(various places): Improve error messages.

2001-10-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* fileio.c (Faccess_file): Run the argument filename through
	Fexpand_file_name, before using it.

	* dispnew.c (syms_of_display) <visible-bell>: Add a reference to
	ring-bell-function.  Suggested by Alf-Ivar Holm <alfh@ifi.uio.no>

2001-10-26  Gerd Moellmann  <gerd@gnu.org>

	* insdel.c (insert_1_both): Do nothing if NCHARS == 0.

	* xterm.c (XTset_vertical_scroll_bar) [!USE_TOOLKIT_SCROLL_BARS]:
	Fix clearing in the case of scroll bars on the right.

2001-10-26  Juanma Barranquero <lektu@terra.es>

	* w32gui.h (XImage): Add a dummy typedef.

2001-10-26  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (XScreenNumberOfScreen): Fix struct to pointer comparison.

2001-10-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* frame.c (Fframe_parameter): Fix last change.

	* fileio.c: Revert last change (which removed old commented-out
	version of expand-file-name).  Add a comment that explains why
	this old version should not be removed.

2001-10-25  Gerd Moellmann  <gerd@gnu.org>

	* frame.c (Fframe_parameter): Fix a bug whereby some
	``artificial'' frame parameters, like `minibuffer' were not
	obtained by calling Fframe_parameters.

	* xterm.c (show_mouse_face): Clean up.  Recognize overwritten
	cursor differently.

	* xdisp.c (move_it_vertically_backward): Compute line height
	differently.  Add heuristic to try to be more compatible to 20.x.

2001-10-25  Stefan Monnier  <monnier@cs.yale.edu>

	* lisp.h (make_fixnum_or_float): Coerce double to int explicitly.

	* editfns.c (text_property_stickiness): Fix Lisp_Object used as
	boolean.

2001-10-25  Miles Bader  <miles@gnu.org>

	* xfns.c (png_load): Make sure SPECIFIED_BG is a string.
	BG is a pointer to a structure, not a structure.
	(gif_format, png_format): Add missing commas.

2001-10-24  Richard M. Stallman  <rms@gnu.org>

	* xfaces.c (Fface_attributes_as_vector): New function.
	(syms_of_xfaces): Defsubr it.

2001-10-24  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* dispnew.c (sync_window_with_frame_matrix_rows): Remove unused
	variable `area'.

2001-10-25  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* search.c (scan_newline): Remove unused variable `selective_display'.

2001-10-25  Miles Bader  <miles@gnu.org>

	* dispextern.h (struct image): Add `background',
	`background_valid', and `background_transparent' fields.
	(image_background, image_background_transparent): New declarations.
	(IMAGE_BACKGROUND, IMAGE_BACKGROUND_TRANSPARENT): New macros.
	* xfns.c (image_background, image_background_transparent)
	(four_corners_best): New functions.
	(xpm_format, png_format, jpeg_format, tiff_format, gif_format)
	(gs_format): Add `:background' entry.
	(lookup_image): Set IMG's background color if specified.
	(pbm_load, xbm_load_image, png_load): Set IMG's background field
	when appropriate.
	(x_clear_image_1): Reset `background_valid' and
	`background_transparent_valid' fields.
	(x_build_heuristic_mask): Use IMAGE_BACKGROUND instead of
	calculating it here.  Set IMG's background_transparent field.
	(enum xpm_keyword_index): Add XPM_BACKGROUND.
	(enum png_keyword_index): Add PNG_BACKGROUND.
	(enum jpeg_keyword_index): Add JPEG_BACKGROUND.
	(enum tiff_keyword_index): Add TIFF_BACKGROUND.
	(enum gif_keyword_index): Add GIF_BACKGROUND.
	(enum gs_keyword_index): Add GS_BACKGROUND.
	(pbm_load, png_load, jpeg_load, tiff_load, gif_load):
	Pre-calculate image background color where necessary.
	* xterm.c (x_setup_relief_colors): Use `IMAGE_BACKGROUND' and
	`IMAGE_BACKGROUND_TRANSPARENT' to calculate the correct background
	color to use for image glyph reliefs.

2001-10-24  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_draw_glyphs): Don't check for cursor overwriting
	in full-width rows.

	* xterm.c (XTset_vertical_scroll_bar) [!USE_TOOLKIT_SCROLL_BARS]:
	Fix clearing of area not covered by scroll bar.

2001-10-24  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xterm.c: (x_insert_glyphs): Remove unused variables `real_end'
	and `real_start'.
	(x_draw_image_foreground): Remove unused variables `mask' and `xgcv'.
	(glyph_rect): Remove unused variable `area'.

2001-10-24  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c: Change #ifdef GLYPH_DEBUG to #if.

	* xdisp.c (try_window_reusing_current_matrix): Use row_containing_pos.
	(row_containing_pos): Take additional argument DY.
	Treat rows ending in middle of char differently.
	(display_line): Handle tabs on window systems differently.

	* xterm.c, w32term.c (fast_find_position): Call row_containing_pos
	with additional argument.

	* dispextern.h (row_containing_pos): Adjust prototype.

	* xdisp.c (inhibit_try_window_id, inhibit_try_window_reusing)
	(inhibit_try_cursor_movement) [GLYPH_DEBUG]: New variables.
	(try_window_id, try_window_reusing_current_matrix)
	(try_cursor_movement) [GLYPH_DEBUG]: Don't run if inhibited.
	(syms_of_xdisp) [GLYPH_DEBUG]:  DEFVAR_BOOL the variables.

2001-10-24  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xmenu.c: Spell the name of Emacs properly (GNU Emacs instead of
	gnuemacs).
	(HAVE_BOXES): Fix typo in comment.
	(push_menu_pane): Fix typo in comment.

	* xdisp.c: (display_prop_string_p): Remove unused local declaration
	of `Qwhen'.
	(single_display_prop_string_p): Remove unused local declarations
	of `Qwhen' and `Qmargin'.
	(string_buffer_position): Remove unused variable `around'.
	(store_frame_title): Remove unused variable `width'.

	* window.c: Don't define max.
	(coordinates_in_window): Remove unused variable `uy'.

	* widget.c: Don't define max.

	* process.c: Don't define max.
	(create_process): Remove unused variable `buffer'.

2001-10-23  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (Finternal_set_lisp_face_attribute): Fix compilation error.

2001-10-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* xfaces.c (Finternal_set_lisp_face_attribute)
	[HAVE_WINDOW_SYSTEM]: Don't do anything for QCfont unless the
	frame is on a windowed display.

2001-10-23  Gerd Moellmann  <gerd@gnu.org>

	* dispnew.c (sync_window_with_frame_matrix_rows):
	Fix handling of windows which aren't full-width, fix handling
	of marginal areas.

	* lread.c (syms_of_lread) <recursive-load-depth-limit>: Raise to 50.

2001-10-23  Andreas Schwab  <schwab@suse.de>

	* m/macppc.h [LINUX]: Undef LD_SWITCH_SYSTEM_TEMACS and override
	LD_SWITCH_MACHINE_TEMACS with "-Xlinker -znocombreloc".

2001-10-23  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_draw_glyphs): Remove parameters READ_START and
	REAL_END.  Notice if cursor gets overwritten.
	(notice_overwritten_cursor): Take X positions as parameters.
	(x_draw_phys_cursor_glyph): Save state of w->phys_cursor_on_p
	around call to x_draw_glyphs.

2001-10-23  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* syntax.c (modify-syntax-entry): Fix argument names (use CHAR
	instead of C) and usage.

	* editfns.c (char-to-string): Fix argument names (use CHAR instead
	of C) and usage.

	* xfns.c (Fx_show_tip): Remove unused variables `buffer', `top',
	`left', `max_width' and `max_height'.

2001-10-23  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (display_line): For a tab continued to the next line,
	set row's ends_in_middle_of_char_p.

2001-10-22  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (display_line): Fix computation of continuation lines
	width for TABs.

2001-10-22  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xdisp.c (build_desired_tool_bar_string): Remove unused variable
	`Qlaplace'.

	* fileio.c: Remove unused code.

2001-10-22  Miles Bader  <miles@gnu.org>

	* lisp.h (DEFVAR_LISP, DEFVAR_LISP_NOPRO, DEFVAR_BOOL)
	(DEFVAR_INT, DEFVAR_PER_BUFFER, DEFVAR_KBOARD):
	Remove `DOC_STRINGS_IN_COMMENTS' cases.

2001-10-21  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_erase_phys_cursor): Remove inverse_p again.

2001-10-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* mocklisp.c (Fml_if, Fml_provide_prefix_argument)
	(Finsert_string): Avoid the multi-line string literals warning.

2001-10-22  Miles Bader  <miles@gnu.org>

	* doc.c (Vhelp_manyarg_func_alist): Variable removed.
	(Fdocumentation): Don't use it.
	(syms_of_doc): Don't initialize it.

	* keyboard.c (Ftrack_mouse): Add usage: string to doc string.
	* print.c (Fwith_output_to_temp_buffer): Likewise.
	* window.c (Fsave_window_excursion): Likewise.
	* editfns.c (Fsave_excursion, Fsave_current_buffer)
	(Fsave_restriction): Likewise.
	* eval.c (Frun_hooks, Frun_hook_with_args)
	(Frun_hook_with_args_until_failure)
	(Frun_hook_with_args_until_success, Ffuncall, For, Fand, Fif)
	(Fcond, Fprogn, Fprog1, Fprog2, Fsetq, Fquote, Ffunction, Fdefun)
	(Fdefmacro, Fdefvar, Fdefconst, FletX, Flet, Fwhile, Fcatch)
	(Funwind_protect, Fcondition_case): Likewise.
	* coding.c (Ffind_operation_coding_system): Likewise.
	* keyboard.c (Ftrack_mouse): Likewise.

2001-10-21  Miles Bader  <miles@gnu.org>

	* fns.c (Fappend, Fconcat, Fvconcat, Fnconc, Fwidget_apply)
	(Fmake_hash_table): Add usage: string to doc string.
	* editfns.c (Finsert, Finsert_and_inherit, Finsert_before_markers)
	(Fmessage, Fmessage_box, Fmessage_or_box, Fpropertize, Fformat)
	(Fencode_time, Finsert_and_inherit_before_markers): Likewise.
	* mocklisp.c (Finsert_string, Fml_if, Fml_provide_prefix_argument)
	(Fml_prefix_argument_loop): Likewise.

2001-10-21  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* fileio.c (Finsert_file_contents): Remove unused variable `gap_size'.

	* sysdep.c (init_sys_modes): Change doc-string comments to `new
	style' [w/`doc:' keyword].

	* data.c, fileio.c, indent.c, print.c, search.c, sound.c,
	* sunfns.c, textprop.c, undo.c, xselect.c: Change doc-string
	comments to `new style' [w/`doc:' keyword].

2001-10-21  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fx_file_dialog): Pass a filter to GetOpenFileName.

	* w32term.c (remember_mouse_glyph): New function.
	(w32_mouse_position): Use it.
	(note_mouse_movement): If the mouse moved off the glyph, remember
	its new position.

	* w32term.h (struct w32_output): Correct spelling of x_compatible.
	(w32_display_info): Add mouse_face_overlay.

	* w32term.c (notice_overwritten_cursor): Renamed from
	note_overwritten_text_cursor.  Rewritten to take glyph widths into
	account.
	(x_y_to_hpos_vpos): Add parameter BUFFER_ONLY_P.
	(fast_find_string_pos): New function.
	(fast_find_position): Return the correct vpos.  Add parameter
	STOP.  In the final row, stop before glyphs having STOP as object.
	Don't consider glyphs that are not from a buffer.
	(fast_find_position) [0]: Add a presumably more correct version
	for after 21.1.
	(expose_window_tree, expose_frame): Don't compute intersections here.
	(expose_window): Do it here instead.
	(expose_window_tree, expose_window, expose_line): Return 1 when
	overwriting mouse-face.
	(expose_window): If W is the window currently being updated, mark
	the frame garbaged.
	(expose_frame): If mouse-face was overwritten, redo it.
	(x_use_underline_position_properties): New variable.
	(syms_of_xterm): DEFVAR_BOOL it.
	(x_draw_glyph_string): Add comment to use it in future.
	(x_draw_glyph_string): Restore clipping after drawing box.
	Fix a computation of the underline position.
	(w32_get_glyph_string_clip_rect): Minor cleanup.
	(x_fill_stretch_glyph_string): Remove an assertion.
	(x_produce_glyphs): Don't convert multibyte characters
	to unibyte characters in unibyte buffers.
	(cursor_in_mouse_face_p): New function.
	(x_draw_stretch_glyph_string): Use it to choose a different GC
	when drawing a cursor within highlighted text.  Don't draw
	background again if it has already been drawn.
	(x_draw_glyph_string_box): Don't draw a full-width
	box just because the glyph row's full_width_p flag is set.
	(x_draw_glyphs): Fix computation of rightmost x for
	full-width rows.
	(x_dump_glyph_string): Put in #if GLYPH_DEBUG.
	(w32_draw_relief_rect): Extend left shadow to the bottom and left;
	change bottom shadow accordingly. Some cleanup.
	(x_update_window_end): Handle overwritten mouse face
	also for tool bar windows.
	(show_mouse_face): Set the glyph row's mouse_face_p flag also when
	DRAW is DRAW_IMAGE_RAISED.
	(clear_mouse_face): Return 1 if text with mouse face was
	actually redrawn.  Make the function static.  Reset
	dpyinfo->mouse_face_overlay otherwise note_mouse_highlight might
	optimize away highlighting if we pass over that same overlay again.
	(note_mouse_highlight): Call mouse_face_overlay_overlaps
	to detect a case where we have to highlight a different region
	despite not having left the currently highlighted region.
	Set mouse_face_overlay in the x_display_info.  Avoid changing the
	mouse pointer shape when show_mouse_face has already done it, or
	there is no need.  Handle mouse-face and help-echo in strings.
	(glyph_rect): New function.
	(w32_mouse_position): Use it to raise the threshold for mouse
	movement event generation.
	(w32_initialize_display_info): Initialize the x_display_info's
	mouse_face_overlay.
	(w32_set_vertical_scroll_bar): Don't clear a zero height
	or width area.
	(w32_set_vertical_scroll_bar, x_scroll_bar_create): Don't configure
	a widget to zero height.

	* w32menu.c (single_submenu, w32_menu_show) [!HAVE_MULTILINGUAL_MENU]:
	Protect unibyte strings created by replacing their multibyte
	equivalents in menu_items.
	(w32_menu_show): Don't overwrite an item's name with its key
	description in case the description is a multibyte string.
	(single_submenu): Some cleanup.

	* w32fns.c (x_laplace_read_row, x_laplace_write_row): Removed.
	(postprocess_image): New function.
	(lookup_image): Call it for all image types except PostScript.
	(x_kill_gs_process): Call postprocess_image.
	(tiff_error_handler, tiff_warning_handler): New functions.
	(tiff_load): Install them as handlers.
	(x_kill_gs_process): Recognize if someone has cleared the image
	cache under us.
	(valid_image_p): Protect better against invalid image
	specifications.  Previous code could signal an error.
	(Fx_hide_tip, Fshow_tip): Doc fix.
	(Fv_max_tooltip_size): New variable.
	(syns_of_xfns): DEFVAR_LISP it.
	(Fx_show_tip): Add parameter TEXT.  Set the tip frame's root
	window buffer to *tip* right after creating the frame. Set frame's
	window_width.  Use a maximum tooltip size specified by
	Vx_max_tooltip_size, if that has valid contents.
	(compute_tip_xy): Add parameters WIDTH and HEIGHT.
	Make sure the tooltip is completely visible.
	(x_create_tip_frame): Set tooltip buffer's truncate-lines to nil.
	(Fx_create_frame): Adjust the frame's height for presence
	of the tool bar before calling x_figure_window_size.
	(x_set_tool_bar_lines): Clear the tool bar window's current matrix
	when the window gets smaller.
	(x_set_foreground_color): Set frame's cursor_pixel.
	(x_set_foreground_color, x_set_background_color): Cleaned up.
	(x_set_font): Handle case of x_new_fontset returning the same name
	as before, although there was a change in fontsets.

2001-10-21  Miles Bader  <miles@gnu.org>

	* data.c (Fplus, Fminus, Fmax, Ftimes, Fquo, Flogand, Flogior)
	(Flogxor): Add usage: string to doc string.
	* charset.c (Fstring): Likewise.
	* callproc.c (Fcall_process_region, Fcall_process): Likewise.
	* alloc.c (Fmake_byte_code, Fvector, Flist): Likewise.

2001-10-21  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* buffer.c: Reindent DEFUNs and DEFVARs with doc: keywords.

	* alloc.c: Reindent DEFUNs with doc: keywords.

	* abbrev.c (Finsert_abbrev_table_description): Reindent.

	* frame.c: Change doc-string comments to `new style' [w/`doc:'
	keyword].

2001-10-20  Gerd Moellmann  <gerd@gnu.org>

	* (Version 21.1 released.)

2001-10-20  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xfns.c (x_laplace_read_row, x_laplace_write_row): Prototypes removed.

	* xdisp.c (invisible_text_between_p): Put prototype inside #if
	0 because unused.

	* bytecode.c, callint.c, callproc.c, casefiddle.c, casetab.c
	* category.c, ccl.c, charset.c, process.c, syntax.c, window.c:
	Change doc-string comments to `new style' [w/`doc:' keyword].

2001-10-20  Miles Bader  <miles@gnu.org>

	The following changes remove the glyph_row `inverse_p' field,
	which is never set anymore, due to other changes:

	* dispextern.h (struct glyph_row): Remove `inverse_p' field.
	(reassert_line_highlight, change_line_highlight): Declarations removed.
	* dispnew.c (update_frame_line): Don't call reassert_line_highlight.
	(line_hash_code, row_equal_p, fake_current_matrices)
	(build_frame_matrix_from_leaf_window, update_frame_line)
	(update_frame_line, update_frame_line, update_frame_line):
	Don't use `inverse_p' field.
	* xterm.c (x_initialize): Don't set reassert_line_highlight_hook or
	change_line_highlight_hook.
	(XTreassert_line_highlight, x_change_line_highlight):
	Functions removed.
	(x_fix_overlapping_area, x_write_glyphs, expose_area)
	(expose_line, x_erase_phys_cursor): Don't use `inverse_p' field.
	* xdisp.c (dump_glyph_row, display_mode_line): Don't use
	`inverse_p' field.
	* w32term.c (x_fix_overlapping_area, x_write_glyphs, expose_area)
	(expose_line, x_erase_phys_cursor): Don't use `inverse_p' field.
	(w32_reassert_line_highlight, x_change_line_highlight):
	Functions removed.
	* w32console.c (reassert_line_highlight, change_line_highlight):
	Functions removed.
	(initialize_w32_display): Don't set reassert_line_highlight_hook
	or change_line_highlight_hook.
	(hl_mode): Function removed.
	(reset_terminal_modes, set_terminal_modes, update_begin)
	(update_end, w32_face_attributes, initialize_w32_display):
	(clear_frame, ins_del_lines): Don't call it.
	* termhooks.h (reassert_line_highlight_hook)
	(change_line_highlight_hook): Declarations removed.
	* term.c (reassert_line_highlight_hook)
	(change_line_highlight_hook): Variables removed.
	(reassert_line_highlight, change_line_highlight): Functions removed.
	* msdos.c (IT_reassert_line_highlight)
	(IT_change_line_highlight): Functions removed.
	(internal_terminal_init): Don't set reassert_line_highlight_hook
	or change_line_highlight_hook.
	(highlight): Variable removed.
	(IT_set_face, IT_update_begin, IT_update_end)
	(IT_set_terminal_modes): Don't set or use it.

	The following changes remove inverse-video support for terminals
	that use a `magic cookie' standout mode.  Due to changes in the
	way mode-lines are displayed, such support no longer works
	anyway, and it's probable that almost no one uses such terminals
	anymore:

	* term.c (standout_requested): Variable removed.
	(update_end, highlight_if_desired): Don't use it.
	(chars_wasted, copybuf): Variables removed.
	(write_standout_marker): Function removed.
	(cursor_to, clear_to_end, clear_frame, clear_end_of_line_raw)
	(clear_end_of_line_raw, write_glyphs, ins_del_lines):
	Don't use `chars_wasted' or `copybuf'.
	(calculate_costs): Don't allocate `chars_wasted' or `copybuf'.
	Set `costs_set' to true.
	(cursor_to, clear_end_of_line): Test `costs_set' instead of
	`chars_wasted'.
	(clear_end_of_line): Function removed.
	(clear_end_of_line_raw): Renamed to `clear_end_of_line'.
	(clear_to_end): Call `clear_end_of_line' instead of
	`clear_end_of_line_raw'.
	(TN_standout_width, TF_xs, TN_magic_cookie_glitch_ul): Vars removed.
	(term_init): Don't set them.
	Turn off any standout/underline modes that require magic cookies.
	(ins_del_lines, highlight_if_desired, background_highlight)
	(turn_on_highlight, turn_off_highlight, reset_terminal_modes):
	Remove special processing for magic-cookie standout modes.
	(turn_off_face, turn_on_face): Remove special processing for
	underline magic-cookie glitch.

2001-10-19  Richard M. Stallman  <rms@gnu.org>

	* eval.c (syms_of_eval): Doc fixes.

2001-10-19  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (redisplay_internal): Don't clear echo area if the
	mini-window is selected.

2001-10-19  Miles Bader  <miles@gnu.org>

	* editfns.c (text_property_stickiness): Non-rear-non-stickiness
	doesn't take precedence if the affected property's value is nil.

	* editfns.c (Fencode_time): Escape a BOL paren in the doc-string.

	* cmds.c (Fbeginning_of_line, Fend_of_line): Clarify interaction
	with fields and suggest using `forward-line' to avoid them.
	* editfns.c (Fline_beginning_position, Fline_end_position):
	Clarify documentation.

2001-10-18  Stefan Monnier  <monnier@cs.yale.edu>

	* keymap.c (current_minor_maps): `override' only shadows its
	correspondent in minor-mode-map-alist, not the whole tail.

2001-10-18  Andrew Innes  <andrewi@gnu.org>

	* fontset.c (fs_load_font) [WINDOWSNT && _MSC_VER]: Disable
	optimization.  The fontp->encoding array was not being initialized
	correctly when compiled with optimizations by MSVC.

2001-10-18  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (display_line): Indicate empty lines in active mini-window.

2001-10-17  Andrew Innes  <andrewi@gnu.org>

	* fontset.h (struct font_info) [WINDOWSNT]: Add codepage field.

	* w32fns.c (w32_load_system_font): Cache codepage for font, in
	font_info.charset field.

	* w32term.c (w32_encode_char): Get cached codepage from font_info,
	rather than working it out by calling w32_codepage_for_font for
	every glyph.

2001-10-17  Andrew Innes  <andrewi@gnu.org>

	* w32term.c (w32_read_socket): Determine clipping rectangle for
	the entire frame, including areas covered by scrollbars and the
	menubar.  This avoids internal arguments about whether a frame is
	fully obscured or not.

2001-10-17  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (try_window_id): Undo last change.  Give up if
	window ends in strings.

	* xdisp.c (try_window_id): Don't display lines after the window
	end if the rest of the window after the window end was already blank.

	* xdisp.c (try_window_id): Remove code that was only there
	for the release of 21.1.

	* xdisp.c (display_line): Don't indicate empty lines in mini-windows.

2001-10-17  Miles Bader  <miles@gnu.org>

	* lisp.h (DEFUN): Remove `DOC_STRINGS_IN_COMMENTS' case.
	* xmenu.c, xdisp.c, term.c, dispnew.c, abbrev.c, editfns.c, buffer.c
	* xfns.c, alloc.c, minibuf.c, xterm.c, xfaces.c:
	Change doc-string comments to `new style' [w/`doc:' keyword].
	(DOC_STRINGS_IN_COMMENTS): Macro removed.
	* minibuf.c: Remove old commented-out-DEFUN that was used to fake
	out make-docfile.

2001-10-16  Miles Bader  <miles@gnu.org>

	* fns.c: Change doc-string comments to `new style' [w/`doc:' keyword].

2001-10-16  Gerd Moellmann  <gerd@gnu.org>

	* buffer.c (Fset_buffer_major_mode): Use initial-major-mode for
	*scratch*.

2001-10-16  Ken Raeburn  <raeburn@gnu.org>

	Avoid the assumption that car and cdr slots of cons cells are
	addressable lvalues; this allows for easier experimentation with
	other lisp implementations that may not permit such accesses for
	various reasons.  Not quite complete -- buffer.c still needs some
	work, and w32/mac files need rechecking -- so compile-time
	enforcement is left disabled for now.

	* lisp.h (LISP_MAKE_RVALUE): New macro, or function in the case of
	gcc with a union-based Lisp object rep.  Redefine as no-op for now.
	(XCAR_AS_LVALUE, XCDR_AS_LVALUE): Rename from old XCAR, XCDR.
	(XCAR, XCDR): Apply LISP_MAKE_RVALUE to the _AS_LVALUE versions.
	(XSETCAR, XSETCDR): New macros.
	(XSETCARFASTINT, XSETCDRFASTINT): New macros.
	(CHECK_NUMBER_CAR, CHECK_NUMBER_CDR): New macros.
	* keyboard.h (POSN_BUFFER_SET_POSN): New macro.
	* alloc.c (Fcons, pure_cons, Fgarbage_collect): Use XSETCAR and
	XSETCDR.
	(mark_buffer): Use XCAR_AS_LVALUE, XCDR_AS_LVALUE.
	* buffer.c (record_buffer, Fbury_buffer)
	(swap_out_buffer_local_variables, recenter_overlay_lists)
	(Foverlay_put): Use XSETCAR and XSETCDR to set the car and cdr
	fields of a cons cell respectively.
	* callint.c (quotify_args, Fcall_interactively): Likewise.
	* ccl.c (Fregister_code_conversion_map): Likewise.
	* coding.c (detect_coding_system): Likewise.
	* composite.c (get_composition_id, make_composition_value_copy):
	Likewise.
	* data.c (Fsetcar, Fsetcdr, swap_in_global_binding)
	(swap_in_symval_forwarding, set_internal, Fset_default)
	(Fmake_variable_buffer_local, Fmake_local_variable)
	(Fmake_variable_frame_local): Likewise.
	* fns.c (concat, Fcopy_alist, Fwidget_put): Likewise.
	* keymap.c (Fset_keymap_parent, store_in_keymap)
	(accessible_keymaps_1, where_is_internal_2, Fcopy_keymap): Likewise.
	* minibuf.c (get_minibuffer): Likewise.
	* search.c (Fmatch_data): Likewise.
	* textprop.c (extend_property_ranges): Likewise.
	* undo.c (record_insert, Fundo_boundary, truncate_undo_list): Likewise.
	* w32fns.c (w32_msg_pump, Fw32_register_hot_key, w32_list_fonts):
	Likewise.
	* w32term.c (x_delete_display): Likewise.
	* xfaces.c (remove_duplicates, Finternal_set_lisp_face_attribute):
	Likewise.
	* xterm.c (x_list_fonts, x_load_font, x_delete_display): Likewise.
	* doc.c (store_function_docstring): Use XSETCARFASTINT.
	* fileio.c (Fdo_auto_save): Use XSETCARFASTINT and XSETCDRFASTINT.
	(Fread_file_name): Use XSETCAR.
	* fontset.c (Fset_fontset_font): Use CHECK_NUMBER_CAR and
	CHECK_NUMBER_CDR.
	(accumulate_font_info, Ffontset_info): Use XSETCAR and XSETCDR.
	* frame.c (Fmake_terminal_frame): Use XSETCDR.
	* indent.c (Fcompute_motion): Use CHECK_NUMBER_CAR and
	CHECK_NUMBER_CDR.
	* keyboard.c (read_char): Alter list traversal to avoid taking the
	address of cons cell slots.  Use POSN_BUFFER_SET_POSN.
	(parse_menu_item): Use XSETCAR and XSETCDR.
	(reach_char_x_menu_prompt): Use XSETCAR.
	(read_key_sequence): Use POSN_BUFFER_SET_POSN.
	(Fcommand_execute): Use XSETCDR.
	* lread.c (Fload): Use XSETCARFASTINT and XSETCDRFASTINT.
	(openp): Change list traversal to avoid using XCAR as lvalue.
	(read_list): Use XSETCDR.
	* process.c (wait_reading_process_input): Change wait_for_cell
	handling to avoid taking addresses of cons cell slots.
	* xselect.c (x_own_selection, x_handle_selection_clear)
	(x_clear_frame_selections): Use XSETCDR.
	(wait_for_property_change): Use XSETCARFASTINT and XSETCDRFASTINT.
	(x_handle_property_notify, x_get_foreign_selection)
	(x_handle_selection_notify): Use XSETCAR.

2001-10-15  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* buffer.c: Put doc strings in comments.

	* sound.c: Include <sys/ioctl.h> also on systems without <soundcard.h>.

2001-10-15  Sam Steingold  <sds@gnu.org>

	* fns.c (Vafter_load_alist): Declare extern (w32 build problem).

2001-10-15  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* process.c (process-inherit-coding-system-flag)
	(get-buffer-process): Do not confuse make-docfile with doc strings
	in comment.

	* editfns.c (Fchar_to_string): Make doc string consistent with
	arguments.  Put doc strings in comments.

	* abbrev.c, minibuf.c: Put doc strings in comments.

2001-10-15  Gerd Moellmann  <gerd@gnu.org>

	* window.c (window_loop): Don't check for Fother_buffer returning nil.

	* window.c (select_window_1): Unfreeze window start.  Remove a
	doubled test for WINDOW being live.

2001-10-15  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* fns.c (Fmapconcat): Fix typo in a doc string.

	* dispnew.c (Fsleep_for): Fix typo in a doc string.

2001-10-15  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_draw_glyph_string): Restore clipping after
	drawing box.

2001-10-15  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* callint.c (prefix-arg, current-prefix-arg): Fix typo in a doc string.

2001-10-14  Stefan Monnier  <monnier@cs.yale.edu>

	* indent.c (skip_invisible): Use new retval of
	TEXT_PROP_MEANS_INVISIBLE.

	* keymap.c (access_keymap): Unify handling of `t' and generic-char.
	If a parent is reached and noinherit is set, exit immediately.
	Use AREF and ASIZE macros.  Call get_keyelt before checking KEYMAPP.

	* s/ms-w32.h (EXEC_SUFFIXES):
	* s/msdos.h (EXEC_SUFFIXES):
	* process.h (EXEC_SUFFIXES): Remove.

	* callproc.c (syms_of_callproc): Init Vexec_suffixes to Qnil.
	(decode_suffixes): Remove.

	* intervals.h (TEXT_PROP_MEANS_INVISIBLE_WITH_ELLIPSIS)
	(TEXT_PROP_MEANS_INVISIBLE_NOELLIPSIS, invisible_noellipsis_p)
	(invisible_ellipsis_p): Remove.

	* xdisp.c (DOLIST, LOOP_PROPVAL): Remove.
	(invisible_p): Return 1 or 2 depending on whether an ellipsis is used.
	(invisible_ellipsis_p, invisible_noellipsis_p): Remove.
	(in_ellipses_for_invisible_text_p, handle_invisible_prop):
	Use new retval of TEXT_PROP_MEANS_INVISIBLE.

2001-10-14  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* lisp.h (Ftop_level): Add prototype.

	* xterm.c: (xlwmenu_window_p, xlwmenu_redisplay): Add prototypes.
	(XTread_socket): Improve style of comments to follow other
	comments.

	* keyboard.c (Fcommand_execute): Remove unnecessary prototype (it
	is already prototyped in included lisp.h).

	* frame.c (Fset_mouse_position): Improve style of comment to
	follow other comments.
	(Fset_mouse_pixel_position): Improve style of comment to follow
	other comments.
	(Fmake_frame_visible): Doc fix and typo in comment.
	(Fmake_frame_invisible): Doc fix and typo in comment.
	(Ficonify_frame): Fix typo in comment.

2001-10-14  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c, dispnew.c, xterm.c, xdisp.c, xfaces.c, xmenu.c
	* term.c, alloc.c: Put doc strings in comments.

2001-10-13  Gerd Moellmann  <gerd@gnu.org>

	* lisp.h (DEFUN, DEFVAR_LISP, ...) [DOC_STRINGS_IN_COMMENTS]:
	Provide definitions for doc strings in comments.

	* fns.c: Put doc strings in comments.

2001-10-13  Eli Zaretskii  <eliz@is.elta.co.il>

	* dired.c (file_name_completion): Ignore a candidate directory if
	it matches an element in completion-ignored-extensions that ends
	in a slash.
	(syms_of_dired) <completion-ignored-extensions>: Mention the above
	feature in the doc string.
	(Ffile_name_completion): Ditto.

2001-10-12  Stefan Monnier  <monnier@cs.yale.edu>

	* indent.c (skip_invisible): Don't skip "ellipsisized" text.

	* xfns.c (syms_of_xfns): Update calls to Fprovide.

	* lisp.h (Fprovide): Update prototype.
	(Ffeaturep, invisible_p): Remove.

	* xdisp.c (init_iterator): Be more strict with bytepos and charpos.
	(DOLIST, LOOP_PROPVAL): New macros.
	(invisible_p, invisible_ellipsis_p): Use them.
	(invisible_noellipsis_p): New function.
	(syms_of_xdisp): Use empty_string.

	* alloc.c (mark_interval_tree): Use traverse_intervals_noorder.

	* lread.c (substitute_object_recurse): Use traverse_intervals_noorder.
	(syms_of_lread) <Vafter_load_alist>: Update docstring.

	* print.c (Fwith_output_to_temp_buffer): Align with
	internal_with_output_to_temp_buffer.
	(print_preprocess): Use traverse_intervals_noorder.
	(print_object): Update call to traverse_intervals.

	* intervals.h (TEXT_PROP_MEANS_INVISIBLE_NOELLIPSIS): New macro.
	(traverse_intervals_noorder, invisible_noellipsis_p): New funs.

	* intervals.c (traverse_intervals_noorder): New function.
	(search_for_interval, count_intervals): Use it.
	(traverse_intervals): Use less stack space and drop `depth' arg.

	* fns.c (Ffeaturep): Add new `subfeature' arg.
	(Fprovide): Add new `subfeatures' arg.  Use `after-load-alist'.
	(Qsubfeatures): New var.
	(syms_of_fns): Initialize it.

	* keymap.c (Fkey_description): Use empty_string.
	(Fdescribe_bindings_internal, describe_buffer_bindings): Remove.
	(syms_of_keymap): Setup inheritance between maps.
	Don't export Sdescribe_bindings_internal any more.

	* minibuf.c (keys_of_minibuf): Eliminate redundant bindings.

2001-10-12  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (notice_overwritten_cursor): Renamed from
	note_overwritten_text_cursor.  Rewritten to take glyph widths into
	account.

2001-10-12  Eli Zaretskii  <eliz@is.elta.co.il>

	* lread.c (syms_of_lread) <load-suffixes>: Fix last change:
	multi-line strings without a trailing "\n\".

2001-10-12  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* floatfns.c: float_error() is defined iff FLOAT_CATCH_SIGILL is
	defined.

2001-10-11  Stefan Monnier  <monnier@cs.yale.edu>

	* callint.c (Fcall_interactively): Remove unused code.  Use XCAR.

	* xfns.c (x_create_bitmap_from_file, x_find_image_file):
	* w32proc.c (sys_spawnve):
	* w32fns.c (x_create_bitmap_from_file, x_find_image_file):
	* w32.c (check_windows_init_file):
	* sound.c (Fplay_sound):
	* emacs.c (init_cmdargs):
	* process.c (Fstart_process): Update calls to openp.

	* callproc.c (Vexec_suffixes): New var.
	(Fcall_process): Update call to openp.
	(decode_suffixes): New function.
	(syms_of_callproc): Init exec-suffixes.

	* lread.c (Vload_suffixes, default_suffixes): New vars.
	(openp): Take a lisp list of suffixes.
	Check for file-name-handlers even if the file was absolute already.
	(syms_of_lread): Declare load-suffixes.
	(Fload): Fix up call to openp.
	Don't bother checking for file-name-handler at the very beginning.

	* keymap.h (Fcopy_keymap): Don't export.

	* lisp.h (empty_string): Declare.
	(Vload_suffixes, Vexec_suffixes): Declare.
	(openp): Update prototype.

	* emacs.c (empty_string): New var.
	(syms_of_emacs): Initialize it.

	* search.c (wordify): Use it.

	* buffer.c (Fbury_buffer): Don't try to remove the buffer from the
	selected window if it's not displayed there.  Handle the case
	when the window is dedicated.
	(syms_of_buffer): Fix docstrings not to mention "buffer-local" anymore.

	* undo.c (Fprimitive_undo): Use XCAR/XCDR.

	* syntax.h (struct gl_state_s): Change the meaning of b_property.
	Remove left_ok and right_ok.
	(UPDATE_SYNTAX_TABLE_BACKWARD, UPDATE_SYNTAX_TABLE)
	(SETUP_SYNTAX_TABLE, SETUP_SYNTAX_TABLE_FOR_OBJECT): Update to the
	new meaning of b_property.

	* syntax.c (update_syntax_table): Simplify.
	(Fforward_comment): Don't skip quoted chars when going backward.

2001-10-11  Gerd Moellmann  <gerd@gnu.org>

	* lisp.h (FIXNUM_OVERFLOW_P): Cast I to EMACS_INT in comparisons
	in case I is of some unsigned type, in which case
	MOST_NEGATIVE_FIXNUM will be converted to unsigned, and the
	comparison becomes bogus.

	* editfns.c (Fuser_uid, Fuser_real_uid): Use make_fixnum_or_float.
	(Fuser_full_name): Fix bug treating a float as a fixnum.

	* data.c (Fstring_to_number): Use make_fixnum_or_float.

	* lisp.h (make_fixnum_or_float): New macro.

	* lisp.h (circular_list_error): Add prototype.

	* data.c (Qcircular_list): New variable.
	(circular_list_error): New function.
	(syms_of_data): Initialize it Qcircular_list.

2001-10-10  Stefan Monnier  <monnier@cs.yale.edu>

	* window.c, syntax.c, macros.c, frame.c, emacs.c, cmds.c, category.c
	* casefiddle.c, buffer.c: Include keymap.h.

2001-10-10  Gerd Moellmann  <gerd@gnu.org>

	* s/osf5-0.h (C_SWITCH_SYSTEM) [!__GNUC__]: Add `-nointrinsics'
	options.  From Dave Love <d.love@dl.ac.uk>.

2001-10-09  Gerd Moellmann  <gerd@gnu.org>

	* regex.c (WIDE_CHAR_SUPPORT): Do not use defined() in macro.
	From Hallvard B Furuseth <h.b.furuseth@usit.uio.no>.

	* editfns.c (Fcurrent_time_zone): Cast isalnum() argument to
	unsigned char.
	From Hallvard B Furuseth <h.b.furuseth@usit.uio.no>.

2001-10-08  Andrew Innes  <andrewi@gnu.org>

	* lisp.h [max]: Undef min and max before redefining them.

	* w32gui.h: Do not undef min and max.

	* w32heap.h: Do not undef min and max.

	* s/ms-w32.h: Do not undef min and max.

2001-10-08  Stefan Monnier  <monnier@cs.yale.edu>

	* xdisp.c (handle_fontified_prop): Don't bind after-change-functions.

2001-10-08  Sam Steingold  <sds@gnu.org>

	* keymap.c (current-active-maps): Quote newlines (compilation error).

2001-10-08  Eli Zaretskii  <eliz@is.elta.co.il>

	* Makefile.in (lisp, shortlisp): Replace bindings.el with
	bindings.elc, since otherwise doc strings in bindings.el get wrong
	offsets in etc/DOC.

2001-10-08  Stefan Monnier  <monnier@cs.yale.edu>

	* lisp.h: Remove the entries for keymap.c (moved to keymap.h).

	* keyboard.h (map_prompt): Remove.

	* xterm.c, w32term.c, term.c, minibuf.c, keymap.c,
	* intervals.c, fns.c, doc.c, callint.c: Include keymap.h.

	* xmenu.c (keymap_panes, Fx_popup_menu): Use Fkeymap_prompt.

	* w32menu.c (keymap_panes, Fx_popup_menu): Use Fkeymap_prompt.

	* keyboard.c (map_prompt): Remove.
	(read_char_x_menu_prompt, read_char_minibuf_menu_prompt):
	Use Fkeymap_prompt.

	* keymap.h: New file.  Extracted from lisp.h.

	* keymap.c (Fkeymap_prompt, Fcurrent_active_maps): New funs.
	(accessible_keymaps_1): New function.
	(Faccessible_keymaps, accessible_keymaps_char_table): Use it.
	(Fwhere_is_internal): Use Fcurrent_active_maps.
	(Fdescribe_buffer_bindings): Renamed from describe_buffer_bindings.
	Insert in current buffer rather than standard-output.
	Don't call `help-mode'.  Export to elisp.
	(describe_buffer_bindings): New wrapper.
	(syms_of_keymap): Defsubr Skeymap_prompt, Scurrent_active_maps
	and Sdescribe_buffer_bindings.

2001-10-08  Gerd Moellmann  <gerd@gnu.org>

	* atimer.c (alarm_signal_handler) [USG && !POSIX_SIGNALS]:
	Remove code setting signal handler.

	* sysdep.c (child_setup_tty) [HAVE_TERMIO || HAVE_TERMIOS]:
	Clear ICRNL and INLCR.  From Daiki Ueno <ueno@unixuser.org>.

2001-10-08  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* keyboard.c: Don't define min/max.

2001-10-08  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c, xmenu.c, xfns.c, xdisp.c, window.c:
	* w32term.c, w32menu.c, w32console.c, w32bdf.c, w32.c, term.c
	* sysdep.c, sound.c, search.c, scroll.c, minibuf.c, keymap.c
	* intervals.c, insdel.c, indent.c, fns.c, fileio.c, editfns.c
	* dispnew.c, dired.c, charset.c, xfaces.c, alloc.c, atimer.c:
	Don't define min/max.

	* lisp.h (min, max): New macros.

	* puresize.h (BASE_PURESIZE): Increase to 725000.

2001-10-08  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* xfaces.c (free_frame_menubar): Add prototype.

	* lisp.h (init_window): Add prototype.

	* editfns.c: Include ctype.h.

	* xterm.c: USE_LUCID can be defined iff USE_X_TOOLKIT is defined.
	(xm_scroll_callback) [USE_MOTIF]: Remove unused variable `percent'.
	(x_set_toolkit_scroll_bar_thumb) [USE_MOTIF]: Remove unused
	variable `sb'.

	* xfns.c (Fx_hide_tip): Fix typo in a doc string.
	(Fx_file_dialog) [USE_MOTIF]: Remove unused variables
	`popup_activated_flag' and `title'.

	* doc.c (Fdocumentation_property): Fix typo in a doc string.

	* emacs.c (main): Remove extra `;'.

	* atimer.h (struct atimer): Fix typos in a comment.

	* atimer.c: Fix typo.

	* Makefile.in: Fix typo.

	* README: Remove obsolete part mentioning removed VMS file.

2001-10-07  Miles Bader  <miles@gnu.org>

	* Makefile.in (lisp, shortlisp): Add `button.elc'.

2001-10-07  Ken Raeburn  <raeburn@gnu.org>

	* minibuf.c (Fminibuffer_prompt_end): Don't apply make_number to a
	Lisp_Object.

	* lisp.h (Ffield_end): Declare.

2001-10-07  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (parse_modifiers, apply_modifiers): Use VALMASK.

	* insdel.c (make_gap): Use MOST_POSITIVE_FIXNUM.

	* floatfns.c (FLOAT_TO_INT2, FLOAT_TO_INT): Use FIXNUM_OVERFLOW_P.

	* dired.c (Ffile_attributes): Use FIXNUM_OVERFLOW_P.

	* bytecode.c (syms_of_bytecode) [BYTE_CODE_METER]: Doc fix.
	(METER_CODE, Fbyte_code): Use MOST_POSITIVE_FIXNUM.

	* alloc.c (inhibit_garbage_collection): Simplify.
	(Fmemory_use_counts): Ditto.

	* data.c (most_positive_fixnum, most_negative_fixnum): New variables.
	(syms_of_data): DEFVAR_INT most-positive-fixnum and
	most-negative-fixnum.

	* lisp.h (MOST_NEGATIVE_FIXNUM, MOST_POSITIVE_FIXNUM)
	(FIXNUM_OVERFLOW_P): New macros.

2001-10-06  Miles Bader  <miles@gnu.org>

	* xterm.h (struct x_output): Add scroll_bar_top_shadow_pixel and
	scroll_bar_bottom_shadow_pixel fields.
	* xterm.c (x_create_toolkit_scroll_bar): Try to allocate colors
	for the shadows, and tell the toolkit about them if we succeed.
	(x_destroy_window) [USE_TOOLKIT_SCROLL_BARS]:
	Free scroll-bar shadow colors.
	* xfns.c (x_set_scroll_bar_background) [USE_TOOLKIT_SCROLL_BARS]:
	Free scroll-bar shadow colors when the background color changes.
	(Fx_create_frame, x_create_tip_frame) [USE_TOOLKIT_SCROLL_BARS]:
	Initialize scroll-bar shadow-color fields.

2001-10-05  Gerd Moellmann  <gerd@gnu.org>

	* fileio.c (Fcopy_file): If NEWNAME is a directory copy FILE there.

2001-10-05  Miles Bader  <miles@gnu.org>

	* minibuf.c (Fminibuffer_prompt_end, Fminibuffer_contents)
	(Fminibuffer_contents_no_properties, Fdelete_minibuffer_contents):
	New functions (were in simple.el).
	(Fminibuffer_complete_and_exit, Fminibuffer_complete_word)
	(read_minibuf, do_completion, Fminibuffer_completion_help): Use them.
	(syms_of_minibuf): Initialize them.

2001-10-05  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (tiff_error_handler, tiff_warning_handler): New functions.
	(tiff_load): Install them as error and warning handler.

2001-10-04  Andrew Innes  <andrewi@gnu.org>

	* w32fns.c (x_to_w32_color): Fix argument to alloca.
	(w32_load_system_font): Don't believe what GetLanguageFontInfo
	says; query codepage info directly to determine if font is double byte.
	(x_to_w32_charset): Handle private format for unknown charsets.
	Handle wildcards in charset spec, by ignoring them.
	(w32_codepage_for_font): Fix argument to alloca.  Don't remove
	"*-" prefix from charset.
	(x_to_w32_font): Enlarge remainder array for safety.  Specifically
	handle the truncated font spec form constructed by font_list_1, so
	that we correctly identify the charset fields.  Don't remove "*-"
	prefix from charset.
	(w32_list_synthesized_fonts): Fix argument to alloca.

2001-10-04  Stefan Monnier  <monnier@cs.yale.edu>

	* window.h (MINI_WINDOW_P): Use NILP.

	* coding.h (ENCODE_SYSTEM, DECODE_SYSTEM): Define also for non-NT.

	* termhooks.h (struct input_event): Use proper type for `kind'.

2001-10-04  Gerd Moellmann  <gerd@gnu.org>

	This handles unknown keysyms better than before.  For example,
	after `xmodmap -e 'keysym F5 = ccaron' in a Latin-1 environment,
	Emacs formerly completely ignored F5.  With the change, it derives
	a key symbol from the name of the X keysym, `ccaron' in this case.
	Reported by Martin Buchholz.

	* xterm.c (XTread_socket): Return a non_ascii_keystroke for
	unknown keysyms.

	* keyboard.c (make_lispy_event) [HAVE_X_WINDOWS]: If we know
	that EVENT->code isn't a function key, use the keysym's name.

2001-10-04  Gerd Moellmann  <gerd@gnu.org>

	FOREACH is a macro that should make it easier to loop over Lisp
	lists with checks for cycles and proper lists.

	* lisp.h (LIST_END_P, FOREACH): New macros.

2001-10-04  Gerd Moellmann  <gerd@gnu.org>

	On some systems, XtCloseDisplay seems to cause a SIGSEGV when
	called for a lost connection.  Prevent dumping core in this case.
	Instead print the X error, and exit.  On user request.

	* xterm.c (error_msg): New variable.
	(x_fatal_error_signal): New function.
	(x_connection_closed): Set error_msg.  Install x_fatal_error_signal
	as fatal_error_signal_hook around the call to XtCloseDisplay.

	* emacs.c (fatal_error_signal_hook): New variable.
	(fatal_error_signal): Call that function.

2001-10-04  Gerd Moellmann  <gerd@gnu.org>

	With this, Emacs prints how much pure storage it will
	approximately need in case pure storage overflows while dumping.

	* alloc.c (purebeg, pure_size, pure_bytes_used_before_overflow):
	New variables.
	(init_alloc_once): Initialize new variables.
	(PURE_POINTER_P): Use new variables.
	(pure_alloc): If pure storage overflows, allocate from the heap.
	(check_pure_size): New function.
	(Fgarbage_collect): Don't GC if pure storage has overflowed.

	* lisp.h (pure_size) [HAVE_SHM]: Declare extern size_t.
	(check_pure_size): Add prototype.

	* emacs.c (Fdump_emacs_data, Fdump_emacs): Call check_pure_size.

2001-10-04  Gerd Moellmann  <gerd@gnu.org>

	This adds a post-gc-hook that's run with GC inhibited.
	Requested by Francois Pinard.  XEmacs has it.  Added to NEWS.

	* alloc.c (Vpost_gc_hook, Qpost_gc_hook): New variables.
	(syms_of_alloc): DEFVAR_LISP post-gc-hook, initialize Qpost_gc_hook.
	(Fgarbage_collect): Run post-gc-hook.

2001-10-04  Gerd Moellmann  <gerd@gnu.org>

	This adds `defvaralias' and `indirect-variable'.  Changes not
	directly related to this feature are there to gain the same
	performance again as before variable aliases.

	You must use the SYMBOL_VALUE and SET_SYMBOL_VALUE macros in C
	code to get and set symbol values, to take defvaralias into account.

	(Note: the new `constant' bit-flag in symbols would make it
	possible to define arbitrary read-only variables, e.g. with
	`defconst'.)

	Documentation is in lispref/variables.texi.  Added to NEWS.

	* lisp.h (enum symbol_interned): New enumeration.
	(struct Lisp_Symbol): Remove member `obarray', add
	`indirect_variable', `constant', and `interned'.
	(SYMBOL_INTERNED_P, SYMBOL_INTERNED_IN_INITIAL_OBARRAY_P)
	(SYMBOL_CONSTANT_P, SYMBOL_VALUE, SET_SYMBOL_VALUE): New macros.
	(indirect_variable): Add prototype.

	* print.c (print_preprocess, print_object): Test internedness of
	symbols differently.

	* lread.c (Fintern, Funintern): Set symbol's interned and constant
	bit-fields.
	(init_obarray): Likewise for t and nil.

	* eval.c Use SYMBOL_VALUE/SET_SYMBOL_VALUE.
	(Fdefvaralias): New function.
	(specbind): Simplify the test if symbol is a constant.
	(syms_of_eval): Defsubr Fdefvaralias.

	* data.c: Use SYMBOL_VALUE/SET_SYMBOL_VALUE.
	(Qcyclic_variable_indirection): New variable.
	(Fkeywordp): Check for internedness differently.
	(Fmakunbound): Simplify the test if symbol is a constant.
	(indirect_variable, Findirect_variable): New functions.
	(swap_in_symval_forwarding): If SYMBOL is an alias, use the
	aliased symbol.
	(let_shadows_buffer_binding_p): Check for variable aliases.
	(set_internal): Simplify the test if SYMBOL is a constant.
	If SYMBOL has a buffer-local value and is an alias, use the aliased
	symbol instead.
	(syms_of_data): Initialize Qcyclic_variable_indirection and defsubr
	Sindirect_variable.

	* bytecode.c (Fbyte_code) <varref>: Use SYMBOL_VALUE.
	(Fbyte_code) <varset>: Simplify the test if symbol's value can be
	set directly.

	* alloc.c (Fmake_symbol): Adapt to changes of struct Lisp_Symbol.

	* abbrev.c, buffer.c, coding.c, fns.c, frame.c, keyboard.c:
	* minibuf.c, sunfns.c, w16select.c: Use SYMBOL_VALUE/
	SET_SYMBOL_VALUE macros instead of accessing symbol values directly.

2001-10-04  Gerd Moellmann  <gerd@gnu.org>

	* Branch for 21.1.

2001-10-03  Miles Bader  <miles@gnu.org>

	* callproc.c (syms_of_callproc): Explicitly state in the
	documentation for `process-environment' that earlier entries take
	precedence over later ones.

2001-10-02  Miles Bader  <miles@gnu.org>

	* textprop.c (Fnext_char_property_change)
	(Fprevious_char_property_change): Remove reference to non-existant
	argument OBJECT from doc-string.

2001-10-01  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (display_line): Set row's ends_in_newline_from_string_p.
	(try_window_id): Skip back over lines ending in a newline from a
	string.

	* dispextern.h (struct glyph_row) <ends_in_newline_from_string_p>:
	New bit flag

2001-10-01  Richard M. Stallman  <rms@gnu.org>

	* search.c (Freplace_match): Doc fix.

2001-09-28  Andrew Innes  <andrewi@gnu.org>

	* w32menu.c (set_frame_menubar): Take into account that
	f->menu_bar_vector can be nil, and not a vector.  From Ken Raeburn
	<raeburn@gnu.org>.

2001-09-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* frame.c (syms_of_frame) <default-minibuffer-frame>: Doc fix.

2001-09-28  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* s/gnu-linux.h: Fix a typo in comment.

2001-09-28  Andreas Schwab  <schwab@suse.de>

	* s/gnu-linux.h (LD_SWITCH_SYSTEM_TEMACS): Link temacs with -z
	nocombreloc, in case -z combreloc is the default.

2001-09-28  Gerd Moellmann  <gerd@gnu.org>

	* m/macppc.h [DATA_SEG_BITS]: Put in #if 0 until we know what's
	really going on here.

2001-09-27  Stefan Monnier  <monnier@cs.yale.edu>

	* search.c (trivial_regexp_p): Catch \{N,M\} as well.

2001-09-27  Eli Zaretskii  <eliz@is.elta.co.il>

	* Makefile.in (shortlisp): Resync with loadup.el: add backquote,
	utf-8, menu-bar, and latin-N.
	(SOME_MACHINE_LISP): Remove menu-bar, since it's loaded
	unconditionally now.
	(lisp): Add latin-N, since they are preloaded.

2001-09-27  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_draw_relief_rect): Draw bottom relief 1 pixel more
	to the left.  Some cleanup.

	* xdisp.c (display_mode_element): One more case where a string's
	multibyteness should be used for display.

2001-09-26  Gerd Moellmann  <gerd@gnu.org>

	* fileio.c (Finsert_file_contents): If REPLACE is non-nil, stop
	reading at EOF.

	* xdisp.c (with_echo_area_buffer): Use echo_kboard instead
	of the only temporarily set echoing flag for deciding when
	the cancel echoing.

	* keyboard.c (echo_kboard): Make externally visible.

	* lisp.h (echo_kboard): Declare extern.

	* xdisp.c (make_cursor_line_fully_visible): Return 0 and set
	fonts_changed_p if we need larger matrices due to vscrolling.
	(try_scrolling, try_cursor_movement, redisplay_window): Give up on
	this round of redisplay if make_cursor_line_fully_visible fails.
	(CURSOR_MOVEMENT_*, SCROLLING_*): New enumerators.
	(try_cursor_movement, try_scrolling): Use them instead of integers.

	* dispextern.h (required_matrix_width, required_matrix_height):
	Add prototypes.

	* dispnew.c (required_matrix_width, required_matrix_height):
	New functions.
	(allocate_matrices_for_window_redisplay)
	(allocate_matrices_for_frame_redisplay: Use them.
	Remove parameters CH_DIM.

	* xdisp.c (display_mode_lines): Temporarily set selected_frame
	and selected_window to the frame of the window whose mode-lines
	are displayed, and to the window itself.
	(redisplay_window, redisplay_mode_lines): Don't set selected_frame
	here.

2001-09-25  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x_kill_gs_process): Recognize if someone has cleared
	the image cache under us.

	* xdisp.c (display_mode_element): If the mode element is a symbol
	with a string value, use that string's multibyteness for displaying.

	* keyboard.c (read_char): Don't clear a message for a switch-frame
	event.   From Stefan Monnier  <monnier@cs.yale.edu>.

	* xterm.c (fast_find_position) [0]: Add a presumably more correct
	version for after 21.1.

	* xdisp.c (row_containing_pos): Make externally visible.

	* dispextern.h (row_containing_pos): Add prototype.

	* process.c (send_process): Disable composition if from_byte < 0.
	From Kenichi Handa <handa@etl.go.jp>.

2001-09-24  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (refreshicon): Function removed.

	* Makefile.in (xterm.o): Remove references to sink.h and sinkmask.h.

	* sink11.h, sink11mask.h, sink.h, sinkmask.h: Removed.

	* xterm.c (toplevel): Remove includes in #if 0.

	* process.c (sigchld_handler) [LINUX]: Don't return from
	the signal handler at the end of the loop.

2001-09-21  Gerd Moellmann  <gerd@gnu.org>

	* sysdep.c (wait_for_termination) [POSIX_SIGNALS]:
	Terminate only if kill returns -1, and errno is ESRCH.

2001-09-21  Markus Rost  <rost@math.ohio-state.edu>

	* Makefile.in (shortlisp): Add ../lisp/env.elc.

2001-09-20  Gerd Moellmann  <gerd@gnu.org>

	* process.c (sigchld_handler): Use GC_CONSP, GC_INTEGERP, GC_EQ
	since this function can be called during GC.

	* callproc.c (Fcall_process): Handle errors from pipe(2).
	(child_setup): Delete code in #ifdef vipc.

2001-09-19  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (decode_mode_spec): Add parameter MULTIBYTE.
	(display_mode_element): Display the string from decode_mode_spec
	depending on its multibyteness.

	* s/netbsd.h (LD_SWITCH_SYSTEM, C_SWITCH_SYSTEM): Add /usr/pkg.

	* m/macppc.h (DATA_SEG_BITS): Also define for GCC 3.

2001-09-18  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (Frecursive_edit): Pass (BUFFER . SINGLE-KBOARD) to
	recursive_edit_unwind.
	(recursive_edit_unwind): Set kboard state according to
	SINGLE-KBOARD.

	* buffer.c (modify_overlay): Don't do nothing if START == END;
	This can still be a modification, for example when an overlay has
	a before-string or after-string.
	(Fdelete_overlay): Prevent redisplay optimizations when deleting
	an overlay with before-string or after-string.

	* s/netbsd.h (C_SWITCH_SYSTEM): Add.
	(LD_SWITCH_SYSTEM): Include /usr/local/lib.

	* xdisp.c (try_window_id) [!GLYPH_DEBUG]: Give up if
	first_unchanged_at_end_row is in front of
	last_unchanged_at_beg_row.  This code should be removed after the
	release of 21.1.

2001-09-17  Gerd Moellmann  <gerd@gnu.org>

	* buffer.h (BUF_COMPUTE_UNCHANGED): Use BUF_MODIFF and
	BUF_OVERLAY_MODIFF instead of MODIFF and OVERLAY_MODIFF.

	* m/macppc.h (DATA_SEG_BITS) [__linux__]: Define for GCC
	versions >= 2.95.

2001-09-14  Eli Zaretskii  <eliz@is.elta.co.il>

	* dired.c (Ffile_attributes): Doc fix.

2001-09-14  Gerd Moellmann  <gerd@gnu.org>

	* fileio.c (Ffile_symlink_p): Fix last change.

	* filelock.c (current_lock_owner): Fix last change.

2001-09-13  Gerd Moellmann  <gerd@gnu.org>

	* filelock.c (current_lock_owner): If readlink returns ERANGE,
	take that to mean that the buffer is too small.

	* fileio.c (Ffile_symlink_p): If readlink returns ERANGE, take
	that to mean that the buffer is too small.

	* xdisp.c (reseat_1): Set IT's multibyte_p flag according to the
	current buffer's multibyteness when discarding the iterator's
	stack.

	* xfns.c (Fx_window_property): Handle case that property gets
	deleted between the two calls to XGetWindowProperty.

2001-09-11  Gerd Moellmann  <gerd@gnu.org>

	* minibuf.c (read_minibuf_unwind): Bind inhibit-modification-hooks.

	* minibuf.c (read_minibuf): Bind inhibit-modification-hooks to t,
	in addition to read-only.

	* xdisp.c (with_echo_area_buffer): Bind inhibit-modification-hooks
	to t in addition to read-only.

	* lisp.h (Qinhibit_modification_hooks): Declare.

	* insdel.c (Qinhibit_modification_hooks): New variable.
	(syms_of_insdel): Initialize and staticpro it.

	* textprop.c (verify_interval_modification): Don't run
	modification-hooks if inhibit_modification_hooks.

	* dispnew.c (set_window_cursor_after_update): Fix code
	finding glyph row containing cursor when cursor_in_echo_area
	is >= 0.

	* xdisp.c (init_from_display_pos): Put some code in #if 0.
	(add_to_log): Use bcopy instead of strcpy.
	(init_from_display_pos): Use an explicit loop over bytes in
	overlay strings instead of calling index.

2001-09-10  Gerd Moellmann  <gerd@gnu.org>

	* alloc.c (allocate_buffer): Call VALIDATE_LISP_STORAGE.

	* dispnew.c (direct_output_for_insert): Don't change IT's
	stop_charpos to something in front of its current position.

	* xdisp.c (Ftrace_to_stderr) [GLYPH_DEBUG]: Take args like
	`format'.

2001-09-10  Richard M. Stallman  <rms@gnu.org>

	* frame.c (Fmouse_position): Doc fix.

2001-09-07  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (init_from_display_pos): Don't compare the result
	of calling index with NULL.

2001-09-06  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x_set_background_color): Don't change the colors
	of the X window of scroll bar widgets.

2001-09-05  Andrew Innes  <andrewi@gnu.org>

	* w32fns.c (w32_createwindow): Undo last change.

2001-09-05  Gerd Moellmann  <gerd@gnu.org>

	* macros.c (store_kbd_macro_char): Fix computation of kbd_macro_end.

	* xdisp.c (string_buffer_position): Use *single_char_property*
	functions instead of the *single_property* functions.

2001-09-04  Andrew Innes  <andrewi@gnu.org>

	* w32term.c (w32_read_socket): Add more information to debugging
	output.

	* w32fns.c (w32_createwindow): Remove the WS_CLIPCHILDREN style
	from Emacs frames, so that calls to GetClipBox in w32term.c
	correctly report when part of a frame is visible (including
	scrollbars, etc).  This prevents repeated redrawing of frames when
	only a scrollbar is visible.
	(w32_wnd_proc): Add more frame information to debugging output.

2001-09-03  Stefan Monnier  <monnier@cs.yale.edu>

	* xdisp.c (handle_single_display_prop): Fix for int/Lisp_Object mixup.

2001-09-03  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (note_mouse_highlight) <help-echo>: When looking for
	help-echo for a string which doesn't have help-echo itself, use
	get-char-property to obtain the help-echo from the string's buffer
	(note_mouse_highlight) <mouse-face>: When on a string that doesn't
	have mouse-face, look ``under'' the string for mouse-face from an
	overlay.
	(fast_find_position): Add parameter STOP.  In the final row, stop
	before glyphs having STOP as object.  Don't consider glyphs that
	are not from a buffer.

	* buffer.c (syms_of_buffer) <default-directory>: Doc fix.

2001-09-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* fns.c (Fmd5): Doc fix.

2001-08-31  Gerd Moellmann  <gerd@gnu.org>

	* composite.c (update_compositions): Do nothing if
	inhibit-modification-hooks is set.

2001-08-30  Gerd Moellmann  <gerd@gnu.org>

	* emacs.c (shut_down_emacs): Don't call check_glyph_memory
	and check_message_stack if terminating abnormally.  We want
	glyph matrices etc. in a core dump.

	* xdisp.c (Qbuffer_position, Qposition, Qobject): New variables.
	(syms_of_xdisp): Initialize them.
	(handle_single_display_prop): Don't change point, bind `object',
	`position', and `buffer-position' instead to the object having the
	`display' property, position in the object and position in the buffer.

	* fileio.c (Finsert_file_contents): Don't change the multibyteness
	of the buffer if REPLACE is non-nil.

2001-08-29  Gerd Moellmann  <gerd@gnu.org>

	* fileio.c (Finsert_file_contents): Undo change of 2001-08-27.

2001-08-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* w32term.c (x_set_glyph_string_background_width)
	(show_mouse_face): Track the last changes in xterm.c.

2001-08-28  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_set_glyph_string_background_width): Set the glyph
	string's background width so that multi-line mouse-face is drawn
	to the right edge of the window.
	(show_mouse_face): Set the row's mouse_face_p flag after drawing
	glyphs.

	* dispnew.c (direct_output_for_insert): Set updated_area
	before inserting/writing glyphs.

	* xdisp.c (display_mode_element): Use string_byte_to_char to
	determine character positions in strings, use chars_in_text
	instead of strwidth.
	(dump_glyph_row) [GLYPH_DEBUG]: Take a glyph row instead of
	a matrix as parameter; this is easier to use from GDB.

2001-08-28  Miles Bader  <miles@gnu.org>

	* textprop.c (Fprevious_single_char_property_change)
	(Fnext_single_char_property_change): Doc fixes.

2001-08-27  Gerd Moellmann  <gerd@gnu.org>

	* fileio.c (Finsert_file_contents): Allocate, restore, and
	free composition data in the case of REPLACE not being nil.

	* xdisp.c (init_from_display_pos, init_to_row_end): Return 0 if
	there exist overlay strings with newlines at POS.
	(text_outside_line_unchanged_p): Return 0 if changes start at
	START and overlays exist at START.  Likewise for END.
	(try_window_id): Give up if init_to_row_end returns 0.

	* fileio.c (Finsert_file_contents): Call Fset_buffer_multibyte
	unconditionally.

2001-08-24  Gerd Moellmann  <gerd@gnu.org>

	* keymap.c (access_keymap): Return the cdr of the binding of
	a generic character instead of its definition (KEY . BINDING).

	* fileio.c (Finsert_file_contents): Set coding's dest_multibyte
	to 0 also in the REPLACE case.

2001-08-24  Andrew Choi  <akochoi@cse.cuhk.edu.hk>

	* fileio.c (Ffile_readable_p) [macintosh]: Call access instead of
	open to determine whether file is readable (as for DOS_NT).

2001-08-23  Gerd Moellmann  <gerd@gnu.org>

	* fileio.c (Finsert_file_contents): If VISIT is non-nil, and
	coding.type is coding_type_no_conversion or coding_type_raw_text,
	use Fset_buffer_multibyte to make the buffer unibyte if REPLACE is
	non-nil instead of just setting enable_multibyte_characters in the
	buffer to nil.

2001-08-22  Gerd Moellmann  <gerd@gnu.org>

	* dispextern.h (struct face_cache): Add member
	menu_face_changed_p.

	* xfaces.c (menu_face_changed_default): New variable.
	(menu_face_changed_count): Variable removed.
	(Finternal_set_lisp_face_attribute): Doc fix.  If FRAME is t, set
	the menu_face_changed_default flag, otherwise set the FRAME's
	menu_face_changed_p flag if the `menu' face has been changed.
	Prevent calling set_font_frame_param if FRAME is t.
	(make_face_cache): Initialize cache's menu_face_changed_p
	from menu_face_changed_default.
	(realize_basic_faces): Look into the frame's face cache to
	determine if the menu appearance needs updating.

	* keymap.c (access_keymap): Fix last change to not consider
	IDX when it has modifiers.

2001-08-21  Gerd Moellmann  <gerd@gnu.org>

	* keymap.c (access_keymap): If a binding of the form (GENERIC-CHAR
	. BINDING) exists, where GENERIC-CHAR is the generic character of
	the charset of IDX, return BINDING unless there exists a binding
	for IDX itself.

2001-08-16  Gerd Moellmann  <gerd@gnu.org>

	* xrdb.c (SYSV): Don't define on Solaris 2.
	From Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>.

	* xdisp.c (move_it_by_lines) <DVPOS < 0>: Start at the beginning
	of the screen line, not text line, containing IT's current position.

2001-08-15  Gerd Moellmann  <gerd@gnu.org>

	* window.c (window_scroll_pixel_based): Don't recenter if
	PT is partially visible in the window.

	* xterm.c (expose_window_tree, expose_window, expose_line):
	Return 1 when overwriting mouse-face.
	(expose_frame): If mouse-face was overwritten, redo it.

	* xfaces.c (x_update_menu_appearance): Don't call
	set_frame_menubar, let the next redisplay do it.

2001-08-14  Andrew Innes  <andrewi@gnu.org>

	* w32term.c (x_draw_glyph_string): Draw relief (if any) before
	drawing glyph string.

2001-08-14  Eli Zaretskii  <eliz@is.elta.co.il>

	* s/hiuxwe2.h: New file, for the HITACHI SR2001/SR2201 series
	running HI-UX/MPP.

2001-08-14  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (x_update_menu_appearance): Save and restore value of
	interrupt_input_blocked.

2001-08-13  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (move_it_by_lines) <DVPOS < 0>: If not already on
	a line start, move back to the line start.

	* xdisp.c (resize_echo_area_exactly): Don't resize the mini-window
	exactly when a mini-buffer is active.

	* keyboard.c (make_lispy_event): Interpret double_click_fuzz
	in units of 1/8 character on non window-system frames.
	(syms_of_keyboard) <double-click-fuzz>: Doc fix.

2001-08-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* keyboard.c (syms_of_keyboard) <double-click-fuzz>: Fix a typo in
	a doc string.

2001-08-09  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (Vpre_help_message): New variable.
	(syms_of_keyboard): Initialize and staticpro it.
	(show_help_echo): Record current message before displaying a
	help-echo, and restore that message when clearing the help.

	* xfns.c (x_create_im): Remove prototype.

	* xdisp.c (mark_window_display_accurate_1): Remove an assertion.

	* dispnew.c (adjust_glyph_matrix): Undo last change.

2001-08-08  Gerd Moellmann  <gerd@gnu.org>

	* dispnew.c (adjust_glyph_matrix): In the optimization for
	windows whose height has changed, disable partially visible lines.

2001-08-07  Gerd Moellmann  <gerd@gnu.org>

	* window.c (Frecenter): If ARG < 0, and on a window system
	frame, count in some empty lines when we can't move -ARG lines down.

	* xdisp.c (start_display): Don't try to determine the continuation
	lines width if lines are truncated.  It's superfluous and leads to
	incorrect results if POS is not visible in the window after
	reseating the iterator at the previous line start.

2001-08-06  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_dump_glyph_string): Put in #if GLYPH_DEBUG.

2001-08-06  Pavel Jan,Bm(Bk  <Pavel@Janik.cz>

	* alloc.c (init_stack): Remove declaration.

2001-08-03  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (read_key_sequence): Check that key is an integer
	before comparing it with quit_char.
	(add_command_key): Use larger_vector.
	(read_char_x_menu_prompt): Instead of converting symbol and
	integer events into conses (EVENT . nil), use (EVENT . disabled)
	which cannot be confused with valid events.
	(read_char): When reading from Vunread_command_events, check for
	events of the form (EVENT . disabled) instead of
	(EVENT . nil).

	* xdisp.c (resize_mini_window): If Vmax_mini_window_height is
	a float, determine the max height from the frame's height.

2001-08-02  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (redisplay_internal): Take message_cleared_p into
	account only if minibuf_level == 0.

2001-08-01  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (redisplay_internal): Add a check for the last
	displayed message.

	* xdisp.c (message_cleared_p): New variable.
	(clear_message): Set message_cleared_p when clearing the current
	message.
	(redisplay_internal): Look at message_cleared_p to capture
	the case that the echo area should be cleared.

	* keyboard.c (command_loop_1): Fix spelling of
	resize_echo_area_exactly.

	* dispextern.h (resize_echo_area_exactly): Fix typo in function name.

	* xdisp.c (resize_echo_area_exactly): Fix typo in function name.

	* xfns.c (x_set_tool_bar_lines): Clear the tool bar window's
	current matrix when the window gets smaller.

2001-08-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* print.c (strout): Cast the character passed to insert_char to
	unsigned char, to avoid sign extension when it is promoted to int.

2001-07-31  Gerd Moellmann  <gerd@gnu.org>

	* fileio.c (Finsert_file_contents): Don't treat a return value
	of 0 from emacs_read as an IO error.

2001-07-30  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (abs): New macro.
	(double_click_fuzz): New variable.
	(make_lispy_event): Use it to determine what makes a double-click.
	(syms_of_keyboard): DEFVAR_INT it.

	* xmenu.c (set_frame_menubar): Take into account that
	f->menu_bar_vector can be nil, and not a vector.  From Ken Raeburn
	<raeburn@gnu.org>.

2001-07-27  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_get_glyph_string_clip_rect): Minor cleanup.

	* dispnew.c (shift_glyph_matrix, blank_row): Fix computation
	of row's visible height.

	* xdisp.c (init_from_display_pos): If POS is in an overlay string,
	deal with the first overlay string having an image `display' property.
	(try_window_reusing_current_matrix, compute_line_metrics):
	Fix computation of row's visible height for the case that part of the
	row is invisible above and part of the row is at the same time
	invisible below the window.

2001-07-26  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x-show-tip): Doc fix.

	* xfns.c (Vx_max_tooltip_size): New variable.
	(syms_of_xfns): DEFVAR_LISP it.
	(Fx_show_tip): Set frame's window_width to the width of the
	window.  Use a maximum tooltip size specified by
	Vx_max_tooltip_size, if that has valid contents.
	(x_create_tip_frame): Set tooltip buffer's truncate-lines to nil.

2001-07-26  Andrew Innes  <andrewi@gnu.org>

	* w32term.c (x_display_list): New variable.
	(w32_term_init): Set it.

	* w32term.h (x_display_list): New extern.

2001-07-26  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (resize_mini_window): Give up when inhibit-redisplay
	is non-nil, instead of when redisplaying_p is non-zero.
	See comment there.
	(mark_window_display_accurate_1): Add an assertion.

2001-07-25  Gerd Moellmann  <gerd@gnu.org>

	* dispextern.h (struct it): Increase size of ctl_chars to 16.

	* xfns.c (Fx_file_dialog): Block/unblock input while processing
	events so that we get a chance of processing expose events.

	* xdisp.c (resize_mini_window): Don't resize while redisplaying.

2001-07-24  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (valid_image_p): Protect better against invalid image
	specifications.  Previous code could signal an error.

2001-07-23  Gerd Moellmann  <gerd@gnu.org>

	* indent.c (current_column): Fix column computation in the
	presence of display table entries.
	(current_column_1, Fmove_to_column, compute_motion): Likewise.

	* dispnew.c (adjust_glyph_matrix): In the optimization for
	windows whose height has changed, use the new window height
	to compute which rows to invalidate.

	* editfns.c (toplevel) [STDC_HEADERS]: Include float.h.
	(MAX_10_EXP): New macro.
	(Fformat): Use it.

	* coding.c (code_convert_region): Handle the multibyte case if
	decoding ends with CODING_FINISH_INSUFFICIENT_SRC.

2001-07-20  Gerd Moellmann  <gerd@gnu.org>

	* dispextern.h (struct face): Change type of `stipple' to
	int; it's an ID.

	* xterm.c (x_fill_stretch_glyph_string): Remove an assertion.

2001-07-19  Gerd Moellmann  <gerd@gnu.org>

	* dispnew.c (update_window): Don't set the cursor at the end
	of the update if display update has been paused.

	* composite.h (syms_of_composite): Renamed from syms_of_composition.

2001-07-18  Ken Raeburn  <raeburn@gnu.org>

	* fns.c (Fset_char_table_default): Check that a charset is defined
	before checking its dimension.

2001-07-17  Ken Raeburn  <raeburn@gnu.org>

	* coding.c (setup_coding_system): Don't do any designation based
	on reg_bits if charset is not yet defined.

  	* lisp.h (XVECTOR): Verify correct object type before returning a
	pointer, using eassert.

2001-07-17  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (KBD_BUFFER_SIZE) [!HAVE_WINDOW_SYSTEM]:
	Increase to 4096 because of paste problems reported on GNU/Linux.

2001-07-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	* emacs.c (USAGE1): Add +LINE:COLUMN option help.

2001-07-16  Gerd Moellmann  <gerd@gnu.org>

	* fileio.c (unwind_read): Function removed.
	(read_non_regular, read_non_regular_quit): New functions.
	(Finsert_file_contents): When reading from non-regular files,
	arrange to catch a `quit' and terminate the loop.  Rearrange
	code so that a `quit' when reading from a regular file doesn't
	insert text in the buffer.

	* xfaces.c (clear_face_cache): Clear fonts on a display basis.
	Clear faces afterwards.
	(clear_font_table): Take a x_display_info parameter.  Don't free
	fonts being the default font of any frame on the given display.

2001-07-13  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (get_next_display_element): Use CHAR_STRING_NO_SIGNAL
	instead of CHAR_STRING which can signal an error.

	* charset.c (char_to_string_1): Extracted from char_to_string.
	Return -1 instead of signaling an error.
	(char_to_string): Use it.

	* charset.h (CHAR_STRING_NO_SIGNAL): New macro.

2001-07-12  Stefan Monnier  <monnier@cs.yale.edu>

	* coding.c (Ffind_coding_systems_region_internal): If safe_codings
	is t, don't try to append anything to it.

2001-07-12  Eli Zaretskii  <eliz@is.elta.co.il>

	* dired.c (file_name_completion): Pass dp->d_name to
	Fstring_match, not elt, which is always nil here.

2001-07-12  Gerd Moellmann  <gerd@gnu.org>

	* xselect.c (x_decline_selection_request): Handle errors
	caused by receivers that have vanished.

	* xterm.c (XTread_socket) <PropertyNotify>: Put the code
	ignoring events on foreign windows in #if 0.  Always dispatch
	the event after checking it with x_handle_property_notify.

	* xselect.c (TRACE0, TRACE1, TRACE2): New macros, defined
	depending on TRACE_SELECTION.  Replace fprintfs in #if 0 with
	TRACE macros to facilitate debugging.  Add additional trace statements.
	(toplevel): Add prototypes for file-local functions.
	(x_atom_to_symbol): Remove DPYINFO parameter.

2001-07-11  Stefan Monnier  <monnier@cs.yale.edu>

	* w32menu.c (menubar_selection_callback, w32_menu_show):
	Initialize `entry' to nil.
	(w32_dialog_show): Remove unused `save_wv' variable.
	(name_is_separator): Recognize "--:foo" and "--foo-bar".

2001-07-11  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (try_cursor_movement): Prevent a warning from GCC 3.0.

	* fileio.c (unwind_read): Print a message when discarding inserted
	text or switching the buffer to unibyte.  Change parameter.
	(Finsert_file_contents): Don't pass VISIT to unwind_read.

	* fileio.c (unwind_read): New function.
	(Finsert_file_contents): Record it as unwind-function for
	the case that reading is interrupted by C-g.

2001-07-10  Gerd Moellmann  <gerd@gnu.org>

	* dispnew.c (update_window): Don't skip the header-line
	update when scrolling_window returns 0.

	* xfaces.c (unload_color): Do nothing if PIXEL is -1.

	* xfns.c (Fx_create_frame): Initialize frame colors to -1,
	for the case that x_decode_color signals an error.

	* xdisp.c (add_to_log): Do nothing if called asynchronously.

2001-07-09  Gerd Moellmann  <gerd@gnu.org>

	* sound.c (toplevel): Include <signal.h> and "syssignal.h".
	(vox_configure, vox_close) [SIGIO]: Block/unblock SIGIO
	around ioctls.

2001-07-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* dosfns.c (syms_of_dosfns): Add \n\ at the end of a line in the
	doc string line for dos-timezone-offset.

	* msdos.c (do_visible_bell): Add \n\ at the end of each line of
	inline assembly, to avoid compiler warnings.
	(syms_of_msdos): Add \n\ at the end of a line in the doc string
	line for dos-unsupported-char-glyph.

	* buffer.c (syms_of_buffer) [if 0]: Avoid a warning from GCC 3.0.

2001-07-05  Gerd Moellmann  <gerd@gnu.org>

	* sound.c: Include Emacs' header files with #include "...".

	* eval.c (specbind): Additionally record the buffer that was
	current when a buffer-local or frame-local variable was bound.

2001-07-04  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_produce_glyphs): Don't convert multibyte characters
	to unibyte characters in unibyte buffers.

2001-07-03  Gerd Moellmann  <gerd@gnu.org>

	* eval.c (specbind): If SYMBOL has a frame-local binding, record
	the frame on the binding stack.  Change format of entries for
	local bindings on the binding stack to '(SYMBOL . WHERE)'.
	(unbind_to): Handle unbinding a frame-local variable.

	* xdisp.c (compute_line_metrics): On ttys, subtract continuation
	glyphs and truncation glyphs at the end of a row from its pixel width.
	(dump_glyph_row): Print row's continuation_lines_width.
	(try_window_id): Take the shortcut if ZV is visible in the
	window, but there are actually no changes at ZV.

2001-07-02  Gerd Moellmann  <gerd@gnu.org>

	* xterm.h (x_free_dpy_colors): Add prototype.

	* xterm.c (cvt_pixel_dtor): Call x_free_dpy_colors with the
	right number of arguments.

	* Makefile.in (tags): Depend on $(lwlibdir)/TAGS.
	($(lwlibdir)TAGS): New target.
	(TAGS): Fix dependency list.

	* xterm.c (x_list_fonts): Make sure XFreeFont is called
	with input blocked.

2001-06-30  Gerd Moellmann  <gerd@gnu.org>

	* emacs.c (main): Remove extern declaration for sys_nerr, which
	isn't used and causes a compilation error with GCC 3.0 on
	FreeBSD 4.3.

2001-06-27  Gerd Moellmann  <gerd@gnu.org>

	* widget.c (EmacsFrameSetCharSize): Turn off atimers and block
	SIGIO around the code where Xt might wait for a ConfigureNotifyEvent.
	(toplevel): Include <signal.h> and syssignal.h.

	* sound.c (vox_configure, vox_close): Turn off atimers
	around ioctls.

2001-06-26  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (read_char) <non_reread>: Record the previous idle
	start time before calling timer_stop_idle.
	(read_char) <reread_first>: After processing a help-echo event,
	restore the previous idle start time.

	* xdisp.c (handle_invisible_prop): Deal with overlay strings at
	the start of invisible text.
	(setup_for_ellipsis): New function.
	(next_overlay_string): After all overlay strings have been
	processed, display an ellipsis if necessary.
	(load_overlay_strings, get_overlay_strings): Add parameter CHARPOS.
	(push_it): Initialize display_ellipsis_p on the iterator's stack.

	* dispextern.h (struct iterator_stack_entry): Add member
	display_ellipsis_p.

2001-06-25  Gerd Moellmann  <gerd@gnu.org>

	* widget.c (EmacsFrameSetCharSize): Set XtNwaitForWm depending
	on the value of the wait-for-wm frame parameter.

	* xterm.h (struct x_output): Add member wait_for_wm.

	* xfns.c (Qwait_for_wm): New variable.
	(x_frame_parms): Add entry for `wait-for-wm".
	(x_set_wait_for_wm): New function.
	(Fx_create_frame): Call x_default_parameter for wait-for-wm.
	(syms_of_xfns): Initialize and staticpro Qwait_for_wm.

	* xdisp.c (try_window_id) <all changes below window end>: Don't
	take this shortcut if ZV is visible in the window.
	(try_window_id): When checking for window start being in changed
	text, don't check that the buffer's size has changed.

2001-06-23  Richard M. Stallman  <rms@gnu.org>

	* minibuf.c (Fcompleting_read): Doc fix.

2001-06-19  Gerd Moellmann  <gerd@gnu.org>

	* composite.c (Ffind_composition_internal): Accept ZV
	and a string's end position as POS.

2001-06-18  Gerd Moellmann  <gerd@gnu.org>

	* composite.c (Ffind_composition_internal): Check POS
	for validity.

2001-06-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* editfns.c (Fmessage_box): If the frame is not under a window
	system, output the message in the echo area.

2001-06-14  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (try_window_id): When EOB is visible, don't treat
	insertion at EOB as if it were "off the bottom of the screen."

2001-06-11  Andrew Innes  <andrewi@gnu.org>

	* w32proc.c (create_child): Add new parameter is_gui_app.
	(w32_executable_type): Add new parameter is_gui_app.
	(sys_spawnve): Use it.
	(sys_kill): Fake ^C for SIGINT, and ^Break (if possible) for
	SIGQUIT.  This matches better how the signals are interpreted by
	MSVC compiled programs.
	(syms_of_ntproc): Update docstring.

2001-06-02  Stefan Monnier  <monnier@cs.yale.edu>

	* xterm.c (clear_mouse_face): Reset dpyinfo->mouse_face_overlay as
	well otherwise note_mouse_highlight might optimize away highlighting
	if we pass over that same overlay again.

2001-06-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* lread.c (Fload): Document that the argument is run via
	substitute-in-file-name.

2001-05-31  Gerd Moellmann  <gerd@gnu.org>

	* Makefile.in (bootstrap-doc): New target.
	(bootstrap-emacs): Depend on it.

	* fileio.c (Fdo_auto_save): Don't try to create the directory of
	auto-save-list-file-name when shutting down Emacs, because
	creating the directory might signal an error, and leaves
	Emacs in a strange state.

	* term.c: (tty_cursor_hidden): New variable.
	(update_begin): Don't call tty_hide_cursor.  Clean up.
	(update_end, set_terminal_window, set_scroll_region): Clean up.
	(ring_bell, reset_terminal_modes): Clean up.
	(tty_hide_cursor, tty_show_cursor): Hide/show cursor depending
	on tty_cursor_hidden.
	(write_glyphs): Call tty_hide_cursor.

2001-05-30  Stefan Monnier  <monnier@cs.yale.edu>

	* buffer.c (copy_overlays): Make ENABLE_CHECKING happy.

2001-05-30  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (enum image_value_type): New enumerator
	IMAGE_STRING_OR_NIL_VALUE.
	(parse_image_spec): Handle it.
	(xbm_format, pbm_format): Use it for :foreground and :background.
	(xbm_load, pbm_load): Check for nil color names.

	* xterm.c (note_mouse_highlight): If an overlapping overlay
	exists, but we find that we highlight the same overlay as before,
	don't do the highlighting again.

2001-05-29  Gerd Moellmann  <gerd@gnu.org>

	* xmenu.c (single_submenu, xmenu_show) [!HAVE_MULTILINGUAL_MENU]:
	Protect unibyte strings created by replacing their multibyte
	equivalents in menu_items.

	* keymap.c (Fsingle_key_description): NUL-terminate the string
	buffer before calling build_string.

	* callproc.c (Fcall_process): Deal with decode_coding returning
	CODING_FINISH_INCONSISTENT_EOL.

2001-05-28  Gerd Moellmann  <gerd@gnu.org>

	* xmenu.c (xmenu_show) [!HAVE_MULTILINGUAL_MENU]: Don't overwrite
	an item's name with its key description in case the description
	is a multibyte string.

	* keymap.c (Fsingle_key_description): Create a multibyte string
	only if necessary.

	* macros.c (Fstart_kbd_macro): Doc fix.

	* xterm.c (cursor_in_mouse_face_p): New function.
	(x_draw_stretch_glyph_string): Use it to choose a different GC
	when drawing a cursor within highlighted text.

	* editfns.c (char_property_eq): Put in #if 0.

	* indent.c (string_display_width): Put in #if 0.

	* lread.c (Fload): Remove unused label.

	* termcap.c (speeds): Put in #if 0.

2001-05-18  Gerd Moellmann  <gerd@gnu.org>

	* eval.c (call_debugger): Don't bind inhibit-eval-during-redisplay.

	* xfaces.c (xlfd_point_size): Don't divide pixel size from
	transformation matrix by 10.

2001-05-16  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x_set_foreground_color): Change frame's cursor_pixel
	only if it's equal to the former foreground pixel color.
	(x_set_foreground_color, x_set_background_color)
	(x_set_mouse_color, x_set_cursor_color): Cleaned up.

2001-05-16  Dave Love  <fx@gnu.org>

	* insdel.c (signal_before_change, signal_after_change): Consider a
	local change hook which changes the buffer.

	* process.c (read_process_output): Don't call signal_after_change
	and update_compositions after insert_from_string_before_markers.

2001-05-16  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (split_font_name): Use the right field when
	checking for `[...]' syntax.

	* buffer.c (copy_overlays): New function.
	(clone_per_buffer_values): Use it.

	* buffer.h (OVERLAY_PLIST): New macro.

	* keymap.c (Fsingle_key_description): Replace a build_string with
	a make_multibyte_string.  From Kenichi Handa <handa@etl.go.jp>.

	* fontset.c (Ffontset_info): Check that face is non-null
	before accessing its fields.

2001-05-15  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (read_key_sequence): Prevent generating a fake
	prefix key twice.

	* xfaces.c (split_font_name): Handle `[...]' for the right
	font name fields.

	* ccl.c (ccl_driver): Don't copy remaining bytes in case
	of CCL_STAT_INVALID_CMD.

2001-05-14  Stefan Monnier  <monnier@cs.yale.edu>

	* eval.c (Fdefvar): Only record (defvar <var>) in the load-history
	in <var> has no default value yet.

	* xfaces.c (try_alternative_families): First try the FAMILY.
	And if nothing is found in the end, try again with scalable fonts.
	(try_font_list): Let try_alternative_families do a bit more of
	the work.  Only use FAMILY if it is not nil.
	(syms_of_xfaces) <scalable-fonts-allowed>: Fix docstring.

2001-05-14  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (note_mouse_highlight): Avoid changing the mouse
	pointer shape when show_mouse_face has already done it.

	* xterm.c (x_draw_glyphs): Fix computation of rightmost x for
	full-width rows.

	* xfaces.c (split_font_name): Make sure to leave the loop
	with the right value of `i'.

	* xfaces.c (split_font_name): Handle matrix transformations
	in the pixel and point size fields of XLFD font names.
	(xlfd_point_size): Likewise.

2001-05-12  Eli Zaretskii  <eliz@is.elta.co.il>

	* w32fns.c (w32_to_x_font): Change prototype to fit the declaration.
	(x_to_w32_font): Add prototype.

	* regex.c (malloc, realloc, free) [emacs]: Undefine before
	redefining, to avoid compiler warnings.

	* w32proc.c: Include syssignal.h, to avoid compiler warnings.

	* w32bdf.c (search_file_line, set_bdf_font_info, seek_char)
	(w32_get_bdf_glyph): Cast between unsigned char and char when
	passing arguments to subroutines, to shut up compiler warnings.
	(w32_get_bdf_glyph): Don't mix signed and unsigned when calling
	GET_HEX_VAL.

	* xfaces.c: Include keyboard.h before frame.h, not after it.

	* widget.c: Include keyboard.h before frame.h.

	* w32term.h (struct image, struct face): Forward declaration, to
	avoid compiler warnings.

2001-05-11  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (read_key_sequence): Don't modify events when
	generating fake prefix keys (mode-line, scroll-bar, ...) since
	this prevents proper processing of such events when pushed back
	into unread-command-events.

	* xterm.c (clear_mouse_face): Return 1 if text with mouse face was
	actually redrawn.  Make the function static.
	(note_mouse_highlight): Fix a case where the mouse cursor
	was changed back to the text cursor.

	* xterm.h (clear_mouse_face): Remove prototype.

	* xdisp.c (try_window_id): Fix the fix and set the right
	window_end_vpos.

	* xdisp.c (try_window_id): Fix computation of window end in the
	case that lines were deleted at the end of the window.  Add some
	more debug_method_adds.

	* xfaces.c (try_alternative_families): New function.
	(try_font_list): Use it.  If ATTRS specifies a family, check
	fonts from that family first.
	(choose_face_font): Remove code setting the family part of
	the pattern to nil.

2001-05-10  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (try_window_id): Fix case of all changes before
	the window start.

	* xdisp.c (try_window_id): Add some xasserts.

2001-05-09  Gerd Moellmann  <gerd@gnu.org>

	* lisp.h (GLYPH_CHAR_VALID_P): Use CHAR_VALID_P.

2001-05-09  Dave Love  <fx@gnu.org>

	* xdisp.c (GIVE_UP): Fix for K&R C.

2001-05-09  Gerd Moellmann  <gerd@gnu.org>

	* print.c (syms_of_print) <print-length, print-level>: Doc fix.

	* xterm.c (note_mouse_highlight): Don't change the mouse cursor
	back to the text cursor shape without need.

2001-05-07  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x_set_foreground_color): Set frame's cursor_pixel.

	* dispextern.h (inverse_video): Declare extern.

	* keyboard.c (delete_kboard): Handle the case that selected_frame
	has been deleted in the course of x_connection_closed.

2001-05-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* xterm.c (XTread_socket) <Expose> [!USE_TOOLKIT_SCROLL_BARS]:
	Fix the change from 2001-04-30.

2001-05-03  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (file_dialog_unmap_cb): New function.
	(Fx_file_dialog): Use it as XmNunmapCallback to capture the case
	where a dialog is closed via the window manager.

	* xdisp.c (try_window_id): Cases of changes all in front of
	the window start or all below the window end mostly rewritten.
	(redisplay_window): Move the tests if try_window_id is
	applicable to try_window_id.
	(GIVE_UP): New macro.

2001-05-02  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (expose_window): Return int.  If W is the window
	currently being updated, mark the frame garbaged.
	Fix computation of rows intersecting the exposed rectangle.
	(expose_window_tree): Stop when expose_window returns 0.

	* xterm.c (x_draw_stretch_glyph_string): Don't draw background
	again if it has already been drawn.

2001-05-01  Stefan Monnier  <monnier@cs.yale.edu>

	* syntax.c (update_syntax_table): Check that oldi has the same
	properties as old_prop before deciding not to invalidate.

2001-04-30  Gerd Moellmann  <gerd@gnu.org>

	* undo.c (Fprimitive_undo): In a writable buffer, enable undoing
	read-only text that is so because of text properties.

	* xterm.c (x_window_to_menu_bar) [USE_LUCID]: New function.
	(XTread_socket) <Expose> [USE_LUCID]: Handle events for
	windows that are components of a Lucid menu bar.

2001-04-27  Gerd Moellmann  <gerd@gnu.org>

	* term.c (turn_on_face): Fix reverse video handling on terminals
	that don't support colors.

2001-04-26  Gerd Moellmann  <gerd@gnu.org>

	* editfns.c (save_excursion_restore): Don't use XBUFFER on
	a non-buffer.

2001-04-25  Gerd Moellmann  <gerd@gnu.org>

	* term.c (toggle_highlight): New function.
	(turn_on_face): Change handling of reverse video.

	* process.c (wait_reading_process_input):
	Call record_asynch_buffer_change only if a timer really changed buffers.

	* buffer.c (mouse_face_overlay_overlaps): Fix the computation
	of the number of overlays to check.

	* keyboard.c (command_loop_1): Redo change of 2001-03-12.

	* xdisp.c (try_window_id): Fix a case where window_end_pos
	and window_end_bytepos were not adjusted.

2001-04-23  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (compute_char_face): If buffer is unibyte, set CH to
	zero instead of -1.

2001-04-21  Eli Zaretskii  <eliz@is.elta.co.il>

	* process.c (wait_reading_process_input) [!subprocesses]:
	Don't reference waiting_for_user_input_p, it's not defined in the
	branch without async subprocesses support.

2001-04-19  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (delete_kboard): Prevent a dangling reference
	from current_kboard to KB, which is freed.

	* process.c (wait_reading_process_input):
	Call record_asynch_buffer_change after running timers, to make
	read_key_sequence aware of buffer changes from under it.

2001-04-18  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (Qscalable_fonts_allowed): New variable.
	(realizing_basic_faces_p): Removed.
	(x_face_list_fonts): Special handling for realizing_basic_faces_p
	removed.
	(realize_basic_faces): Specbind Qscalable_fonts_allowed to t.
	(syms_of_xfaces): Initialize Qscalable_fonts_allowed.  Change default
	for scalable-fonts-allowed to t.

	* fileio.c (Finsert_file_contents): If the file size returned from
	stat is zero, set END to READ_BUF_SIZE.  This makes sure we can
	read from files on a procfs whose contents are generated dynamically.

2001-04-18  Eli Zaretskii  <eliz@is.elta.co.il>

	* gmalloc.c (__malloc_size_t) [__GNUC__]: If STDC_HEADERS is not
	defined, include stddef.h and use __SIZE_TYPE__ instead of size_t.
	(__memalign_hook): Make the two prototypes consistent.

2001-04-17  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (redisplay_window): Make sure to clear the desired glyph
	matrix of mini-windows.

2001-04-12  Stefan Monnier  <monnier@cs.yale.edu>

	* intervals.c (find_interval): Don't rebalance during signal handling.

2001-04-11  Gerd Moellmann  <gerd@gnu.org>

	* fns.c: Include blockinput.h.

	* fns.c (Fplist_get): Don't QUIT if interrupt_input_blocked.

2001-04-10  Gerd Moellmann  <gerd@gnu.org>

	* fns.c (Fcompare_strings): Fix return values.

	* window.c (window_scroll): Change the meaning of N to mean
	N screen-fulls or N lines.
	(window_scroll_pixel_based, window_scroll_line_based)
	(scroll_command, Fscroll_other_window): Change accordingly.

	* window.c (window_scroll_pixel_based, Frecenter):
	Call window_box_height instead of using it.last_visible_y for the
	height of the window.

	* xdisp.c (redisplay_window) <recenter>: Call window_box_height
	instead of using it.last_visible_y for the height of the window.

	* w32proc.c (sys_spawnve): Quote more chars for Cygwin.
	From Dan Holmsand <dan@eyebee.com>.

	* w32.c (sys_open): Try to open file without _O_CREAT first, to be
	able to write to hidden and system files.  From Dan Holmsand
	<dan@eyebee.com>.

	* fileio.c (Fcopy_file) [WINDOWSNT]: Use CopyFile.  From Dan
	Holmsand <dan@eyebee.com>.

2001-04-09  Gerd Moellmann  <gerd@gnu.org>

	* fns.c (Fplist_get, Fplist_put): Add QUITs.

	* window.c (window_internal_height): Return 1 less if the
	window has a header line.

	* xdisp.c (try_window_id): When scrolling on a terminal, take
	the change of window_internal_height into account.

2001-04-09  Eli Zaretskii  <eliz@is.elta.co.il>

	* gmalloc.c (align): If the argument SIZE would overflow
	__malloc_ptrdiff_t, fail right away.

2001-04-06  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (compute_tip_xy): Add parameters WIDTH and HEIGHT.
	Make sure the tooltip is completely visible.
	(x_make_gc): Use FRAME_X_SCREEN_NUMBER.

	* xterm.h (FRAME_X_SCREEN_NUMBER): New macro.

	* xmenu.c (xmenu_show): Use FRAME_X_SCREEN_NUMBER.

2001-04-06  Dave Love  <fx@gnu.org>

	* composite.c (update_compositions) <check_mask & CHECK_HEAD>:
	Fix test of `from'.

2001-04-06  Gerd Moellmann  <gerd@gnu.org>

	* composite.h (COMPOSITION_VALID_P): Allow integers as cdrs of PROP.

	* xdisp.c (Qinhibit_eval_during_redisplay): Make it a Lisp_Object.

2001-04-05  Gerd Moellmann  <gerd@gnu.org>

	* sysdep.c (getwd) [!HAVE_GETWD]: Unblock input before returning.

	* editfns.c (Fcurrent_time_zone): Accept spaces in timezone names.

	* xfns.c (Vmotif_version_string) [USE_MOTIF]: New variable.
	(syms_of_xfns): DEFVAR_LISP it.  Initialize from XmVERSION_STRING.

	* xmenu.c (free_frame_menubar) [USE_MOTIF]: Preserve the
	shell widget's position only if it is non-null.

	* xterm.c (x_free_frame_resources) [USE_X_TOOLKIT]:
	Set f->output_data.x->widget to null after destroying it.

	* fns.c (Frequire): Doc fix.  Rename parameter FILE_NAME to
	FILENAME to bring it in synch with the documentation.

	* xfaces.c (realizing_basic_faces_p): Renamed from
	realize_default_face_p.
	(realize_basic_faces): Set/clear realizing_basic_faces_p.
	(realize_default_face): Don't set the flag.

2001-04-04  Gerd Moellmann  <gerd@gnu.org>

	* lisp.h (echoing, echo_message_buffer, cancel_echoing): Declare.

	* keyboard.c (echoing, echo_message_buffer): Make externally visible.

	* xdisp.c (with_echo_area_buffer): Avoid confusion from reusing
	the buffer that was used for echoing.

	* xfaces.c (best_matching_font): Remove unused parameter PATTERN.
	(first_font_matching): Removed unused function.
	(x_face_list_fonts): Remove unused parameter SCALABLE_P.
	(may_use_scalable_font_p): Remove parameter FONT; rename
	parameter NAME to FONT.
	(x_face_list_fonts): Fix missing bounds check.
	(realizing_default_face_p): New variable.
	(realize_default_face): Set and clear that flag.
	(x_face_list_fonts): When called during the realization of the
	default face, and no matching fonts are found when ignoring
	scalable fonts and fonts matching a regexp from
	face-ignored-fonts, try without ignoring fonts.

2001-04-03  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (postprocess_image): New function.
	(lookup_image): Call it for all image types except PostScript.
	(x_kill_gs_process): Call postprocess_image.

	* xterm.c (x_use_underline_position_properties): New variable.
	(x_draw_glyph_string): Use it.
	(syms_of_xterm): DEFVAR_BOOL it.

2001-04-02  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_alloc_nearest_color_1): New function.
	(x_alloc_nearest_color): Use it.
	(x_color_cells): Take a Display as argument, instead of a frame.
	(cvt_string_to_pixel_args, cvt_string_to_pixel_value): New variables.
	(cvt_string_to_pixel, cvt_pixel_dtor): New functions.
	(x_initialize): Register cvt_string_to_pixel as resource converter
	string -> Pixel and cvt_pixel_dtor as pixel resource destructor.

2001-03-30  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (get_overlay_strings): Set iterator's end_charpos.
	(set_iterator_to_next): If a string from a display property ends,
	consider the case that this might also be the end of an
	overlay string having the display property.

	* xdisp.c (handle_display_prop): Fix recognition of subproperty lists.

	* xdisp.c (reseat_to_string): Undo last change.

	* dispnew.c (adjust_glyph_matrix): Don't try to reuse the current
	matrix of a window when the header line changes, when
	new rows are allocated, or when the width changes.

2001-03-30  Eli Zaretskii  <eliz@is.elta.co.il>

	* print.c (Fprin1, Fprin1_to_string, Fprinc, Fprint): Fix last change.

2001-03-29  Eli Zaretskii  <eliz@is.elta.co.il>

	* fileio.c (syms_of_fileio) <directory-sep-char>: Warn that it is
	deprecated.

2001-03-29  Gerd Moellmann  <gerd@gnu.org>

	* data.c (Fsubr_interactive_form): New function.
	(syms_of_data): Defsubr it.

	* alloc.c (live_string_p, live_cons_p, live_symbol_p)
	(live_float_p, live_misc_p): Return 1 only if the offset of the
	pointer in its block is >= 0.

2001-03-28  Paul Eggert <eggert@twinsun.com>

	* editfns.c (Ffloat_time): Fix off-by-factor-of-10 bug in the
	microseconds calcuation.  Avoid double-rounding problem.
	In doc string, warn that the result is approximate.

2001-03-28  Gerd Moellmann  <gerd@gnu.org>

	* eval.c (call_debugger): Bind `inhibit-redisplay' to nil, and
	bind `inhibit-eval-during-redisplay' to t.

	* lisp.h (Qinhibit_eval_during_redisplay): Declare extern.

	* xdisp.c (inhibit_eval_during_redisplay)
	(Qinhibit_eval_during_redisplay): New variables.
	(safe_eval, safe_call): If inhibit_eval_during_redisplay is set,
	don't eval, return nil instead.
	(syms_of_xdisp): DEFVAR_BOOL inhibit-eval-during-redisplay.
	Initialize Qinhibit_eval_during_redisplay.

	* xdisp.c (reseat_to_string): If STRING is multibyte, set
	the iterator's multibyte_p flag.

	* xfaces.c (realize_basic_faces): Decrement menu_face_change_count
	instead of setting it to zero; it's incremented for each frame
	where the menu face is changed.

	* xterm.c (x_draw_relief_rect): Extend left shadow to the bottom;
	change bottom shadow accordingly.

	* xterm.c (expose_window_tree, expose_frame): Don't compute
	intersections here.
	(expose_window): Do it here instead.
	(x_draw_glyph_string): Fix a computation of the underline position.

	* bytecode.c (BYTE_CODE_QUIT): New macro.
	(Fbyte_code): Use BYTE_CODE_QUIT instead of QUIT.

2001-03-27  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (try_window_reusing_current_matrix) <scrolling up>:
	Give up if matrix starts in an ellipsis.
	(init_from_display_pos): Do nothing if POS doesn't specify
	a dpvec_index but the iterator has such a position.

	* xdisp.c (init_from_display_pos): Remove unwarranted assertion.

	* xmenu.c (free_frame_menubar) [USE_MOTIF]: If the shell widget's
	x/y position is (0, 0) after destroying the menu bar, restore
	its original position.

	* xdisp.c (in_ellipses_for_invisible_text_p): New function.
	(init_from_display_pos): Use it.
	(try_window_reusing_current_matrix): Don't use cursor_row_p.

2001-03-26  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (try_window_id): Undo last change.

2001-03-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* print.c (Fprin1, Fprin1_to_string, Fprinc, Fprint): Doc fix.

	* buffer.c (syms_of_buffer): Doc fix.

2001-03-26  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (x_update_menu_appearance): Use local variable
	popup_path for setting font resources.

2001-03-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* frame.c (Fframe_list): Don't reference tip_frame if
	HAVE_WINDOW_SYSTEM is not defined.

	* emacs.c (main): Update the copyright year.  From Werner LEMBERG
	<wl@gnu.org>.

2001-03-25  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (init_from_display_pos): Test invisible property
	with TEXT_PROP_MEANS_INVISIBLE instead of NILP.

	* xdisp.c (redisplay_internal) <update one window>: Make sure
	last_arrow_position and last_arrow_string are set.

	* frame.c (Fframe_list): Don't return a tooltip frame.

2001-03-23  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (mark_window_display_accurate_1): New function,
	extracted from mark_window_display_accurate.
	Compute BUF_UNCHANGED_MODIFIED, BUF_OVERLAY_UNCHANGED_MODIFIED,
	BUF_BEG_UNCHANGED, BUF_END_UNCHANGED.
	(mark_window_display_accurate): Use it.
	(redisplay_internal): Use it for the selected window.
	(redisplay_internal): Avoid duplicate mark_window_display_accurate
	for the selected frame.

	* xdisp.c  Use make_number, for readability.
	(try_window_id): Disable rows below the window end.
	(try_window_reusing_current_matrix): Use cursor_row_p.
	(try_window_reusing_current_matrix) <scrolling up>: Fix disabling
	of rows.
	(init_from_display_pos): If POS specifies a position in a display
	vector, maybe get the iterator set up for that ellipsis.

	* xdisp.c (dump_glyph_row): Fix output for NGLYPHS == 2.

2001-03-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* xmenu.c: Include widget.h only if USE_X_TOOLKIT is defined.

2001-03-23  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (x_update_menu_appearance): Use a different path
	for Lucid popup menus.

2001-03-22  Stefan Monnier  <monnier@cs.yale.edu>

	* xterm.c (note_mouse_highlight): Dec the int, not the Lisp_Object.

	* xdisp.c (init_iterator): Check WINDOWP before using XWINDOW.
	(string_buffer_position): Use `make_number'.

2001-03-22  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (x_update_menu_appearance): Renamed from
	x_set_menu_face_resources.  Use different resources for popups.

	* lisp.h (Vx_resource_name) [HAVE_X_WINDOWS]: Declare extern.
	(GC_CHECK_STRING_BYTES): Don't define.

	* xfaces.c (x_set_menu_resources_from_menu_face) [USE_X_TOOLKIT]:
	Removed, together with subroutines.
	(x_set_menu_face_resources) [USE_X_TOOLKIT]: New function.
	(realize_basic_faces) [USE_X_TOOLKIT]: Call x_set_menu_face_resources.

	* dispextern.h (x_set_menu_resources_from_menu_face):
	Remove prototype.

	* xmenu.c (update_frame_menubar, set_frame_menubar, xmenu_show):
	Remove calls to x_set_menu_resources_from_menu_face.

	* xfaces.c (xm_set_menu_resources_from_menu_face):
	Remove #ifndef LESSTIF_VERSION.

	* xmenu.c: Include widget.h.
	(single_submenu): Return int.  Some cleanup.
	(set_frame_menubar): Call x_set_menu_resources_from_menu_face.

2001-03-21  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_update_window_end): Handle overwritten mouse face
	also for tool bar windows.
	(show_mouse_face): Set the glyph row's mouse_face_p flag also when
	DRAW is DRAW_IMAGE_RAISED.

2001-03-20  Gerd Moellmann  <gerd@gnu.org>

	* print.c (syms_of_print): Doc fixes.

	* fns.c (Fmd5): Doc fix.

2001-03-19  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (XTset_vertical_scroll_bar) [!USE_TOOLKIT_SCROLL_BARS]:
	Clear area of the frame not occupied by the scroll bar.

	* xfns.c (x_create_tip_frame): Add parameter TEXT.  Set the
	tip frame's root window buffer to *tip* right after creating
	the frame.

	* xdisp.c (highlight_trailing_whitespace): Glyphs whose object
	is an integer don't have to be for space characters.

2001-03-16  Gerd Moellmann  <gerd@gnu.org>

	* indent.c (current_column, current_column_1, Fmove_to_column)
	(compute_motion): Handle characters from display vectors differently.

2001-03-15  Kenichi Handa  <handa@etl.go.jp>

	* xterm.c (x_draw_glyph_string): Draw relief (if any) before
	drawing glyph string.

2001-03-15  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (timer_check): Preserve the value of deactivate-mark.
	(command_loop_1): Undo last change.

	* xterm.c (fast_find_position): Return the correct vpos.

	* data.c (store_symval_forwarding): Add parameter BUF.  If BUF is
	non-null, set a per-buffer value in BUF instead of the current buffer.
	(swap_in_global_binding, swap_in_symval_forwarding, Fset_default):
	Call store_symval_forwarding with BUF null.
	(set_internal): Call store_symval_forwarding with the BUF
	parameter passed to set_internal.  Formerly, the value was always
	set in the current buffer; the buffer recorded in specbind for
	this case wasn't used.
	(arith_driver): Reindent.

	* buffer.c (swap_out_buffer_local_variables):
	Call store_symval_forwarding with BUF null.

	* lisp.h (store_symval_forwarding): Change prototype.

	* eval.c (specbind): Call store_symval_forwarding with BUF null.

2001-03-14  Gerd Moellmann  <gerd@gnu.org>

	* frame.c (do_switch_frame): Remove unused parameter NO_EVENT, add
	FOR_DELETION.  Avoid resizing the mini-window of the selected
	frame if FOR_DELETION is set.
	(Fselect_frame, Fhandle_switch_frame, Fdelete_frame)
	(Fmake_frame_invisible): Change calls to do_switch_frame for new
	signature.

	* window.c (Fset_window_configuration): Change call to
	do_switch_frame to new format.

	* keyboard.c (quit_throw_to_read_char): Change call to
	do_switch_frame to new format.

	* lisp.h (do_switch_frame): Change prototype.

	* frame.c (Fframe_parameters): In the `buffer-list' frame
	parameter, store the buffer list of FRAME, not the list of the
	selected frame.

	* xterm.c (x_draw_glyph_string_box): Don't draw a full-width
	box just because the glyph row's full_width_p flag is set.

2001-03-14  Eli Zaretskii  <eliz@is.elta.co.il>

	* xdisp.c (highlight_trailing_whitespace): On character terminals,
	skip the padding blanks inserted in extend_face_to_end_of_line,
	before checking for trailing whitespace.

2001-03-13  Gerd Moellmann  <gerd@gnu.org>

	* xmenu.c (popup_activate_callback, popup_deactivate_callback):
	Remove special handling for LessTif/Motif.
	(toplevel): Don't include Xm/Xm.h.

	* xterm.c (XTread_socket) <LeaveNotify, EnterNotify>:
	Remove workaround code for LessTif; it doesn't work anymore.

	* xterm.c [USE_TOOLKIT_SCROLL_BARS && USE_MOTIF]: Don't include
	Xm/ScrollBarP.h.

	* xterm.c (x_set_toolkit_scroll_bar_thumb) [USE_MOTIF]:
	Don't access private scroll bar data; it's no longer necessary with
	contemporary LessTif.

	* xfaces.c (xm_set_menu_resources_from_menu_face):
	Change #if 0 to #ifndef LESSTIF_VERSION.

	* xmenu.c (xmenu_show) [LESSTIF_VERSION]: Take out the code
	removing button grabs.

2001-03-13  Kenichi Handa  <handa@etl.go.jp>

	* fontset.c (syms_of_fontset): Describe highlight-wrong-size-font
	and clip-large-size-font as obsolete.

	* lread.c (read_multibyte): Check the validity of multibyte
	sequence.  If invalid, return the first byte.

2001-03-12  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (command_loop_1): Set Vdeactivate_mark to nil
	before running the command; timer functions or process
	filters may have set it.

2001-03-12  Eli Zaretskii  <eliz@is.elta.co.il>

	* keyboard.c (syms_of_keyboard) <overriding-terminal-local-map>:
	Doc fix.

2001-03-12  Gerd Moellmann  <gerd@gnu.org>

	* xrdb.c (x_load_resources) [USE_MOTIF]: Remove extraneous arg
	to sprintf.

2001-03-09  Gerd Moellmann  <gerd@gnu.org>

	* dispextern.h (string_buffer_position): Add prototype.

	* xdisp.c (string_buffer_position, display_prop_string_p)
	(single_display_prop_string_p): New functions.

	* xterm.c (note_mouse_highlight): If there's no help-echo on
	a string, look at the buffer text ``under'' it.

	* keyboard.c (make_lispy_event): Add string info to the event,
	analogous to what's done on mode lines.
	(read_key_sequence): For a click on a string, consider `local-map'
	and `keymap' of that string.

	* keyboard.c (make_lispy_event, make_lispy_movement):
	Adjust calls to buffer_posn_from_coords to new format.

	* dispextern.h (buffer_posn_from_coords): Adjust prototype.

	* dispnew.c (buffer_posn_from_coords): Add parameters OBJECT and
	POS; return void.

	* fileio.c (Fwrite_region) [DOS_NT]: Remove O_TRUNC from open
	flags argument to emacs_open; it seems to conflict with O_EXCL.

2001-03-09  Kenichi Handa  <handa@etl.go.jp>

	* composite.h (struct composition): Change types of members;
	glyph_len to unsigned, width to unsigned short.

2001-03-08  Andrew Innes  <andrewi@gnu.org>

	* w32menu.c (add_menu_item): Fix problems with using ownerdraw for
	menu titles.

2001-03-08  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (handle_display_prop): Use it->w->buffer as object,
	instead of nil.

	* xterm.c (note_mouse_highlight): Handle mouse-face and
	help-echo in strings.
	(x_y_to_hpos_vpos): Add parameter BUFFER_ONLY_P.
	(fast_find_string_pos): New function.

	* xdisp.c (handle_face_prop, face_before_or_after_it_pos)
	(display_string): Call face_at_string_position with new parameter.

	* xfaces.c (face_at_string_position): Add parameter MOUSE_P.
	Handle `mouse-face'.

	* dispextern.h (face_at_string_position): Change prototype.

	* dired.c (directory_files_internal): Handle EAGAIN more efficiently.

	* keyboard.c (make_lispy_event): Avoid generating drag events
	if the mouse hasn't actually moved to another buffer position.

2001-03-08  Dave Love  <fx@gnu.org>

	* eval.c (syms_of_eval) <debug-on-error>: Doc fix.

2001-03-08  Gerd Moellmann  <gerd@gnu.org>

	* process.c (Fset_process_window_size): Fix a typo.

2001-03-08  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (detect_coding_sjis): Do more rigid check.
	(detect_coding_big5): Likewise.
	(decode_coding_sjis_big5): Likewise.
	(Fdetect_coding_region): Call detect_coding_system with tailing
	anchor byte `\0' for more rigid detection.
	(detect_coding_mask): Fix the incorrect handling of arg MULTIBYTEP.
	(Fdetect_coding_string): Likewise.

2001-03-07  Stefan Monnier  <monnier@cs.yale.edu>

	* bytecode.c (Fbyte_code) <Btemp_output_buffer_setup>: Check the arg is
	a string before extracting its data.

2001-03-07  Gerd Moellmann  <gerd@gnu.org>

	* window.c (Frecenter): Rewrite code handling negative values
	of ARG on graphical frames.

2001-03-07  Eli Zaretskii  <a34785@is.elta.co.il>

	* window.c (displayed_window_lines): If W->start is outside the
	accessible portion of the buffer, call start_display with BEGV or
	ZV instead of W->start.

2001-03-07  Gerd Moellmann  <gerd@gnu.org>

	* buffer.c (syms_of_buffer) <header-line-format>: Doc fix.

	* process.c (Fset_process_filter): Don't crash if the input
	file descriptor of PROCESS is closed.
	(Fset_process_window_size): Likewise.

2001-03-06  Kenichi Handa  <handa@etl.go.jp>

	* xterm.c (XTflash): Make the timeout of select shorter, and call
	select repeatedly until the desired time expires.

2001-03-06  Gerd Moellmann  <gerd@gnu.org>

	* w32fns.c (Fx_create_frame): Clear Vwindow_list.

	* xfns.c (Fx_create_frame): Clear Vwindow_list.

	* lisp.h (Vwindow_list): Declare extern.

2001-03-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* dispnew.c (syms_of_display) <glyph-table>: Doc fix.

2001-03-06  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (note_mouse_highlight): Call mouse_face_overlay_overlaps
	to detect a case where we have to highlight a different region
	despite not having left the currently highlighted region.
	Set mouse_face_overlay in the x_display_info.
	(x_term_init): Initialize the x_display_info's mouse_face_overlay.

	* xterm.h (struct x_display_info): Add mouse_face_overlay.

	* buffer.c (mouse_face_overlay_overlaps): New function.

	* lisp.h (mouse_face_overlay_overlaps): Add prototype.
	(Qmouse_face): Declare extern.

	* xdisp.c (redisplay_internal): Set windows_or_buffers_changed
	if face_change_count is non-zero.

2001-03-06  Kenichi Handa  <handa@etl.go.jp>

	* ccl.c (ccl_driver) <CCL_ReadMultibyteChar2>: Fix for the case
	that the source is unibyte.

2001-03-05  Dave Love  <fx@gnu.org>

	* xterm.c (XTmouse_position): Fix typo.

2001-03-05  Gerd Moellmann  <gerd@gnu.org>

	* minibuf.c (read_minibuf): Clean up the binding stack if
	called noninteractively.

2001-03-05  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (syms_of_coding): Docstring modified.

2001-03-05  Kenichi Handa  <handa@etl.go.jp>

	* charset.c (char_to_string): If a single byte char has modifier
	bits that can't be reflected to the character code, ignore them
	instead of signaling an error.

2001-03-04  Eli Zaretskii  <eliz@is.elta.co.il>

	* s/msdos.h: Update copyright notice.

	* dosfns.h: Update copyright notice.

	* dosfns.c: Update copyright notice.

	* msdos.c: Update copyright notice.

2001-03-02  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (glyph_rect): New function.
	(XTmouse_position): Use it to raise the threshold for mouse
	movement event generation.

2001-03-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (Fmsdos_remember_default_colors): If default-frame-alist
	specifies (reverse . t), reverse the initial screen colors.
	(IT_set_frame_parameters): If the property is foreground-color,
	but we are reversing the colors, set bg_set, not fg_set.
	Likewise for setting background-color and reversing: set fg_set.
	Set unspecified-fg and unspecified-bg correctly when (reverse . t) is
	in effect.

	* xfaces.c (Finternal_set_lisp_face_attribute)
	[!HAVE_WINDOW_SYSTEM]: Record the new attribute in the frame's
	parameters alist.

2001-03-02  Gerd Moellmann  <gerd@gnu.org>

	* fileio.c (Fexpand_file_name): Collapse sequences of slashes
	to a single slash in the middle of file names.

	* editfns.c (Fcurrent_time_zone) [HAVE_TM_ZONE || HAVE_TZNAME]:
	Accept only alphanumeric time zone names.

	* xterm.c (XTset_vertical_scroll_bar): Don't clear a zero height
	or width area.
	(XTset_vertical_scroll_bar, x_scroll_bar_create): Don't configure
	a widget to zero height.

2001-03-01  Gerd Moellmann  <gerd@gnu.org>

	* window.c (Fwindow_end): Call move_it_past_eol only if
	ending up on a partially visible line.

2001-03-01  Dave Love  <fx@gnu.org>

	* ccl.c (Fccl_execute): Doc fix.

2001-03-01  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (Fx_create_frame): Adjust the frame's height for presence
	of the tool bar before calling x_figure_window_size.

	* xmenu.c (free_frame_menubar): Set the frame's menubar_widget to
	NULL after destroying it, otherwise XTread_socket can access a
	destroyed widget when input is unblocked.

	* xfns.c (x_set_foreground_color): Set the background of the cursor GC.

	* xfns.c (x_set_font): Handle case of x_new_fontset returning the
	same name as before, although there was a change in fontsets.

2001-02-28  Ken Raeburn  <raeburn@gnu.org>

	* lisp.h (Fframe_parameter): Declare.

	* window.c (set_window_buffer): Field vscroll is an int, not a
	Lisp_Object.

2001-02-28  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_set_window_size): Don't use `None' with widgets; use
	NULL instead.

	* xfns.c (Fx_hide_tip): Don't use `None' with widgets; use
	NULL instead.

	* alloc.c (toplevel): Include process.h.
	(enum mem_type): Add MEM_TYPE_PROCESS, MEM_TYPE_HASH_TABLE,
	MEM_TYPE_FRAME, MEM_TYPE_WINDOW enumerators.
	(allocate_vectorlike): Make it a static function.  Add parameter TYPE.
	(allocate_vector, allocate_hash_table, allocate_window)
	(allocate_frame, allocate_process, allocate_other_vector):
	New functions.
	(Fmake_vector): Call allocate_vector instead of allocate_vectorlike.
	(mark_maybe_pointer): New function.
	(mark_memory): Also mark Lisp data to which only pointers
	remain and not Lisp_Objects.
	(min_heap_address, max_heap_address): New variables.
	(mem_find): Return MEM_NIL if START is below min_heap_address or
	above max_heap_address.
	(mem_insert): Compute min_heap_address and max_heap_address.

	* process.c (make_process): Use allocate_process.

	* frame.c (make_frame): Use allocate_frame.

	* window.c (make_window, make_dummy_parent): Use allocate_window.
	(Fcurrent_window_configuration): Use allocate_other_vector.

	* lisp.h (allocate_vectorlike): Remove prototype.
	(allocate_vector, allocate_other_vector, allocate_frame)
	(allocate_window, allocate_process, allocate_hash_table):
	Add prototypes.

	* fns.c (Fdelete, larger_vector): Use allocate_vector.
	(make_hash_table, copy_hash_table): Use allocate_hash_table.

2001-02-27  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (ccl_coding_driver): If ccl->eight_bit_control is zero,
	treat the produced bytes as a valid multibyte sequence.

	* ccl.c (CCL_WRITE_MULTIBYTE_CHAR): New macro.
	(ccl_driver) <CCL_WriteMultibyteChar2>:
	Use CCL_WRITE_MULTIBYTE_CHAR instead of CCL_WRITE_CHAR.
	<ccl_finish>: Set ccl->eight_bit_control properly.

	* ccl.h (struct ccl_program): New member eight_bit_control.

2001-02-26  Stefan Monnier  <monnier@cs.yale.edu>

	* keymap.c (Faccessible_keymaps): Pass `is_metized' to
	accessible_keymaps_char_table.
	(accessible_keymaps_char_table): Obey `is_metized'.
	(where_is_internal, Fwhere_is_internal): Don't confuse int and
	Lisp_Object.

2001-02-26  Gerd Moellmann  <gerd@gnu.org>

	* dispnew.c: Check HAVE_TERM_H before including term.h.

2001-02-24  Andrew Innes  <andrewi@gnu.org>

	* makefile.w32-in: Update copyright notice.

2001-02-24  Stefan Monnier  <monnier@cs.yale.edu>

	* keymap.c (where_is_internal): Accept non-ascii integer prefixes.

2001-02-24  Kenichi Handa  <handa@etl.go.jp>

	* Makefile.in (lisp): Add international/utf-8.elc.

	* fontset.c (Fnew_fontset): Fix handling of the case that an
	element of FONTLIST is a cons of family and registry.

2001-02-23  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fx_create_frame): Don't add FRAME_TOOL_BAR_LINES
	to height unconditionally.

	* w32term.c (x_set_glyph_string_background_width): Extend the
	background face to the end of the drawing area in the text area, only.
	(x_insert_glyphs): Call window_box_left to obtain the left
	x-coordinate of the area to shift.

	* w32menu.c (set_frame_menubar): Run activate-menu-bar-hook with
	safe_run_hooks.

2001-02-22  Andrew Innes  <andrewi@gnu.org>

	* makefile.nt ($(BLD)\dired.obj): Remove reference to VMS header files.
	($(BLD)\dispnew.obj):
	($(BLD)\editfns.obj):
	($(BLD)\fileio.obj):
	($(BLD)\filelock.obj):
	($(BLD)\keyboard.obj):
	($(BLD)\w32proc.obj):
	($(BLD)\process.obj):
	($(BLD)\sysdep.obj): Ditto.

	* makefile.w32-in ($(BLD)/dired.$(O)): Remove reference to VMS
	header files.
	($(BLD)/dispnew.$(O)):
	($(BLD)/editfns.$(O)):
	($(BLD)/fileio.$(O)):
	($(BLD)/filelock.$(O)):
	($(BLD)/keyboard.$(O)):
	($(BLD)/w32proc.$(O)):
	($(BLD)/process.$(O)):
	($(BLD)/sysdep.$(O)): Ditto.

2001-02-22  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (forward_to_next_line_start): When taking the shortcut
	at the start of the function, check that the \n in it->c is
	from the iterator's current position.

	* xdisp.c (handle_single_display_prop): Add parameter
	DISPLAY_REPLACED_BEFORE_P.  If it is non-zero ignore display
	properties which replace the display of text with something else.
	(handle_display_prop): Call handle_single_display_prop with
	additional argument saying if we already replaced text display
	with something else.  Use AREF.
	(with_echo_area_buffer_unwind_data, display_menu_bar)
	(decode_mode_spec_coding): Use AREF and ASIZE.

	* vms-pp.c, vmsdir.h, vmsmap.c, vmsproc.h, vms-pp.trans, vmsfns.c,
	* vmspaths.h, vmstime.c, vms-pwd.h, vmsgmalloc.c, vmsproc.c,
	* vmstime.h: Files removed.

	* unexencap.c, unexfx2800.c: Files removed.

	* dispnew.c (direct_output_for_insert): Give up if we are showing
	a message or just cleared the message because we might need to
	resize the echo area window or display an empty echo area.

2001-02-21  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (redisplay_internal): Do the
	mark_window_display_accurate after all windows have been
	redisplayed because this call resets flags in buffers which are
	needed for proper redisplay.

	* keyboard.c, minibuf.c, lread.c, fns.c, eval.c:
	Use display_hourglass_p, start_hourglass, cancel_hourglass instead of
	the old names.

	* w32term.h (struct x_output): Rename busy_cursor to hourglass_cursor,
	busy_window to hourglass_window, busy_p to hourglass_p.

	* msdos.h (struct x_output): Rename busy_window to
	hourglass_window, busy_p to hourglass_p.

	* xterm.h (struct x_output): Rename busy_cursor to hourglass_cursor,
	busy_window to hourglass_window, busy_p to hourglass_p.

	* xfns.c: Rename everything containing *busy_cursor* and similar
	to *hourglass*.
	(syms_of_w32fns): Rename x-busy-pointer-shape to
	x-hourglass-pointer-shape, display-busy-cursor to
	display-hourglass, busy-cursor-delay to hourglass-delay.

	* w32fns.c: Rename everything containing *busy_cursor* and similar
	to *hourglass*.
	(syms_of_w32fns): Rename x-busy-pointer-shape to
	x-hourglass-pointer-shape, display-busy-cursor to
	display-hourglass, busy-cursor-delay to hourglass-delay.

	* xterm.c (XTread_socket): Test x_output's hourglass_p instead
	of its busy_p flag.

	* dispextern.h (start_hourglass, cancel_hourglass)
	(display_hourglass_p): Renamed from *busy_cursor*.

2001-02-20  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (read_char): When an event from unread-command-events
	is from the tool or menu bar, set *USE_MOUSE_MENU to 1.

	* window.c (Fwindow_end): Handle case that WINDOW's buffer is not
	equal to the current buffer.

	* xdisp.c (setup_echo_area_for_printing): Set truncate_lines to
	nil, otherwise we're left with truncate_lines t when a message
	is printed with message-truncate-lines bound to t.

2001-02-19  Gerd Moellmann  <gerd@gnu.org>

	* window.c (Fmove_to_window_line): Undo last change.
	(displayed_window_lines): Call line_bottom_y to determine
	the line's bottom position.

	* dispextern.h (line_bottom_y): Add prototype.

	* xdisp.c (line_bottom_y): New function extracted from pos_visible_p.
	(pos_visible_p): Use it.

	* keyboard.c (recursive_edit_1): Bind `inhibit-redisplay' and
	set redisplaying_p to 0 here instead of in Frecursive_edit.
	(Frecursive_edit): Don't bind `inhibit-redisplay' and don't
	set redisplaying_p.

	* xdisp.c (Qinhibit_menubar_update, inhibit_menubar_update):
	New variables.
	(syms_of_xdisp): Initialize new variables.
	(update_menu_bar): Do nothing if inhibit_menubar_update is set.
	Specbind `inhibit-menubar-update' when updating the menu bar.

	* xmenu.c (set_frame_menubar): Run activate-menu-bar-hook with
	safe_run_hooks.

	* xdisp.c (update_menu_bar): Run activate-menu-bar-hook with
	safe_run_hooks.

	* emacs.c (malloc_initialize_hook): Handle case thet `environ'
	is null.

	* ralloc.c (__morecore) [!SYSTEM_MALLOC]: Move declaration
	to the start of the file.

2001-02-16  Gerd Moellmann  <gerd@gnu.org>

	* window.c (set_window_buffer): Fix last change.

	* window.c (set_window_buffer): Set window's vscroll to 0.

	* window.c (coordinates_in_window): Increase width of area
	where the vertical line can be dragged.

	* xterm.c (x_set_glyph_string_background_width): Extend the
	background face to the end of the drawing area in the text
	area, only.

	* xdisp.c (handle_single_display_prop): Set iterator's position
	to where the `display' property starts, like for images.
	(dump_glyph): New function.
	(dump_glyph_row): Use it.  Dump info about marginal areas.

	* dispnew.c (direct_output_for_insert): Recognize more cases where
	glyphs can be written instead of being inserted.

	* xterm.c (x_insert_glyphs): Call window_box_left to obtain
	the left x-coordinate of the area to shift.

	* dired.c (directory_files_internal): Set result list to nil
	before retrying.

2001-02-15  Kenichi Handa  <handa@etl.go.jp>

	* ccl.c (ccl_driver) [CCL_ReadMultibyteChar2]: If SRC points an
	invalid multibyte sequence, treat *SRC as a character of
	eight-bit-graphic.

2001-02-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* textprop.c (Fset_text_properties): Doc fix.

2001-02-15  Gerd Moellmann  <gerd@gnu.org>

	* dispnew.c (update_text_area): Undo change of 2001-01-12.

2001-02-14  Dave Love  <fx@gnu.org>

	* coding.c: Doc and message fixes.

2001-02-14  Andrew Innes  <andrewi@gnu.org>

	* w32fns.c (w32_wnd_proc) <WM_GETMINMAXINFO>: Allow resizing the
	Emacs frame above the screen size.

2001-02-14  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (reseat_1): Set iterator's end_charpos to ZV.

2001-02-13  Gerd Moellmann  <gerd@gnu.org>

	* insdel.c (del_range_1, del_range_byte, del_range_both): Handle
	case that TO ends up beyond ZV after running before-change-functions.

	* window.c (window_loop) <GET_BUFFER_WINDOW>: Prefer to return
	the selected window if it is showing the buffer in question.

	* dired.c (directory_files_internal): Initialize errno.
	(toplevel): Include errno.h.

2001-02-13  Kenichi Handa  <handa@etl.go.jp>

	* xfaces.c (best_matching_font): New parameter width_ratio.
	Multiply avgwidth by width_ratio.
	(choose_face_font): Call best_matching_font with width_ratio
	calculated from the column width of C.

2001-02-12  Andrew Innes  <andrewi@gnu.org>

	The following changes are to draw box lines inside characters area
	if line-width is negative.

	* w32term.c (x_produce_image_glyph): Pay attention to the case that
	face->box_line_width is negative.
	(x_produce_stretch_glyph): Likewise.
	(x_produce_glyphs): Likewise.
	(x_estimate_mode_line_height): Likewise.
	(x_draw_glyph_string_background): Likewise.
	(x_draw_glyph_string_foreground): Likewise.
	(x_draw_composite_glyph_string_foreground): Likewise.
	(x_draw_glyph_string_box): Likewise.
	(x_draw_image_foreground): Likewise.
	(x_draw_image_relief): Likewise.
	(x_draw_image_foreground_1): Likewise.
	(x_draw_image_glyph_string): Likewise.

2001-02-09  Kenichi Handa  <handa@etl.go.jp>

	The following changes are to draw box lines inside characters area
	if line-width is negative.

	* xterm.c (x_produce_image_glyph): Pay attention to the case that
	face->box_line_width is negative.
	(x_produce_stretch_glyph): Likewise.
	(x_produce_glyphs): Likewise.
	(x_estimate_mode_line_height): Likewise.
	(x_draw_glyph_string_background): Likewise.
	(x_draw_glyph_string_foreground): Likewise.
	(x_draw_composite_glyph_string_foreground): Likewise.
	(x_draw_glyph_string_box): Likewise.
	(x_draw_image_foreground): Likewise.
	(x_draw_image_relief): Likewise.
	(x_draw_image_foreground_1): Likewise.
	(x_draw_image_glyph_string): Likewise.

	* xfaces.c (Finternal_set_lisp_face_attribute): The value of :box
	and :line-width can be negative.
	(realize_x_face): The value of attrs[LFACE_BOX_INDEX] can be negative.

2001-02-09  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_encode_char): Treat eight bit graphic and control
	characters the same as ASCII and latin-1.
	(x_display_and_set_cursor): Check for the focus	frame's selected
	window instead of selected_window.
	(x_after_update_window_line): Don't clear if frame's internal
	border width is zero.
	(x_new_font): Don't change a tooltip's size.
	(w32_initialize): Set char_ins_del_ok to 1.

	* w32fns.c (Fx_show_tip): Fix calls to make_number.
	(x_set_font): If font hasn't changed, avoid recomputing
	faces and other things.
	(x_set_tool_bar_lines): Do nothing if frame is minibuffer-only,
	(Fx_create_frame): Add the tool bar height to the frame height.
	(x_create_tip_frame): Prevent changing the tooltip's
	background color by specifying a color for the default font
	in .Xdefaults.
	(Qcancel_timer): New variable.
	(syms_of_w32fns): Initialize and staticpro it.
	(Fx_hide_tip, Fx_show_tip): Use it.
	(Fx_show_tip): Make sure to set tip_timer to nil when canceling
	the timer.
	(toplevel): Lisp code for generating parts of syms_of_w32fns removed.

	* w32.c (init_environment): Duplicate local string before putenv.

2001-02-09  ShengHuo ZHU  <zsh@cs.rochester.edu>

	* charset.c (Fstring): A typo.

2001-02-09  Kenichi Handa  <handa@etl.go.jp>

	* charset.c (Fstring): If all arguments are less than 256, return
	a unibyte string.

	* editfns.c (Fchar_to_string): If CHARACTER is less than 256,
	return a unibyte string.

	* coding.c (code_convert_region): After detecting a coding, if
	nothing found, set coding->composing to COMPOSITION_NO.
	(decode_coding_string): Likewise.

2001-02-08  Stefan Monnier  <monnier@cs.yale.edu>

	* w32term.c (w32_set_scroll_bar_thumb): Use `double' for `range'
	to avoid overflow.

2001-02-07  Kenichi Handa  <handa@etl.go.jp>

	* charset.c (parse_str_to_multibyte): New function.

	* charset.h (parse_str_to_multibyte): Extern it.

	* print.c (print_string): If we are going to print a unibyte
	string into a multibyte buffer, convert the string to multibyte by
	str_to_multibyte.

2001-02-06  Andrew Innes  <andrewi@gnu.org>

	* w32xfns.c (select_palette): Do nothing if palette hasn't yet
	been created.  It seems we can get sent window messages such as
	WM_ERASEBKGND before we properly update a frame.

2001-02-06  Gerd Moellmann  <gerd@gnu.org>

	* dispnew.c (update_frame_line): Rename parameter FRAME to F.
	Avoid some unnecessary cursor positioning.

2001-02-05  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (split_font_name): Compute numeric value of XLFD_AVGWIDTH.
	(LFACE_AVGWIDTH): New macro.
	(LFACEP): Use AREF.
	(check_lface_attrs): Check LFACE_AVGWIDTH.
	(lface_fully_specified_p): Don't check LFACE_AVGWIDTH.
	(set_lface_from_font_name): Set LFACE_AVGWIDTH.
	(merge_face_vectors): Check LFACE_AVGWIDTH.
	(Finternal_make_lisp_face): Use AREF.
	(xm_set_menu_resources_from_menu_face)
	(xl_set_menu_resources_from_menu_face): Check LFACE_AVGWIDTH.
	(Finternal_lisp_face_empty_p): Use AREF.
	(lface_same_font_attributes_p): Compare LFACE_AVGWIDTH.
	(better_font_p, exact_face_match_p): Add parameter AVGWIDTH.
	Compare average widths..
	(best_matching_font): Arrange for comparing average widths.

	* dispextern.h (enum lface_attribute_index):
	Add LFACE_AVGWIDTH_INDEX (invisible from Lisp).

2001-02-05  Dave Love  <fx@gnu.org>

	* puresize.h: Revert last change following loadup.el change.

2001-02-05  Andrew Innes  <andrewi@gnu.org>

	* makefile.w32-in ($(EMACS)): Use $(THISDIR) instead of . in
	invocation of temacs, to work with Windows 2000.
	(bootstrap-emacs): Ditto.

2001-02-05  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_display_and_set_cursor): Check for the focus
	frame's selected window instead of selected_window.

	* xdisp.c (try_scrolling): If point is in the line below the
	window, make sure to move the iterator at least a canonical
	char height down.

	* window.c (Fmove_to_window_line): Don't add 1 if window is vscrolled.

2001-02-05  Kenichi Handa  <handa@etl.go.jp>

	* ccl.c (CCL_WRITE_CHAR): Check if CH is valid or not.
	If invalid, execute CCL_INVALID_CMD.
	(ccl_driver): If the CCL program is terminated because of
	CCL_STAT_INVALID_CMD, copy the remaining source data to the
	destination instead of throwing them away.

2001-02-02  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x_set_font): If font hasn't changed, avoid recomputing
	faces and other things.

	* xdisp.c (get_next_display_element): Fix case of empty
	display table entry.

2001-02-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* editfns.c (Fconstrain_to_field): Doc fix.

	* xfaces.c (Fclear_face_cache): Rename the `thorougly' argument
	into `thoroughly', to make it consistent with the doc string.

	* window.c (Fenlarge_window, Fshrink_window): Doc fix.

2001-02-01  Gerd Moellmann  <gerd@gnu.org>

	* search.c (search_buffer): Call set_search_regs with a byte
	position, not a character position.

	* xfns.c (x_set_tool_bar_lines): Do nothing if frame is
	minibuffer-only,

2001-02-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* frame.c (Fmodify_frame_parameters): Doc fix.

2001-01-31  Gerd Moellmann  <gerd@gnu.org>

	* frame.h (EMACS_FRAME_H_INCLUDED): Use an include blocker
	identifier which is not reserved by Standard C.

	* frame.h (FRAME_RIGHT_SCROLL_BAR_WIDTH): New define.

	* window.c (enum window_part): New enumeration.
	(Qleft_fringe, Qright_fringe): Replace Qleft_bitmap_area and
	Qright_bitmap_area.
	(coordinates_in_window): Return an enumerator from enum
	window_part.  Fix handling of right scroll bar.
	(Fcoordinates_in_window_p): Doc fix.  Return `left-fringe' and
	`right-fringe' instead of `left-bitmap-area' and
	`right-bitmap-area'.  Use enumerators from enum window_part
	instead of hard-coded integers.
	(check_window_containing, window_from_coordinates):
	Use enumerators from enum window_part instead of hard-coded integers.
	(syms_of_window): Replace Qleft_bitmap_area and
	Qright_bitmap_area.with Qleft_fringe and Qright_fringe.

2001-01-31  Eli Zaretskii  <eliz@is.elta.co.il>

	* editfns.c (Fformat_time_string): Doc fix.

2001-01-31  Stefan Monnier  <monnier@cs.yale.edu>

	* keymap.c (Fwhere_is_internal): Use the first valid binding
	if no ascii binding is found (when firstonly is t).

2001-01-31  Gerd Moellmann  <gerd@gnu.org>

	* window.c (Fscroll_right, Fscroll_left): Use interactive_p
	instead of Finteractive_p.

	* lisp.h (interactive_p): Add prototype.

	* eval.c (interactive_p): New function.
	(Finteractive_p): Use it.

	* alloc.c (Fmake_list): Add a QUIT in the loop; unroll the loop.

2001-01-31  Dave Love  <fx@gnu.org>

	* .gdbinit (hook-run): Define to run xreload.

	* textprop.c (Fset_text_properties): Fix newline in doc string.

2001-01-30  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (build_desired_tool_bar_string, syms_of_xdisp):
	Use DEFAULT_TOOL_BAR_BUTTON_MARGIN and DEFAULT_TOOL_BAR_BUTTON_RELIEF.

	* dispextern.h (Vtool_bar_button_margin:): Declare extern.
	(DEFAULT_TOOL_BAR_BUTTON_MARGIN, DEFAULT_TOOL_BAR_BUTTON_RELIEF)
	(DEFAULT_TOOL_BAR_IMAGE_HEIGHT): New defines.

	* xfns.c (Fx_create_frame): Add the tool bar height to the frame
	height.

2001-01-30  Dave Love  <fx@gnu.org>

	* bytecode.c (Fbyte_code) <Bgeq>: Add BEFORE_POTENTIAL_GC and
	AFTER_POTENTIAL_GC.

2001-01-29  Gerd Moellmann  <gerd@gnu.org>

	* bytecode.c (Fbyte_code) <Bcurrent_column>:
	Add BEFORE_POTENTIAL_GC and AFTER_POTENTIAL_GC.

2001-01-29  Eli Zaretskii  <eliz@is.elta.co.il>

	* textprop.c (Fset_text_properties): Doc fix.

2001-01-29  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (forward_to_next_line_start): Remove xassert.

2001-01-29  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_draw_row_bitmaps): Delay obtaining HDC to avoid
	returning without releasing it.

2001-01-29  Kenichi Handa  <handa@etl.go.jp>

	* w32fns.c (w32_font_match): Allocate three more bytes to regex
	for '^', '$', and '\0'.

2001-01-28  Andrew Choi  <akochoi@i-cable.com>

	* fontset.c (fontset_pattern_regexp): Allocate three more bytes to
	regex for '^', '$', and '\0'.

	* alloc.c (allocate_string) [macintosh]: Call check_string_bytes
	only if current_sblock has been initialized.

	* frame.c (Fdelete_frame) [macintosh]: Allow deletion of initial
	terminal frame even if it is the only visible frame.

2001-01-28  Kenichi Handa  <handa@etl.go.jp>

	* fontset.c (font_family_registry): Even if FONTNAME conform to
	XLFD, if it specifies other fields than family and registry,
	return FONTANME.  New argument FORCE if nonzero cancel that feature.
	(fontset_font_pattern): Call font_family_registry with FORCE 1 for
	a signle byte character.  Don't set FAMILY part to nil here.
	It is handled by the caller choose_face_font.
	(Fnew_fontset): Call font_family_registry with FORCE 0.
	(Fset_fontset_font): Likewise.

2001-01-27  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (display_line): Don't treat a newline as fitting
	on the line.

2001-01-26  Gerd Moellmann  <gerd@gnu.org>

	* window.c (size_window): Set the window's orig_top to nil when
	changing heights, so that a future shrink_mini_window won't
	restore a bogus height.

	* frame.c (do_switch_frame): If selected frame has a mini-window,
	resize that to exact size.

	* dispnew.c (adjust_glyph_matrix): Always clear desired matrices.

	* xdisp.c (display_line): Simplify check for glyphs fitting
	entirely in the line.

	* xfns.c (xic_style): New variable.
	(create_frame_xic): Move static variable to global scope for
	the case that `static' gets defined away.

2001-01-26  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (decode_coding): Set a flag for inhibiting
	inconsistent eol.
	(code_convert_region): Always set saved_coding_symbol.
	(decode_coding_string): Likewise.  Update coding->symbol when we
	encounter a inconsistent eol by the same way as code_convert_region.

2001-01-25  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x_set_tool_bar_lines): Use x_clear_area instead of
	XClearArea.

	* xterm.c (x_after_update_window_line): Don't clear if frame's
	internal border width is zero.
	(x_clear_area): New function.
	(x_after_update_window_line, x_clear_end_of_line)
	(x_scroll_bar_create, x_scroll_bar_set_handle)
	(XTset_vertical_scroll_bar, x_erase_phys_cursor): Use x_clear_area
	instead of XClearArea.

	* xterm.h (x_clear_area): Add prototype.

	* xfns.c (Fx_file_dialog): Remove a workaround for Lesstif
	which doesn't seem necessary anymore with Lesstif 0.92.

2001-01-25  Dave Love  <fx@gnu.org>

	* puresize.h (BASE_PURESIZE): Up to 720000.

	* keymap.c (Fwhere_is_internal): Declare gcpro3, gcpro4.

2001-01-25  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (echo_area_display): Don't call redisplay_internal
	when Emacs is shutting down.  We can't run hooks etc. that
	would be necessary to do a redisplay.

	* lread.c (read_integer): Use type EMACS_INT instead of int.

2001-01-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* ccl.c (ccl_driver): Fix last change.

2001-01-25  Kenichi Handa  <handa@etl.go.jp>

	* ccl.h (sturct ccl_program): New member suppress_error.

	* ccl.c (ccl_driver): If ccl->suppress_error is nonzero, don't
	insert error message to the output.
	(setup_ccl_program): Initialize ccl->suppress_error to 0.

	* coding.h (struct coding_system): New member suppress_error.

	* coding.c (ccl_coding_driver): Setup ccl->suppress_error.
	(Fset_terminal_coding_system_internal): Set the member
	suppress_error to 1.
	(Fset_safe_terminal_coding_system_internal): Likewise.

2001-01-24  Stefan Monnier  <monnier@cs.yale.edu>

	* regex.c (mutually_exclusive_p): Don't blindly handle `charset_not'
	as if it was a `charset'.

2001-01-24  Gerd Moellmann  <gerd@gnu.org>

	* keymap.c (Fwhere_is_internal): Don't nreverse the cached
	value in where_is_cache; the next lookup in the cache returns
	something bogus if we do.

2001-01-24  Eli Zaretskii  <eliz@is.elta.co.il>

	* xdisp.c (syms_of_xdisp) <Stool_bar_lines_needed>: Don't defsubr
	if HAVE_WINDOW_SYSTEM isn't defined.

2001-01-24  Gerd Moellmann  <gerd@gnu.org>

	* fns.c (sweep_weak_table): Fix code taking items out of
	the hash collision chain.  Some cleanup.

	* xterm.c (x_new_font): Don't change a tooltip's size.

	* xfns.c (x_create_tip_frame): Prevent changing the tooltip's
	background color by specifying a color for the default font
	in .Xdefaults.

2001-01-24  Kenichi Handa  <handa@etl.go.jp>

	* ccl.c (CCL_READ_CHAR): Change the argument name from r to REG as
	a workaround for SunOS 4's cc.
	(CCL_CALL_FOR_MAP_INSTRUCTION): Use "if (1)..." not "do {...".
	(CCL_SUCCESS, CCL_SUSPEND, CCL_INVALID_CMD): Likewise.
	(ccl_driver) <CCL_ReadMultibyteChar2>: Remove unnecessay "do"
	statement.

2001-01-23  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_set_window_size_1): New function extracted from
	x_set_window_size.
	(x_set_window_size): Use it.
	(x_set_window_size) [USE_X_TOOLKIT]: Handle case that window
	doesn't have a widget, like tooltips.

2001-01-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* window.c (syms_of_window) <scroll-preserve-screen-position>: Doc fix.

2001-01-23  Kenichi Handa  <handa@etl.go.jp>

	* fns.c (Fset_char_table_default): Fix to make sub char-table
	correctly.

2001-01-22  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (build_desired_tool_bar_string): Make sure we have
	a desired tool bar string, even if there are no tool bar items.

	* xdisp.c (Ftool_bar_lines_needed): New function.
	(syms_of_xdisp): Defsubr it.

	* editfns.c (Fformat): Don't extend text properties from arguments
	to padding chars in the result.

2001-01-20  Eli Zaretskii  <eliz@is.elta.co.il>

	* s/msdos.h (GC_MARK_STACK): Define to GC_MAKE_GCPROS_NOOPS.

2001-01-20  Andrew Innes  <andrewi@gnu.org>

	* w32term.c (w32_ring_bell): Only support visible bell on w32 frames.
	(w32_initialize): Don't set term hooks that aren't actually needed
	in windowed mode.

	* xfaces.c (realize_default_face):
	(realize_face):
	(realize_tty_face): Remove references to FRAME_W32_CONSOLE_P.

	* xdisp.c (handle_single_display_prop): Remove references to
	FRAME_W32_CONSOLE_P.

	* dispnew.c (Fredraw_frame): Remove reference to FRAME_W32_CONSOLE_P.

	* frame.h (output_method): Remove output_w32_console method.
	(FRAME_W32_CONSOLE_P): Remove macro.

	* frame.c (Qw32_console): Remove variable.
	(Fframep): Remove references to it.
	(syms_of_frame): Ditto.
	(Fframe_parameters): Remove references to FRAME_W32_CONSOLE_P.

	* term.c (FRAME_TERMCAP_P) [WINDOWSNT]: Reinstate original
	redefinition.

2001-01-20  Kenichi Handa  <handa@etl.go.jp>

	* editfns.c (Fformat): Use lisp_string_width instead of strwidth.

2001-01-19  Andrew Innes  <andrewi@gnu.org>

	* w32.c (init_environment): Add a version-independent site-lisp
	directory to EMACSLOADPATH, after the version dependent one.

2001-01-19  Gerd Moellmann  <gerd@gnu.org>

	* editfns.c (Fbuffer_substring): Doc fix.

	* xdisp.c (message_dolog, message2, message2_nolog):
	Rename parameter LEN to NBYTES.

2001-01-19  Kenichi Handa  <handa@etl.go.jp>

	* charset.c (strwidth): Use c_string_width.
	(c_string_width): New function.
	(lisp_string_width): New arguments PRECISION, NCHARS, NBYTES.
	Caller changed.

	* charset.h (c_string_width, lisp_string_width): Extern them.

	* doprnt.c (doprnt1): Get byte length of Lisp string correctly.

	* indent.c (check_composition): Check validity of composition.

	* xdisp.c (store_frame_title): Pay attention to width of non-ASCII
	characters by calling c_string_width.
	(x_consider_frame_title): Get byte length of frame tile string
	correctly.
	(display_mode_element): Pay attention to width of non-ASCII
	characters by calling strwidth.

2001-01-18  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (Qcancel_timer): New variable.
	(syms_of_xfns): Initialize and staticpro it.
	(Fx_hide_tip, Fx_show_tip): Use it.
	(Fx_show_tip): Make sure to set tip_timer to nil when canceling
	the timer.
	(toplevel): Lisp code for generating parts of syms_of_xfns removed.

	* window.c (Fwindow_live_p): Use WINDOW_LIVE_P.

	* window.h (WINDOW_LIVE_P): New macro.

	* window.c (window_size_fixed): New variable.
	(syms_of_window): Add a DEFVAR_BOOL for window-size-fixed, for
	the doc string.

	* eval.c (specbind): If binding a per-buffer variable which
	doesn't have a buffer-local value in the current buffer, change
	the global value by changing the value of the symbol bound in all
	buffers not having their own value, to make it consistent with
	what happens with other buffer-local variables.

	* xterm.c (x_initialize): Set char_ins_del_ok to 1.

	* xdisp.c (forward_to_next_line_start): Stop at end of buffer
	when searching for a newline.

2001-01-18  Kenichi Handa  <handa@etl.go.jp>

	* xdisp.c (display_string): Fix previous change.

2001-01-18  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_produce_stretch_glyph): Only use Qspace when
	GLYPH_DEBUG is defined.
	(x_produce_glyphs): Don't xassert `it->descent > 0'; this isn't
	true for images with `:ascent 100'.
	(x_set_mouse_face_gc): If the last used mouse face has gone in the
	meantime, use face MOUSE_FACE_ID.
	If first glyph isn't a character glyph, use the ASCII NUL
	character to determine the face.
	(expose_area): Do not treat left margin specially.
	(note_mode_line_highlight): If no local_map, check global keymap.
	(note_mouse_highlight): Initialize overlay.
	(clear_mouse_face): Don't return if tip_frame is non-nil.
	(show_scroll_bars): Remove unused function.
	(w32_read_socket) [WM_KILLFOCUS]: Set help_echo to Qnil.
	(x_draw_bar_cursor): Remove extra test for out of bounds cursor.
	Clip to row.
	(x_erase_phys_cursor): Don't apply XWINDOW to variable that may be nil.
	(x_free_frame_resources): Unload relief colors.

2001-01-17  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (forward_to_next_line_start): Avoid calling
	get_next_display_element when the newline is already found.
	This may change the iterator's position, when its current position is
	equal to the iterator's stop_charpos.

	* dispnew.c (direct_output_for_insert): If char_ins_del_ok is
	zero, use this method only at the end of a line.

	* xfaces.c (x_face_list_fonts): Don't BLOCK_INPUT around the
	call to x_list_fonts.  Call x_list_fonts with SIZE -1 only
	if SCALABLE_FONTS_P is set.

	* xfaces.c (x_face_list_fonts): Call x_list_fonts with SIZE -1,
	so that scalable fonts are included.

	* xterm.c (x_list_fonts): Allow scalable fonts if SIZE is < 0,
	In the cache, use a key containing the information if scalable
	fonts are included.
	(x_load_font): Adapt to change of keys in the font cache.

2001-01-17  Kim F. Storm  <storm@filanet.dk>

	* xfaces.c (x_face_list_fonts): Use x_list_fonts instead of
	XListFonts to take advantage of font caching.

	* xterm.c (x_list_fonts): Ensure caching font information when
	called for a null frame, which is the case frequently when Emacs
	starts.

2001-01-17  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (QCconversion): Replaces QCalgorithm.

	* w32fns.c (QCconversion): Replaces QCalgorithm.  Update copyright.

	* xdisp.c (build_desired_tool_bar_string): Use :conversion instead
	of :algorithm.

	* xdisp.c (redisplay_tool_bar): Change tool bar's height when
	not everything could be displayed.

	* line.h, x-list-font.c: Files removed because unused.

2001-01-17  Andrew Innes  <andrewi@gnu.org>

	* dired.c (directory_files_internal): Convert result from readdir
	to a unibyte string initially, to avoid possible misinterpretation
	of some bytes as the internal form of Emacs characters.

2001-01-17  Kenichi Handa  <handa@etl.go.jp>

	* fns.c (concat): Be sure to avoid putting the same `composition'
	property on the adjacent regions.

2001-01-16  Gerd Moellmann  <gerd@gnu.org>

	* window.c (Fset_window_hscroll): Don't set window's min_hscroll here.
	(Fscroll_right, Fscroll_left): Set it here instead, if called
	interactively.

	* buffer.c (Fset_buffer_modified_p): Set buffer's
	prevent_redisplay_optimizations_p flag.

	* dispnew.c, callproc.c, fns.c, keyboard.c, process.c, sunfns.c,
	* sysdep.c, vmsproc.c, xselect.c: Call redisplay_preserve_echo_area
	with additional arg.

	* dispextern.h, lisp.h (redisplay_preserve_echo_area):
	Change prototype.

	* xdisp.c (redisplay_preserve_echo_area): Add parameter
	FROM_WHERE, for debugging.

2001-01-16  Kenichi Handa  <handa@etl.go.jp>

	* ccl.c (Fregister_ccl_program): Handle the return value of
	resolve_symbol_ccl_program correctly.
	(CCL_Extension): Fix typo (originally CCL_Extention).  Caller changed.

2001-01-15  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_set_mouse_face_gc): If the last used mouse face
	has gone in the meantime, use face MOUSE_FACE_ID.

	* xterm.c (x_connection_closed) [USE_X_TOOLKIT]:
	If x_display_info_for_display returns null, don't try to close
	the display; we didn't open it.

	* dispnew.c (save_or_restore_current_matrices): Function removed.
	(save_current_matrix, restore_current_matrix): New functions.
	(adjust_frame_glyphs_for_frame_redisplay): Use them to save and
	restore the frame's current matrix.  Due to the glyph pointer
	setup done in adjust_glyph_matrix, there is no easy way to make
	saving the current matrix in the desired matrix generally correct,
	so don't try it.

2001-01-15  Kenichi Handa  <handa@etl.go.jp>

	* xdisp.c (insert_left_trunc_glyphs): Overwrite padding glyphs by
	truncation glyphs.
	(display_line): Optimize for wide characters.
	(display_string): Don't try to display a multi-column character
	partially.  On ttys, produce more than one truncation glyph for
	multi-column characters that don't fit on the line.

2001-01-13  Kenichi Handa  <handa@etl.go.jp>

	* md5.c (WORDS_BIG_ENDIAN) [__BYTE_ORDER == __BIG_ENDIAN]:
	Define it instead of WORDS_BIGENDIAN.  Caller changed.

2001-01-13  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fimage_size, image_ascent, lookup_image)
	(IMAGE_POSITIVE_INTEGER_VALUE_OR_PAIR, parse_image_spec)
	(xbm_format, xpm_format, pbm_format, png_format, jpeg_format)
	(tiff_format, gif_format, gs_format): Adapt to change of image margins.

	* w32term.c (x_produce_image_glyph, x_draw_image_foreground)
	(x_draw_image_relief, x_draw_image_foreground_1)
	(x_draw_image_glyph_string): Adapt to change of image margins.

	* w32.c (init_environment, sys_shutdown, sys_pipe): Remove unused
	variables.

	* w32bdf.c (search_file_line, get_cached_font_char)
	(cache_char_offset, create_offscreen_bitmap): Remove unused variables.

	* w32inevt.c (w32_console_toggle_lock_key): Add parentheses.

	* w32fns.c (x_to_w32_color, x_set_icon_name, xlfd_strip_height)
	(w32_list_synthesized_fonts, lookup_image, Fx_file_dialog)
	(Fw32_send_sys_command): Remove unused variables.
	(w32_msg_pump): Add parentheses.

	* w32term.c (w32_fill_rect, w32_read_socket, x_bitmap_icon)
	(x_new_fontset, x_calc_absolute_position, x_iconify_frame):
	Add parentheses.

2001-01-12  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (Vtool_bar_button_margin): Replaces tool_bar_button_margin.
	(build_desired_tool_bar_string): Handle Vtool_bar_button_margin
	being a pair of margins.
	(syms_of_xdisp): Change DEFVAR_INT of tool-bar-button-margins
	to DEFVAR_LISP.  Extend doc.

	* xfns.c (Fimage_size, image_ascent): Adapt to the change of image
	margins.
	(lookup_image): If `:margin MARGIN' is specified, and MARGIN is a
	pair of integers `(X . Y)', use X for the horizontal and Y for the
	vertical margin.
	(IMAGE_POSITIVE_INTEGER_VALUE_OR_PAIR): New enumerator.
	(parse_image_spec): Check it.
	(xbm_format, xpm_format, pbm_format, png_format, jpeg_format)
	(tiff_format, gif_format, gs_format):
	Use IMAGE_POSITIVE_INTEGER_VALUE_OR_PAIR for :margin.

	* xterm.c (x_produce_image_glyph, x_draw_image_foreground)
	(x_draw_image_relief, x_draw_image_foreground_1)
	(x_draw_image_glyph_string): Adapt to the change of image margins.

	* dispextern.h (struct image): Replace member `margin' with
	`hmargin' and `vmargin'.

	* xdisp.c (Fdump_tool_bar_row) [GLYPH_DEBUG]: Add parameters ROW
	and GLYPHS.

	* dispnew.c (update_text_area): Put code which decrements the
	stop position when the row's face extends to the end of the
	line in #if 0.

	* xfns.c (x_set_mouse_color): Fix color allocation.

	* keyboard.c: Call get_local_map with new argument list.

	* intervals.c (get_local_map): Change TYPE to Lisp_Object.

	* intervals.h (enum map_property): Removed.
	(get_local_map): Change prototype.

	* keymap.c: Call get_local_map with new argument list.
	(Fwhere_is_internal): Rename parameter XKEYMAP to KEYMAP.

2001-01-11  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (build_desired_tool_bar_string): Correct the computation
	of the size needed for the tool bar string.  For the last image,
	use a `display' property that reaches to the end of the string.

	* xselect.c (selection_request_dpyinfo): New variable.
	(x_handle_selection_request): Set it.
	(x_selection_request_lisp_error): Don't call
	x_decline_selection_request if selection request's display has
	been closed.

	* xfaces.c (x_free_colors, x_free_dpy_colors) [DEBUG_X_COLORS]:
	Do the unregister_colors before calling XFreeColors.

2001-01-10  Dave Love  <fx@gnu.org>

	* Makefile.in (${etc}DOC): Depend on ${shortlisp} and
	${SOME_MACHINE_LISP}, not ${lisp}.

2001-01-10  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (display_line): On ttys, produce more than one truncation
	glyph for multi-column characters that don't fit on the line.

	* xselect.c (x_reply_selection_request): Add a comment.

	* xfns.c (Fx_backspace_delete_keys_p): Use XkbGetMap and
	XkbGetNames instead of XkbGetKeyboard.

2001-01-10  Dave Love  <fx@gnu.org>

	* sysdep.c (random): Revert the declaration.

2001-01-09  Gerd Moellmann  <gerd@gnu.org>

	* lisp.h (STRING_BYTES) [GC_CHECK_STRING_BYTES]:
	Call function string_bytes.
	(GC_CHECK_STRING_BYTES): Moved here from alloc.c.

	* alloc.c (CHECK_STRING_BYTES) [GC_CHECK_STRING_BYTES]: New macro.
	(check_sblock, string_bytes) [GC_CHECK_STRING_BYTES]: New functions.
	(check_string_bytes) [GC_CHECK_STRING_BYTES]: Add parameter ALL_P.
	(allocate_string) [GC_CHECK_STRING_BYTES]: Always check strings in
	the current sblock.
	(mark_object) [GC_CHECK_STRING_BYTES]: Use CHECK_STRING_BYTES.
	(gc_sweep) [GC_CHECK_STRING_BYTES]: Call check_string_bytes
	after sweeping strings, and at the end.
	(GC_CHECK_STRING_BYTES): Moved to lisp.h.

	* alloc.c (Fgarbage_collect): Use a record_unwind_protect to
	ensure that pop_message is called.

	* keyboard.c (Fexecute_extended_command): Use a
	record_unwind_protect to ensure that pop_message is called.

	* lisp.h (push_message_unwind): Add prototype.

	* xdisp.c (push_message_unwind): New function.

	* fileio.c (do_auto_save_unwind): Do the pop_message here
	instead of in Fdo_auto_save.
	(Fdo_auto_save): Don't call pop_message.

2001-01-08  Ken Raeburn  <raeburn@gnu.org>

	* xfns.c (xpm_load) [!ALLOC_XPM_COLORS]: Declare local variable I
	in inner block.

2001-01-08  Gerd Moellmann  <gerd@gnu.org>

	* window.c (window_scroll_pixel_based): Adjust glyph matrices
	when increasing window's vscroll.

	* macros.c (Qkbd_macro_termination_hook): New variable.
	(syms_of_macros): Initialize and staticpro it.
	(pop_kbd_macro): Run kbd-macro-termination-hook.

	* xterm.c (XTread_socket) <LeaveNotify>: Set help_echo to nil.

2001-01-07  Dave Love  <fx@gnu.org>

	* keyboard.c (Fread_key_sequence_vector):  Avoid newline in
	arglist, for documentation's sake.

2001-01-06  Andrew Innes  <andrewi@gnu.org>

	* makefile.w32-in (clean): Delete $(COMPILER_TEMP_FILES) instead
	of *.pdb.

2001-01-05  Andrew Innes  <andrewi@gnu.org>

	* term.c (update_end): Don't check updating_frame; for some reason
	this can be 0 sometimes, such as after dismissing a popup menu,
	and isn't necessary given the explicit frame argument.

2001-01-05  Gerd Moellmann  <gerd@gnu.org>

	* sysdep.c: Don't prototype srandom; it takes an unsigned argument
	 on some systems, and an unsigned long on others, like FreeBSD 4.1.

2001-01-04  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (clear_mouse_face): Don't return if tip_frame is non-nil.

	* xfns.c (x_create_tip_frame): Preserve the value of
	face_change_count around the creation of the tip frame.

	* xfns.c (last_show_tip_args): New variable.
	(compute_tip_xy): New function.
	(Fx_show_tip): Reuse an existing tip frame, if possible.
	(syms_of_xfns): Initialize and staticpro last_show_tip_args.

2001-01-04  Dave Love  <fx@gnu.org>

	* editfns.c (Fformat): Doc fix.

	* systime.h (set_file_times): Prototype.

	* widget.h (EmacsFrameSetCharSize_): Prototype.

	* sysdep.c (random, srandom): Declare explicitly.

	* dispextern.h (move_it_vertically_backward): Declare.

2001-01-04  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (x_create_tip_frame): Call face-set-after-frame-default,
	like in Fx_create_frame.

	* xfaces.c (set_font_frame_param): Don't do anything for
	non-graphical frames.

	* window.c (Fdelete_other_windows): Set window's window_end_valid
	to nil when changing the window's start.  Don't change the
	window's start when its top position hasn't changed.  If we do,
	this will set the window's optional_new_start, which act's like a
	force_start during redisplay with C-x 1 M-> under particular
	circumstances (see report from Per Starback to emacs-pretest-bug
	from 2000-12-13.).

2001-01-03  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (forward_to_next_line_start): Reset it->c if taking the
	short cut at the start of the function.  Add an assertion.
	(reseat_at_next_visible_line_start): Add an assertion.

	* window.c (Frecenter): When changing the window start, set the
	window's window_end_valid to nil.
	(Fwindow_end): Fix window-end computation when UPDATE is non-nil.

	* dispextern.h (move_it_past_eol): Add prototype.

	* xdisp.c (move_it_past_eol): New function.

	* window.c (Fwindow_end): Doc fix.

2001-01-03  Dave Love  <fx@gnu.org>

	* dired.c (Ffile_attributes): Fix last change, removing BSD4_3 kluge.

2001-01-03  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (try_window_reusing_current_matrix): Fix bug setting
	the enabled_p flag of the glyph row at window_end_vpos to 0.
	(handle_single_display_prop): Fix last change.

2001-01-02  Richard M. Stallman  <rms@caffeine.ai.mit.edu>

	* window.c (Frecenter): Doc fix.

2001-01-02  Andrew Innes  <andrewi@gnu.org>

	* term.c (FRAME_TERMCAP_P) [WINDOWSNT]: Remove redefinition.

	* frame.h (output_method): Add output_w32_console method.
	(FRAME_W32_CONSOLE_P): New macro.

	* frame.c (make_terminal_frame) [WINDOWSNT]: Make terminal frames
	use output_w32_console method.
	(Qw32_console): New Lisp_Object.
	(Fframep): Return it.
	(syms_of_frame): Init it.
	(Fframe_parameters): Report w32console as font for w32_console frames.

	* xfaces.c (realize_default_face): Set face foreground and
	background to unspecified for w32_console frames.
	(realize_face): Realize face cache for w32_console frames.
	(realize_tty_face): Accept w32_console frames.

	* xdisp.c (handle_single_display_prop): Return if frame is w32_console.
	(init_iterator) [WINDOWSNT]: Initialize frame face cache if
	necessary, even if running interactively.

	* dispnew.c (Fredraw_frame): Call set_terminal_modes for
	w32_console frames.

	* w32term.c (x_update_begin):
	(x_update_end):
	(x_clear_frame):
	(x_ins_del_lines):
	(x_change_line_highlight):
	(x_delete_glyphs):
	(w32_ring_bell):
	(x_update_begin):
	(x_update_end):
	(w32_reassert_line_highlight):
	(w32_frame_rehighlight):
	(w32_frame_raise_lower): Do nothing if not w32 frame.

	* w32xfns.c (get_frame_dc): Abort if called on a non-w32 frame.

	* w32fns.c (Fx_display_color_cells): Determine correct value, when
	system doesn't tell us directly.
	(Fx_display_visual_class): Implement properly.

2001-01-02  Gerd Moellmann  <gerd@gnu.org>

	* window.c (Frecenter): Handle centering in graphical frames
	specially.  Centering on the basis of line counts doesn't work
	reliably with variable-height lines.

2001-01-02  Eli Zaretskii  <eliz@is.elta.co.il>

	* widget.c (EmacsFrameSetCharSize): Remove unused variables `ac'
	and al[].

	* composite.c (run_composition_function): Remove unused var `val'.
	(update_compositions): Remove unused variable `hook'.

	* intervals.c (get_local_map): Remove unused variable `tem'.

	* doprnt.c (doprnt1): Remove unused variable `size'.

	* fns.c (Flength): Remove unused variable `tail'.
	(Fdelete): Remove unused variable `size'.

	* editfns.c (Ftranspose_regions): Remove unused variables `gcpro1'
	and `gcpro2'.

	* doc.c (Fsnarf_documentation): Remove unused vars `fun' and `tem'.

	* data.c (find_symbol_value): Remove extra 3rd argument in the
	call to swap_in_symval_forwarding.

	* undo.c (Fprimitive_undo): Remove unused block-scope variable `end'.

	* search.c (shrink_regexp_cache): Remove unused variable `cpp'.
	(trivial_regexp_p): Remove unused variable `c'.
	(boyer_moore): Remove unused variable `k'.

	* indent.c (current_column): Remove unused variable `stopchar'.
	(Fcompute_motion): Remove unused variable `contin'.

	* casefiddle.c (casify_object): Remove unused variable `tolen'.

	* dired.c (directory_files_internal): Fix a typo in a comment.
	Remove an unused variable `handler'.
	(file_name_completion): Remove unused function-scope variable `dp'.
	(Ffile_attributes) <dirname, sdir>: Make declarations conditioned
	on BSD4_2.

	* fileio.c (e_write): Remove unused variable `require_encoding_p'.

	* marker.c (Fmarker_position): Remove unused variables `pos', `i',
	and `buf'.
	(Fmarker_insertion_type): Remove unused variable `buf'.

	* insdel.c (make_gap): Remove unused variable `result'.

	* keyboard.c (record_char): Remove unused function-scope var `help'.
	(kbd_buffer_get_event): Remove unused block-scope variable `idx'.
	(menu_bar_items): Remove unused function-scope variable `tem'.

	* fontset.c (fontset_ref): Remove unused variable `i'.
	(fontset_set): Remove unused variables `j' and `tmp'.
	(make_fontset): Remove unused variables `i', `j', `elt' and `base_elt'.
	(make_fontset_for_ascii_face): Remove unused variable `name'.
	(fs_load_font): Remove unused variable `font_idx'.
	(fs_query_fontset): Remove unused function-local variable `fontset'.
	(list_fontsets): Remove unused variable `tail'.
	(Fnew_fontset): Remove unused variables `family' and `registry'.
	(accumulate_font_info): Remove unused variable `tmp'.
	(Ffontset_font): Remove unused variable `id'.
	(syms_of_fontset): Remove unused variable `i'.

	* xfns.c (x_display_info_for_name): Cast 0 to "char *" in the call
	to x_term_init.
	(lookup_image): Remove unused variable `file'.
	(xbm_load): Remove unused variables `bitmap_data', `height', and
	`width'.  Remove function-local variable `i', leave the
	block-local one.
	(gif_load): Remove unused variable `inc'.

	* xterm.c (XTread_socket): Remove unused variables `p' and `pend'.
	(XTread_socket) <LeaveNotify>: Remove unused variable `frame',
	leave only the one in the inner block.

	* xfaces.c (face_fontset, realize_default_face): Remove unused
	variable `fontset'.
	(face_at_buffer_position): Remove unused variable `multibyte_p'.

	* term.c (encode_terminal_code): Remove unused variable `c'.

	* ccl.c (Fccl_execute): Cast ccl_driver parameters to `unsigned
	char *' instead of `char *'.

	* category.c (Fcategory_docstring): Remove unused variable `doc'.
	(Fget_unused_category): Remove unused variable `docstring_vector'.
	(Fchar_category_set): Remove unused variables `val', `charset',
	`c1' and `c2'.

	* coding.c (detect_coding_iso2022, setup_coding_system):
	Remove unused variable `i'.
	(detect_coding_mask): Remove unused variable `idx'.
	(detect_coding): Remove unused variable `i'.
	(ccl_coding_driver): Remove unused variable `result'.
	(run_pre_post_conversion_on_str): Remove unused variable `prev'.
	(decode_coding_string): Remove unused variables `to' and `gcpro1'.
	(encode_coding_string): Remove unused variables `gcpro1' and
	`saved_coding_symbol'.
	(Ffind_coding_systems_region_internal): Remove function-local
	variable args[], leave only the block-local one.
	(code_convert_region1): Remove unused variable `len'.

	* charset.c (char_printable_p): Remove unused variable `chars'.
	(Fsplit_char, Fchar_bytes): Remove unused variable `val'.
	(str_to_multibyte): Remove unused variable `c'.

	* window.c (size_window): Remove block-local variable `min_size'.

	* xdisp.c (make_cursor_line_fully_visible): Remove unused variable
	`header_line_height'.
	(append_space, extend_face_to_end_of_line): Declare `saved_what'
	enum display_element_type.

2001-01-02  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_connection_closed): Catch X errors around all
	statements that call X.  Save away the error message in a local copy.

	* xterm.c (x_connection_closed): Set handling_signal to 0 at
	the start.

	* xdisp.c (pos_visible_p): Take into account that CHARPOS maybe
	in or at the start of invisible text.

	* dispnew.c (update_window): Don't check_current_matrix_flags.

2001-01-01  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (x_figure_window_size): Do not allow new_height and
	new_width of frame to override specified values.

2000-12-30  Kenichi Handa  <handa@etl.go.jp>

	* composite.c (find_composition): Fix a code for searching backward.

2000-12-29  Gerd Moellmann  <gerd@gnu.org>

	* dispnew.c (check_current_matrix_flags) [GLYPH_DEBUG]: New function.
	(update_window) [GLYPH_DEBUG]: Call it.
	(scrolling_window): Prevent including current rows which are below
	what's displayed in the window.

	* xdisp.c (try_window_reusing_current_matrix)
	<new start <= old start>:  Disable rows in the current matrix
	which are below the window after scrolling.

	* xdisp.c (move_it_by_lines): Don't do optimizations if NEED_Y_P
	is zero.  It's not worth the complexity.
	(invisible_text_between_p): Put in #if 0 because unused.

2000-12-28  Gerd Moellmann  <gerd@gnu.org>

	* xfns.c (Fx_backspace_delete_keys_p): Check library and server
	XKB versions.  Call XkbFreeKeyboard with 2nd arg 0.

	* keyboard.c (echo_char): If C is an integer, always call
	push_key_description.  Former code could signal an invalid
	character error.

	* keymap.c (push_key_description): Add parameter FORCE_MULTIBYTE.
	If set, print multibyte text.
	(Fsingle_key_description): Call push_key_description with
	FORCE_MULTIBYTE set.
	(describe_buffer_bindings): Likewise.

	* lisp.h (push_key_description): Add prototype.

	* xdisp.c (echo_area_display): Bind redisplay-dont-pause to t
	around the call to redisplay_internal.

	* xfns.c: Use #if GLYPH_DEBUG instead of #ifdef GLYPH_DEBUG.

	* dispnew.c: Use #if GLYPH_DEBUG instead of #ifdef GLYPH_DEBUG.

2000-12-28  Kenichi Handa  <handa@etl.go.jp>

	* ccl.c (CCL_WRITE_CHAR): Check variable `extra_bytes'.
	(ccl_driver): New local variable `extra_bytes'.

	* ccl.h (struct ccl_spec): New member eight_bit_carryover.

	* coding.c (setup_coding_system):
	Initialize coding->spec.ccl.eight_bit_carryover.
	(ccl_coding_driver): Pay attention to carried over 8-bit bytes.

2000-12-28  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (SAFE_ONE_MORE_BYTE): New macro.
	(DECODE_EMACS_MULE_COMPOSITION_CHAR): New macro.
	(DECODE_EMACS_MULE_COMPOSITION_RULE): New macro.
	(decode_composition_emacs_mule): New function.
	(decode_coding_emacs_mule): Decode composition sequence by calling
	decode_composition_emacs_mule.
	(ENCODE_COMPOSITION_EMACS_MULE): New macro.
	(encode_coding_emacs_mule): Changed from macro to function.
	If a text contains compositions, encode them correctly.
	(setup_coding_system): Set coding->commong_flags for emacs-mule so
	that decoding and encoding are required.

2000-12-27  Gerd Moellmann  <gerd@gnu.org>

	* xfaces.c (PT_PER_INCH): New macro.
	(xlfd_point_size): Compute real point size from font's pixel size.
	(pixel_point_size, build_scalable_font_name): Use PT_PER_INCH
	instead of 72.

	* .gdbinit: Comment out the line pointing to the Lesstif source
	directory.

	* window.c (Frecenter): Use displayed_window_lines instead
	of window_internal_height.

	* xterm.c (syms_of_xterm): DEFVAR_LISP x-toolkit-scroll-bars
	instead of x-toolkit-scroll-bars-p.
	(Vx_toolkit_scroll_bars): Renamed from x_toolkit_scroll_bars_p.

	* w32term.c (syms_of_xterm): DEFVAR_LISP x-toolkit-scroll-bars
	instead of x-toolkit-scroll-bars-p.
	(Vx_toolkit_scroll_bars): Renamed from x_toolkit_scroll_bars_p.

	* dispnew.c (struct redisplay_history) [GLYPH_DEBUG]: New.
	(REDISPLAY_HISTORY_SIZE) [GLYPH_DEBUG]: New macro.
	(redisplay_history, history_idx, history_tick) [GLYPH_DEBUG]:
	New variables.
	(add_window_display_history, add_frame_display_history)
	(Fdump_redisplay_history) [GLYPH_DEBUG]: New functions.
	(build_frame_matrix_from_leaf_window): Remove unused code.
	(build_frame_matrix_from_leaf_window) [GLYPH_DEBUG]: Add to
	redisplay history.
	(update_frame) [GLYPH_DEBUG]: Add to redisplay history.
	(update_window) [GLYPH_DEBUG]: Likewise.
	(syms_of_display): Defsubr dump-redisplay-history.

2000-12-23  Gerd Moellmann  <gerd@gnu.org>

	* keyboard.c (echo_prompt): Always set current_kboard->echoptr to
	the end of the prompt.  Set echo_after_prompt to the offset
	of echoptr in echobuf.

	* xdisp.c (init_from_display_pos): Pop until the iterator's
	stack is empty; there may be frames for stretch or images
	on the stack.

	* dispnew.c (save_frame_matrix, restore_frame_matrix): Removed.
	(save_or_restore_current_matrix): New function for the same
	purpose, but more efficient.
	(adjust_frame_glyphs_for_frame_redisplay): Use it.

2000-12-23  Eli Zaretskii  <eliz@is.elta.co.il>

	* xdisp.c (syms_of_xdisp): Fix last change.

2000-12-23  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (syms_of_xdisp): Doc fix.

	* xdisp.c (redisplay_window): Remove label restore_buffers;
	use finish_scroll_bars instead to make sure that scroll bars
	are redeemed.  If we don't do this, flickering can result from
	scroll bars being destroyed and recreated.

2000-12-22  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_draw_bitmap): Fix drawing so it does not appear
	in the wrong colors when the foreground is not black.
	(expose_window): Don't redraw the window that's currently being
	updated.

2000-12-22  Gerd Moellmann  <gerd@gnu.org>

	* window.c (size_window): When setting the window's too_small_ok
	flag, compare old size with minimum size depending on WIDTH_P,
	don't compare with window_min_width.

	* window.c (delete_window): Simplify somewhat.
	(Fset_window_configuration): Don't SET_FRAME_GARBAGED after
	freeing window matrices.  The flag windows_or_buffers_changed is
	set, so the next redisplay will consider all windows; this should
	suffice.

2000-12-22  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (ccl_coding_driver): Initialize ccl->cr_consumed.

	* ccl.h (struct ccl_program): New member cr_consumed.

	* ccl.c (CCL_WRITE_CHAR): Don't handle EOL conversion here.
	(CCL_READ_CHAR): Handle EOL conversion here.
	(ccl_driver) <CCL_ReadMultibyteChar2>: Likewise.

2000-12-21  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (Fdump_glyph_row) [GLYPH_DEBUG]: Add optional arg GLYPHS.

	* dispextern.h (GLYPH_EQUAL_P): Also compare pixel widths,
	otherwise tabs of different size compare equal.

	* callint.c (Fcall_interactively): Prevent a compiler warning.

	* print.c (print_unwind): Return nil.
	(PRINTDECLARE): Initialize all local variables.
	(print_preprocess): Add a default case.

	* lisp.h (Qinhibit_point_motion_hooks): Declare extern.

	* undo.c (Fprimitive_undo): Bind `inhibit-point-motion-hooks' to t.

	* window.c (delete_window, Fsplit_window)
	(Fset_window_configuration): Calls to ensure_frame_matrix removed.

	* dispextern.h (ensure_frame_matrix): Function declaration removed.

	* dispnew.c (ensure_frame_matrix): Removed.
	(save_frame_matrix, restore_frame_matrix): New functions.
	(adjust_frame_glyphs_for_frame_redisplay): Use them.

	* xdisp.c (dump_glyph_row, dump_glyph_matrix, Fdump_glyph_matrix)
	[GLYPH_DEBUG]: Extended to dump glyphs in short form.

2000-12-21  Andrew Innes  <andrewi@gnu.org>

	* w32term.c (x_update_begin): Regenerate the palette here, rather
	than for each window.

	* w32xfns.c (select_palette): Avoid calling SelectPalette if
	palette is NULL, since this corrupts memory!  Also get
	display_info reference from frame.

2000-12-21  Jason Rumney  <jasonr@gnu.org>

	* w32bdf.c (w32_init_bdf_font): Fix test for valid bmp heap.

	* w32term.c (x_draw_hollow_cursor): Delay obtaining the frame's DC
	to avoid returning without releasing it.

2000-12-21  Kenichi Handa  <handa@etl.go.jp>

	* keymap.c (push_key_description): Don't convert eight-bit-control
	and eight-bit-graphic to multibyte character.

	* charset.c (Fmake_char_internal): If CHARSET doesn't have a
	generic character and CODE1 is nil, return the smallest character
	in CHARSET.

2000-12-20  Dave Love  <fx@gnu.org>

	* s/osf5-0.h (NSIG): Don't redefine.

2000-12-20  Stefan Monnier  <monnier@cs.yale.edu>

	* keymap.c (where_is_internal): Check ascii_sequence_p rather than
	excluding menu-bar and tool-bar.
	(Fwhere_is_internal): Check ascii_sequence_p when looking up the cache.
	(menu_item_p): Remove.
	(where_is_internal_1): Don't ignore menu-items.

2000-12-20  Gerd Moellmann  <gerd@gnu.org>

	* xdisp.c (hscroll_window_tree): Take window's min_hscroll
	into account.

	* window.c (make_window): Initialize window's min_hscroll.
	(Fset_window_hscroll): Set window's hscroll and min_hscroll.
	(set_window_buffer, temp_output_buffer_show): Set min_hscroll
	to zero.
	(struct saved_window): New member min_hscroll.
	(SAVED_WINDOW_VECTOR_SIZE): Set to 17.
	(Fset_window_configuration): Set window's min_hscroll.
	(save_window_save): Save window's min_hscroll.
	(compare_window_configurations): Compare min_hscroll values.

	* window.h (struct window): New member min_hscroll.

	* keyboard.c (echo_prompt): Prevent a compiler warning.

	* xdisp.c (try_cursor_movement): Fix last change.  The real
	condition is that PT is at the end of the row, and should
	be displayed at the start of the next row.

	* xdisp.c (try_cursor_movement): If we end on a partially
	visible line, end we already decided to scroll, return -1.

	* dispextern.h (ensure_frame_matrix): Add prototype.

	* window.c (delete_window, Fsplit_window)
	(Fset_window_configuration): Call ensure_frame_matrix.

	* dispnew.c (fake_current_matrices, ensure_frame_matrix):
	New functions.
	(adjust_frame_glyphs_for_frame_redisplay): If display has been
	completed, call fake_current_matrices instead of marking frame
	garbaged.

2000-12-20  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (syms_of_w32fns): Initialize and staticpro tip_frame.

2000-12-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* fns.c (Frequire): Doc fix.

2000-12-19  Gerd Moellmann  <gerd@gnu.org>

	* window.c (window_scroll_pixel_based): Don't use move_it_vertically.

	* dispnew.c (direct_output_for_insert): Fix check for mini-window
	currently displaying a message.

	* bytecode.c (toplevel) [CHECK_FRAME_FONT]: Include frame.h and
	xterm.h.
	(Fbyte_code) [CHECK_FRAME_FONT]: Check the selected frame's font.

2000-12-18  Andrew Innes  <andrewi@gnu.org>

	* w32.c (w32_strerror): New function.

	* w32.h (w32_strerror): New extern.

	* w32fns.c (Fw32_shell_execute): Use it.

2000-12-18  Gerd Moellmann  <gerd@gnu.org>

	* s/hpux10.h (_FILE_OFFSET_BITS): Undef again.

2000-12-18  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (IT_set_face): Obey inverse_video.

2000-12-18  Kenichi Handa  <handa@etl.go.jp>

	* dired.c (directory_files_internal): Always return decoded filenames.

2000-12-18  Gerd Moellmann  <gerd@gnu.org>

	* xterm.c (x_connection_closed): Prevent being called recursively
	because of an error condition in XtCloseDisplay.

	* xdisp.c (init_iterator): If noninteractive, and the frame's
	face cache is null, make one.

	* xfns.c (show_busy_cursor): Check for live frames more thoroughly.

	* process.c (wait_reading_process_input): Check for pending
	input when running timers.

2000-12-18  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (IT_write_glyphs): Compute the glyph face from str->face_id.

2000-12-18  Kenichi Handa  <handa@etl.go.jp>

	* process.c (read_process_output): Don't run a filter if the code
	decoder produces nothing but carryover.

2000-12-17  Andrew Innes  <andrewi@gnu.org>

	* w32.c (sys_rename): Only check errno against EEXIST, and not
	EACCES, when determining whether rename failed because the target
	exists.  This was resulting in indefinite looping on Windows 9x if
	the source file was locked by another process.

	* w32fns.c (Ffile_system_info): New function.
	(syms_of_w32fns): Defsubr it.

2000-12-17  Gerd Moellmann  <gerd@gnu.org>

	* window.c (coordinates_in_window): Fix computation for
	position on vertical line between mode lines.

	* xfns.c (unwind_create_frame): Return t if frame was deleted.
	Don't alter tip_frame or tip_window.
	(unwind_create_tip_frame): Set tip_frame to nil only if frame
	was deleted.

	* w32fns.c (unwind_create_frame): Return t if frame was deleted.
	Don't alter tip_frame or tip_window.
	(unwind_create_tip_frame): Set tip_frame to nil only if frame
	was deleted.

2000-12-16  Eli Zaretskii  <eliz@is.elta.co.il>

	* fileio.c (Fcopy_file): Rename the last argument to keep_time, to
	be consistent with the doc string.  Reported by NAKAJIMA Mikio
	<minakaji@osaka.email.ne.jp>.

2000-12-16  Kenichi Handa  <handa@etl.go.jp>

	* xfaces.c (Vface_ignored_fonts): New variable.
	(x_face_list_fonts): Ignore fonts matching Vface_ignored_fonts.
	(syms_of_xfaces): Declare Vface_ignored_fonts as a Lisp variable.

2000-12-15  Gerd Moellmann  <gerd@gnu.org>

	* dispnew.c (update_window): Detect pending input every nth line
	updated, i.e. do it depending on real work done, and not on the
	vpos of the line.

	* xterm.c (expose_window): Don't redraw the window that's
	currently being updated.

	* window.c (Fset_window_point): Remove test for
	cursor_in_non_selected_windows.

	* lread.c (read1): Recognize end of file after `\\'.

	* xfns.c (x_create_tip_frame): Use unwind_create_tip_frame,
	not unwind_create_frame.

2000-12-15  Dave Love  <fx@gnu.org>

	* s/usg5-4.h (bcopy) [IRIX6]: Don't special-case definition of
	bcopy & al.

	* s/irix6-5.h: #undef bcopy & al here.  Include strings.h.

2000-12-15  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (setup_coding_system): Clear all members of the struct
	coding_system at first.
	(detect_coding): Call detect_coding_mask with a correct MULTIBYTEP
	argument.
	(code_convert_region): Don't override coding->src_multibyte and
